2017-09-11  Eli Zaretskii  <eliz@gnu.org>

	* etc/NEWS: Document the vulnerability and its resolution.
	Include a workaround.  Suggested by Charles A. Roelli
	<charles@aurox.ch>.

	* lisp/gnus/mm-view.el (mm-inline-text): Disable decoding of
	"enriched" and "richtext" MIME objects.  Suggested by Lars
	Ingebrigtsen <larsi@gnus.org>.

	* lisp/textmodes/enriched.el (enriched-decode-display-prop):
	Don't produce 'display' properties.  (Bug#28350)


2017-04-20  Nicolas Petton  <nicolas@petton.fr>

	* Version 25.2 released.

2017-04-18  Eli Zaretskii  <eliz@gnu.org>

	Fix a typo in indexing the user manual

	* doc/emacs/cmdargs.texi (General Variables): Fix a horrible typo.

2017-04-12  Eli Zaretskii  <eliz@gnu.org>

	* lisp/menu-bar.el (kill-this-buffer): Doc fix.  (Bug#26466)

2017-04-11  Eli Zaretskii  <eliz@gnu.org>

	Document 'line-pixel-height'

	* doc/lispref/display.texi (Size of Displayed Text): Document
	line-pixel-height.  Suggested by Tak Kunihiro
	<tkk@misasa.okayama-u.ac.jp>.  (Bug#26379)

2017-04-07  Hong Xu  <hong@topbug.net>

	* src/search.c (Fre_search_forward, Fre_search_backward): Improve doc (Bug#25193).

2017-04-07  Noam Postavsky  <npostavs@gmail.com>

	Mention that processes start in default-directory (Bug#18515)

	* doc/lispref/processes.texi (Synchronous Processes):
	(Asynchronous Processes):
	* lisp/subr.el (start-process):
	* src/callproc.c (call-process): Mention that the subprocess starts in
	`default-directory' when local, suggest `start-file-process' and
	`process-file' otherwise.

2017-04-07  Noam Postavsky  <npostavs@gmail.com>

	* src/xdisp.c (vmessage, message): Clarify commentary.

2017-04-02  Glenn Morris  <rgm@gnu.org>

	Belated fixes for admin.el's M-x make-manuals-dist

	* admin/admin.el (make-manuals-dist-output-variables): Additions.
	(make-manuals-dist--1): Also copy docstyle.texi.

2017-03-31  Tino Calancha  <tino.calancha@gmail.com>

	default-directory: Remark that it must be a directory name

	* src/buffer.c (default-directory): Update docstring (Bug#26272).

2017-03-31  Tino Calancha  <tino.calancha@gmail.com>

	Delete confuse statement in manual

	* doc/misc/cl.texi (For Clauses): Delete confuse statement
	and its example (Bug#23550).

2017-03-31  Noam Postavsky  <npostavs@gmail.com>

	Improve packaging documentation

	* doc/lispref/package.texi (Packaging Basics):
	* doc/lispref/tips.texi (Library Headers): Clarify some header
	formats, relation between file headers and package
	attributes (Bug#13281).

2017-03-27  Eric Abrahamsen  <eric@ericabrahamsen.net>

	Expand manual section on quitting windows

	* doc/lispref/windows.texi (Quitting Windows): Provide more
	  information about the elements of the quit-restore window parameter,
	  and how they affect the behavior of quit-restore-window.

2017-03-26  Noam Postavsky  <npostavs@gmail.com>

	Fix docstring of dabbrev-abbrev-char-regexp

	* lisp/dabbrev.el (dabbrev-abbrev-char-regexp): Using a value of nil
	is equivalent to "\\sw\\|\\s_", and has no special behavior.  If the
	previous character doesn't match, we search backwards for one that
	does, not throw an error.  Replace Lisp example with C based one to
	make it clear that "symbol" means a sequence of word and symbol
	constituent characters, not a Lisp symbol (Bug#358).

2017-03-26  Johan Claesson  <johanclaesson@bredband.net>  (tiny change)

	* doc/misc/cl.texi (Iteration Clauses): Clarify example (Bug#19515).

2017-03-25  Eli Zaretskii  <eliz@gnu.org>

	;* doc/misc/info.texi (Choose menu subtopic): Improve indexing.  (Bug#26236)

2017-03-21  Noam Postavsky  <npostavs@gmail.com>

	Narrow scope of modification hook renabling in org-src fontification

	Modification hooks should be enabled while modifying text in the
	org-src temp buffer, but in 2017-01-29 "Call modification hooks in
	org-src fontify buffers" the hooks were enabled also for modifications
	to the original org buffer.  This causes fontification errors when
	combined with certain packages, as reported in
	https://lists.gnu.org/r/emacs-orgmode/2017-03/msg00420.html.

	* lisp/org/org-src.el (org-src-font-lock-fontify-block): Reduce scope
	of inhibit-modification-hooks let-binding.

2017-03-17  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of interactive "r".

	* doc/lispref/commands.texi (Interactive Codes): Mention that mark
	must be set for "r" to work.

2017-03-17  Thien-Thi Nguyen  <ttn@gnu.org>

	Fix bug: Range-check integer ‘alpha’ frame parm value

	Typo introduced 2013-04-01, "Prefer < to >
	in range checks such as 0 <= i && i < N".

	* src/frame.c (x_set_alpha): Use ‘ialpha’, not ‘alpha’.

2017-03-17  Paul Eggert  <eggert@cs.ucla.edu>

	* etc/PROBLEMS: Say that HP-UX cc doesn't work.

2017-03-14  Eli Zaretskii  <eliz@gnu.org>

	Fix duplicate wording in Emacs manual

	* doc/emacs/programs.texi (Which Function): Delete duplicate
	wording.  (Bug#26098)

2017-03-14  Hong Xu  <hong@topbug.net>

	* lisp/paren.el (show-paren--default, show-paren-function): Add docstring.

2017-03-13  Eli Zaretskii  <eliz@gnu.org>

	Fix wording in Emacs manual

	* doc/emacs/text.texi (Paragraphs): Fix a garbled sentence.
	(Bug#26086)

2017-03-11  Eli Zaretskii  <eliz@gnu.org>

	Document how to customize input methods

	* doc/emacs/mule.texi (Input Methods): Document how to customize
	input methods.

2017-03-11  Eli Zaretskii  <eliz@gnu.org>

	* lisp/net/eww.el (eww-reload): Doc fix.  (Bug#25981)

2017-03-06  Noam Postavsky  <npostavs@gmail.com>

	Fix warning message about native completion (Bug#25984)

	* lisp/progmodes/python.el (python-shell-completion-native-turn-on-maybe):
	The relevant variable is `python-shell-completion-native-enable'.

2017-03-04  Eli Zaretskii  <eliz@gnu.org>

	Clarify documentation of 'raise' and 'height' display specs

	* doc/lispref/display.texi (Other Display Specs): Clarify the
	effect of 'height' display spec on the following 'raise'.
	(Bug#25824)

2017-03-04  Eli Zaretskii  <eliz@gnu.org>

	Mention problems with GPaste in PROBLEMS

	* etc/PROBLEMS (GPaste): Mention the problem in yanking caused by
	GPaste, and its solution.  (Bug#25902)

2017-02-25  Eli Zaretskii  <eliz@gnu.org>

	Fix doc strings in info.el

	* lisp/info.el (Info-selection-hook, Info-mode-hook)
	(Info-edit-mode-hook): Doc fixes.  (Bug#25794)

2017-02-25  Eli Zaretskii  <eliz@gnu.org>

	Fix doc string of 'posn-at-point'

	* src/keyboard.c (Fposn_at_point): Clarify the doc string.
	(Bug#25796)

2017-02-24  Tino Calancha  <tino.calancha@gmail.com>

	Documentation fix in elisp reference manual

	* doc/lispref/macros.texi (Defining Macros): Drop redundant mention
	on 'declare' forms (Bug#25846).

2017-02-18  Noam Postavsky  <npostavs@gmail.com>

	* lisp/woman.el (woman): Fix docstring prefix arg description.

2017-02-18  Eli Zaretskii  <eliz@gnu.org>

	Mention "editor" in Emacs man page header

	* doc/man/emacs.1.in: Mention "editor" in the header line.
	(Bug#25771, Bug#25779)

2017-02-18  Eli Zaretskii  <eliz@gnu.org>

	Document problems with nerd-fonts

	* etc/PROBLEMS (fonts): Describe the potential problems with
	nerd-fonts that cause slow display.  (Bug#25697)

2017-02-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	* doc/lispref/modes.texi (Derived Modes): Make example more idiomatic

2017-02-12  Eli Zaretskii  <eliz@gnu.org>

	Clarify what is the "cursor"

	* doc/lispref/windows.texi (Window Point): Clarify the notion of
	"cursor".

2017-02-10  Eli Zaretskii  <eliz@gnu.org>

	Improve commentary in lisp.h

	* src/lisp.h: Explain in the comment why enlarging a Lisp_Misc
	object is discouraged.

2017-02-08  Noam Postavsky  <npostavs@gmail.com>

	Disable native completion for ipython (Bug#25067)

	* lisp/progmodes/python.el:
	(python-shell-completion-native-disabled-interpreters): Add "ipython".

2017-02-07  Eli Zaretskii  <eliz@gnu.org>

	Fix a typo in ada-mode manual

	* doc/misc/ada-mode.texi (Project file variables): Add a missing
	right bracket.  Reported by Jean-Christophe Helary
	<jean.christophe.helary@gmail.com>.

2017-02-05  Eli Zaretskii  <eliz@gnu.org>

	Clarify documentation of 'bufferpos-to-filepos' and 'filepos-to-bufferpos'

	* doc/lispref/nonascii.texi (Text Representations): Clarify that
	'exact' value of QUALITY argument to 'bufferpos-to-filepos' and
	'filepos-to-bufferpos' can lead to expensive and slow processing.

	* lisp/international/mule-util.el (filepos-to-bufferpos)
	(bufferpos-to-filepos): Doc fix.  (Bug#25626)

2017-02-03  Nicolas Petton  <nicolas@petton.fr>

	Bump Emacs version to 25.2 RC1

	* README:
	* configure.ac:
	* msdos/sed2v2.inp:
	* nt/README.W32: Bump Emacs version.
	* lisp/ldefs-boot.el: Update.

2017-02-03  Nicolas Petton  <nicolas@petton.fr>

	* admin/make-tarball.txt: Add documentation regarding the release banner.

2017-02-03  Tino Calancha  <tino.calancha@gmail.com>

	* CONTRIBUTE (Documenting your changes): Index new vars/commands in manual.

2017-01-31  Eli Zaretskii  <eliz@gnu.org>

	Index byte-compile-debug

	* doc/lispref/compile.texi (Compilation Functions): Index
	byte-compile-debug.

2017-01-31  Philipp Stephani  <phst@google.com>

	Document `byte-compile-debug' in the ELisp manual

	* doc/lispref/compile.texi: Document variable `byte-compile-debug'.

2017-01-31  Philipp Stephani  <phst@google.com>

	Document variable `byte-compile-debug'

	* lisp/emacs-lisp/bytecomp.el (byte-compile-debug): Document variable.

2017-01-31  Noam Postavsky  <npostavs@gmail.com>

	Fix call to debugger on assertion failure

	* lisp/emacs-lisp/cl-preloaded.el (cl--assertion-failed): The first
	argument must be `error', and the second is a list of arguments for
	`signal'.

2017-01-29  Noam Postavsky  <npostavs@gmail.com>

	Call modification hooks in org-src fontify buffers

	* lisp/org/org-src.el (org-src-font-lock-fontify-block): Let-bind
	`inhibit-modification-hooks' to nil, since this function can be called
	from jit-lock-function which binds that variable to t (Bug#25132).

2017-01-28  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'format' conversions

	* src/editfns.c (Fformat): More accurate description of %g and
	effects of the various flags on it.  More accurate description of
	integer conversions.

	* doc/lispref/strings.texi (Formatting Strings): More accurate
	description of %g and effects of the various flags on it.  More
	accurate description of integer conversions.  (Bug#25557)

2017-01-27  Vladimir Panteleev  <git@thecybershadow.net>  (tiny change)

	Remove stale functions from ert manual

	* doc/misc/ert.texi (Useful Techniques when Writing Tests):
	Replace ert--mismatch references with its cl-lib replacement,
	cl-mismatch.

2017-01-27  Eli Zaretskii  <eliz@gnu.org>

	Fix a typo in Eshell manual

	* doc/misc/eshell.texi (History): Fix a typo.  Reported by Mak
	Kolybabi <mak@kolybabi.com>.

2017-01-20  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of hooks related to saving buffers

	* lisp/files.el (write-file-functions, write-contents-functions)
	(before-save-hook, after-save-hook): Note that these are only used
	by save-buffer.

	* doc/lispref/backups.texi (Auto-Saving):
	* doc/lispref/files.texi (Saving Buffers): Mention that
	save-related hooks are not run by auto-saving.  (Bug#25460)

2017-01-20  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of auto-save-visited-file-name

	* doc/emacs/files.texi (Auto Save Files): Mention subtle
	differences between saving the buffer and auto-saving with
	auto-save-visited-file-name set non-nil.  (Bug#25478)

2017-01-18  Tom Tromey  <tom@tromey.com>

	fix typo in mailcap-mime-extensions

	* lisp/gnus/mailcap.el (mailcap-mime-extensions): Use "text/x-patch",
	not "test/x-patch".  (Bug#25472)

2017-01-18  Lele Gaifax  <lele@metapensiero.it>  (tiny change)

	Fix typos in flymake.el

	* lisp/progmodes/flymake.el (flymake-check-patch-master-file-buffer):
	Spelling fixes in the doc string.

2017-01-17  Glenn Morris  <rgm@gnu.org>

	More NEWS checking for admin.el's set-version

	* admin/admin.el (set-version): Warn if temporary NEWS markup
	still present in release candidates.

2017-01-17  Michael Albinus  <michael.albinus@gmx.de>

	Fix auto-save-file-name problem in Tramp on MS Windows. Do not merge

	* lisp/net/tramp.el (tramp-handle-make-auto-save-file-name):
	Fix a problem when running on MS Windows.

2017-01-16  Ian Dunn  <dunni@gnu.org>  (tiny change)

	* lisp/net/eww.el (eww-tag-meta): Handle single quoted URLs (Bug#25445).

2017-01-14  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/progmodes/sql.el (sql-product-alist): Doc tweak

	`:sqli-comint-func' does not have to be a symbol.

2017-01-14  Eli Zaretskii  <eliz@gnu.org>

	* lisp/progmodes/sql.el (sql-product-alist): Doc fix.  (Bug#25440)

2017-01-13  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of dabbrevs

	* doc/emacs/abbrevs.texi (Dynamic Abbrevs): Add a cross reference
	to "Dabbrev Customization".
	(Dabbrev Customization): More details about the default value of
	dabbrev-abbrev-char-regexp and use cases when it might not be good
	enough.  (Bug#25432)

2017-01-12  Noam Postavsky  <npostavs@gmail.com>

	Clarify that easy-menu-add is a nop (Bug#25382)

	* lisp/emacs-lisp/easymenu.el (easy-menu-add): Make it into an alias of
	`ignore', like `easy-menu-remove'.

2017-01-12  Glenn Morris  <rgm@gnu.org>

	* lisp/textmodes/rst.el (rst-package-emacs-version-alist): Fix entry.

2017-01-11  Eli Zaretskii  <eliz@gnu.org>

	Revert "Add DNS keywords and remove duplications"

	This reverts commit 1cb9aa5b14867983d0013a61709b4d0af18364ff.

2017-01-11  Alexander Kuleshov  <kuleshovmail@gmail.com>

	Add DNS keywords and remove duplications

	* lisp/textmodes/dns-mode.el (dns-mode-types): Add two TLSA and
	NSEC" DNS related keywords and remove duplication of "NSAP".

2017-01-10  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of coding-systems

	* doc/lispref/nonascii.texi (Coding System Basics): Mention
	'prefer-utf-8'.  Index it and 'undecided'.
	(Encoding and I/O): Fix a typo.
	(User-Chosen Coding Systems): Improve the documentation of
	ACCEPT-DEFAULT-P argument to select-safe-coding-system.  Document
	select-safe-coding-system-function.
	(Specifying Coding Systems): Document coding-system-require-warning.

2017-01-09  Eli Zaretskii  <eliz@gnu.org>

	Improve definition of 'variable-pitch' face on MS-Windows

	* lisp/faces.el (variable-pitch): Don't specify too many
	attributes of the font, otherwise faces that request different
	weight or slant or size will not get them.

2017-01-09  Eli Zaretskii  <eliz@gnu.org>

	Fix an error message in python.el

	* lisp/progmodes/python.el (python-shell-get-process-or-error):
	Don't repeat the same key binding twice.  (Bug#25405)

2017-01-07  Noam Postavsky  <npostavs@gmail.com>

	Clarify major mode switching

	* doc/emacs/modes.texi (Major Modes):
	* doc/lispref/modes.texi (Modes, Major Modes): Explictly say that each
	buffer has exactly one major mode and can't be "turned off", only
	switched away from (Bug#25357).

2017-01-07  Noam Postavsky  <npostavs@gmail.com>

	Add helpful comment to compile-command's docstring

	* lisp/progmodes/compile.el (compile-command): Mention trailing space in
	docstring (Bug#25337).

2017-01-06  Eli Zaretskii  <eliz@gnu.org>

	Fix ':version' of 'select-enable-primary'

	* lisp/select.el (select-enable-primary): Fix a typo in
	':version'.  (Bug#25375)

2017-01-04  Glenn Morris  <rgm@gnu.org>

	Update remaining copyright years with admin.el M-x set-copyright

	* etc/refcards/ru-refcard.tex (cyear): Set to 2017.

2017-01-04  Glenn Morris  <rgm@gnu.org>

	* lisp/ffap.el (ffap-lax-url): Bump :version after recent change.

2017-01-03  Philipp Stephani  <phst@google.com>

	Document that functions in 'ffap-alist' can use the match data

	* lisp/ffap.el (ffap-alist): Document that ffap sets the match data
	while walking 'ffap-alist'.

2017-01-01  Paul Eggert  <eggert@cs.ucla.edu>

	Fix copyright years by hand

	These are dates that admin/update-copyright did not update, or
	updated incorrectly.

2017-01-01  Paul Eggert  <eggert@cs.ucla.edu>

	Update copyright year to 2017

	Run admin/update-copyright.

2016-12-30  Nicolas Petton  <nicolas@petton.fr>

	Bump Emacs version to 25.1.91

	* README:
	* configure.ac:
	* msdos/sed2v2.inp:
	* nt/README.W32: Bump Emacs version.
	* lisp/ldefs-boot.el: Update.

2016-12-30  Alan Mackenzie  <acm@muc.de>

	Backport: Remove an ambiguity from defvar's doc string.  Fixes bug #25292.

	The ambiguity was whether INITVALUE is evaluated when it's not going to be
	used to set SYMBOL's value.

	* src/eval.c (defvar): Rewrite a paragraph of the doc string.

	(cherry picked from commit 8295e97f18490a535d1188a3daf0b0fd1bf4fa0d)

2016-12-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/emacs-lisp/inline.el: Fix apply-conversion (bug#25280)

	(inline--dont-quote): Quote the function with #' when passing it to `apply'.
	Cherry picked from commit e6161f648903d821865b9610b3b6aa0f82a5dcb7.

2016-12-26  Eli Zaretskii  <eliz@gnu.org>

	Document 'default-toplevel-value' and 'set-default-toplevel-value'

	* doc/lispref/variables.texi (Default Value): Document
	'default-toplevel-value' and 'set-default-toplevel-value'.

2016-12-25  Leo Liu  <sdl.web@gmail.com>

	Don't modify minibuffer variables globally

	* lisp/files.el (cd): Use setq-local instead.  (Bug#25260)

2016-12-24  Eli Zaretskii  <eliz@gnu.org>

	Revert to pre-25.1 behavior in ffap

	* lisp/ffap.el (ffap-lax-url): Change the default to t, to produce
	the same behavior as in Emacs 24.x.  (Bug#25264)
	Explain the trade-offs of customizing this in the doc string.

2016-12-24  Noam Postavsky  <npostavs@gmail.com>

	* lisp/ffap.el: Fix obsolete comment referencing ffap-bug.

2016-12-23  Eli Zaretskii  <eliz@gnu.org>

	Attempt to fix 64-bit AIX build

	* src/unexaix.c (make_hdr, copy_text_and_data, write_segment): Fix
	type-casts that assumed 32-bit pointers.  (Bug#25141)

2016-12-23  Philipp Stephani  <phst@google.com>

	Clarify usage of 'ediff-cleanup-hook' (Bug#24675)

	* doc/misc/ediff.texi (Hooks): Clarify usage of 'ediff-cleanup-hook'

2016-12-23  Philipp Stephani  <phst@google.com>

	Document that variable binding order is unspecified

	* doc/lispref/variables.texi (Local Variables):
	* doc/misc/cl.texi (Modify Macros): Document that binding order in 'let' and
	'cl-letf' is unspecified.

2016-12-23  Eli Zaretskii  <eliz@gnu.org>

	* lisp/desktop.el (desktop-buffers-not-to-save): Doc fix.

2016-12-23  Stefan Monnier  <monnier@IRO.UMontreal.CA>

	Fix M-x hints on Mac port

	* lisp/simple.el (execute-extended-command--shorter): Call
	input-pending-p to trigger input processing on some systems, such
	as Mac port.  (Bug#23002)

2016-12-22  Martin Rudalics  <rudalics@gmx.at>

	Work around reporting a dpi change in apply_xft_settings

	* src/xsettings.c (apply_xft_settings): Don't report a change
	when dpi settings do not differ substantially.

2016-12-20  Alan Mackenzie  <acm@muc.de>

	Amend the version number of CC Mode 5.33 -> 5.32.99.  Don't merge to trunk.

	lisp/progmodes/cc-defs.el: Amend the version number.
	etc/NEWS: Add an item explaining the change.

2016-12-20  Noam Postavsky  <npostavs@gmail.com>

	Improve skeleton docstrings

	* lisp/skeleton.el (skeleton-end-newline): Remove mention of
	`skeleton-end-hook', its default code was moved into `skeleton-insert'.
	(skeleton-insert): Mention `skeleton-end-newline' and move reference to
	`skeleton-end-hook' above the explanation of skeleton syntax.

2016-12-19  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'w32-scroll-lock-modifier'

	* doc/emacs/msdos.texi (Windows Keyboard): Document how to set up
	w32-scroll-lock-modifier so that Scroll Lock toggles the LED.

	* src/w32fns.c (syms_of_w32fns) <w32-scroll-lock-modifier>: Doc
	fix.  (Bug#25204)

2016-12-19  Eli Zaretskii  <eliz@gnu.org>

	Document 'describe-fontset'

	* doc/emacs/mule.texi (Fontsets): Document 'describe-fontset'.
	(Bug#25216)

2016-12-19  Eli Zaretskii  <eliz@gnu.org>

	Document 'describe-fontset'

	* doc/emacs/mule.texi (Fontsets): Document 'describe-fontset'.
	(Bug#25216)

2016-12-17  Eli Zaretskii  <eliz@gnu.org>

	Repair desktop restoration on text terminals

	* lisp/desktop.el (desktop-restoring-frameset-p): Test for the GUI
	frame here, instead of in desktop-restoring-frameset.  That's
	because desktop-read wants to know whether frameset will actually
	be restored, and has fallback procedures up its sleeve when it
	won't be; these fallbacks need to be invoked when the frameset is
	not going to be restored.  (Bug#24298)

2016-12-17  Dmitry Gutov  <dgutov@yandex.ru>

	Ignore forward-sexp-function in js-mode indentation code

	* lisp/progmodes/js.el (js--multi-line-declaration-indentation)
	(js--maybe-goto-declaration-keyword-end):
	Bind forward-sexp-function to nil (bug#25215).

2016-12-16  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'define-coding-system'

	* lisp/international/mule.el (define-coding-system): Warn against
	possible infinite recursion in pre-write-conversion and
	post-read-conversion functions.  (Bug#25203)

2016-12-11  Michael Albinus  <michael.albinus@gmx.de>

	Fix Bug#25162

	* doc/emacs/files.texi (Reverting): Document
	auto-revert-remote-files and auto-revert-verbose.

	* lisp/autorevert.el (auto-revert-verbose, auto-revert-mode)
	(auto-revert-tail-mode, global-auto-revert-mode): Fix docstring.

2016-12-11  Glenn Morris  <rgm@gnu.org>

	Fix a typo in define-abbrev-table

	* lisp/abbrev.el (define-abbrev-table): Fix typo in docstring handling.

2016-12-11  Glenn Morris  <rgm@gnu.org>

	Bump makeinfo requirement from 4.7 to 4.13

	* configure.ac: Bump makeinfo version requirement from 4.7 to 4.13.
	We need at least 4.8, and that may be buggy, so go for the last
	of the 4 series, which is 8 years old.  (Bug#25108)

2016-12-11  Glenn Morris  <rgm@gnu.org>

	Fixes related to select-enable-clipboard

	* lisp/menu-bar.el (clipboard-yank, clipboard-kill-ring-save)
	(clipboard-kill-region):
	* lisp/eshell/esh-io.el (eshell-virtual-targets)
	(eshell-clipboard-append):
	Replace option gui-select-enable-clipboard with
	select-enable-clipboard; renamed October 2014.  (Bug#25145)

2016-12-10  Noam Postavsky  <npostavs@gmail.com>

	Define struct predicate before acccesors

	The accessor functions use the predicate function, which causes problems
	when reloading after unload-feature: the compiler-macro property is
	still present on the predicate symbol, and the compiler fails to find
	the definition when trying to inline it into the accessor
	function (Bug#25088).

	* lisp/emacs-lisp/cl-macs.el (cl-defstruct): Move predicate definition
	before field accessor definitions.

2016-12-08  Glenn Morris  <rgm@gnu.org>

	Doc fix for vc-git

	* lisp/vc/vc-git.el (vc-git-region-history): Add a doc string.

2016-12-08  Glenn Morris  <rgm@gnu.org>

	Further improve make-dist checking

	* make-dist: Print status messages when checking.

2016-12-08  Glenn Morris  <rgm@gnu.org>

	Improve previous make-dist change

	* make-dist: Let make check the info files more thoroughly.

2016-12-08  Glenn Morris  <rgm@gnu.org>

	Make make-dist --snapshot do some sanity checks

	* make-dist: Snapshot mode no longer disables checks.
	Checks now includes checks for freshness.  (Bug#25084)
	Checks now exits with an error if problems were found.

2016-12-07  Paul Eggert  <eggert@cs.ucla.edu>

	Fix minor quoting problems in doc strings

2016-12-07  Philipp Stephani  <p.stephani2@gmail.com>

	* lisp/emacs-lisp/easy-mmode.el (define-minor-mode): Fix docstring

	so that it matches the actual implementation.
	See https://lists.gnu.org/r/help-gnu-emacs/2016-04/msg00071.html

2016-12-07  Noam Postavsky  <npostavs@gmail.com>

	Don't assume window-point and point are the same

	The function `cursor-sensor--detect' calls `bobp' to decide whether to
	check properties at (1- (window-point)).  However, (window-point) may be
	at beginning of buffer, even if (point) is not.  In this case an
	`args-out-of-range' error will be signaled (Bug#25104).

	* lisp/emacs-lisp/cursor-sensor.el (cursor-sensor--detect): Check the
	value of (window-point) against (point-min), rather than (bobp) to
	decide if (1- (window-point)) is accessible.

2016-12-02  Nicolas Petton  <nicolas@petton.fr>

	Fix bug#25087

	* etc/themes/manoj-dark-theme.el: Fix two typos.

	(cherry picked from commit 66d6e7e9ecf5e481f8c2c3a4f88411f66c869a6e)

2016-12-02  Eli Zaretskii  <eliz@gnu.org>

	* lisp/vc/ediff-util.el (ediff-janitor): Doc fix.  (Bug#25046)

2016-12-02  Eli Zaretskii  <eliz@gnu.org>

	Improve indexing of 'man'

	* doc/emacs/programs.texi (Man Page): Index 'man', not
	'manual-entry', as the latter is an alias for the former.
	Suggested by Hong Xu <hong@topbug.net>.  (Bug#25033)

2016-12-02  Paul Eggert  <eggert@cs.ucla.edu>

	Port to Sun C 5.14

	Backport from master.  Sun C 5.14 supports C11 but not GCC
	extensions, and so refuses to compile Emacs without this patch.
	* src/alloc.c (lmalloc, lrealloc): Don't use INT_ADD_WRAPV on
	size_t, as in general this macro is restricted to signed types.

2016-12-02  Richard Stallman  <rms@gnu.org>

	Fix mail-combine-fields

	* lisp/mail/sendmail.el (mail-combine-fields): Call `save-excursion' to
	avoid losing our place in the search loop.

	(cherry picked from commit 5fbba6cceaf843cfca449eb000a0a65243b61808)

2016-12-01  Martin Rudalics  <rudalics@gmx.at>

	Fix documentation of `window-combination-resize'

	* src/window.c (Vwindow_combination_resize): Fix doc-string.
	* doc/lispref/windows.texi (Recombining Windows): Fix
	documentation of `window-combination-resize'.

2016-11-29  Bogdan Creanga  <bogdan.creanga@gmail.com>  (tiny change)

	Typo fixes in elisp manual

	* doc/lispref/sequences.texi: Add missing '4' in result (Bug#25047).
	* doc/lispref/strings.texi (Text Comparison): Avoid duplicate
	definitions of 'string-prefix-p' and 'string-suffix-p'.
	* doc/lispref/symbols.texi (Definitions): Pluralize 'definitions'.

2016-11-28  Eli Zaretskii  <eliz@gnu.org>

	Fix 'expand-file-name' during startup on MS-Windows

	* src/w32.c (w32_init_file_name_codepage): New function, resets
	file_name_codepage and w32_ansi_code_page to undo the values
	recorded during dumping.
	(codepage_for_filenames): Fix an embarrassing typo.  Ignore the
	cached value of file-name encoding if it is nil, i.e. not
	initialized yet.  Actually cache the last used file-name encoding
	to avoid calling APIs when not necessary.

	* src/w32.h (w32_init_file_name_codepage): Add prototype.

	* src/w32term.c (syms_of_w32term): Set the value of
	w32_unicode_filenames according to the OS version.  This avoids
	resetting it during startup, which then causes temacs to run with
	the incorrect value.

	* src/emacs.c (main): Call w32_init_file_name_codepage early
	during the startup.

	* src/fileio.c (Fexpand_file_name) [WINDOWSNT]: Update 'newdir'
	after converting $HOME to a UTF-8 string, so that 'newdirlim' is
	consistent with it.  (Bug#25038)

	* lisp/international/mule-cmds.el (set-locale-environment): Set
	'default-file-name-coding-system' to the ANSI codepage even in
	non-interactive sessions.

	* lisp/files.el (directory-abbrev-alist, abbreviated-home-dir):
	Doc fix.
	(abbreviate-file-name): Decode 'abbreviated-home-dir' if it is a
	unibyte string.

	* doc/lispref/files.texi (Directory Names): Index
	'directory-abbrev-alist'.

2016-11-28  Nicolas Petton  <nicolas@petton.fr>

	* admin/authors.el (authors-renamed-files-alist): Addition.

2016-11-28  Glenn Morris  <rgm@gnu.org>

	Tweak refcard note about documentation location

	* etc/refcards/calccard.tex, etc/refcards/cs-dired-ref.tex:
	* etc/refcards/cs-refcard.tex, etc/refcards/cs-survival.tex:
	* etc/refcards/de-refcard.tex, etc/refcards/dired-ref.tex:
	* etc/refcards/fr-dired-ref.tex, etc/refcards/fr-refcard.tex:
	* etc/refcards/fr-survival.tex, etc/refcards/gnus-refcard.tex:
	* etc/refcards/orgcard.tex, etc/refcards/pl-refcard.tex:
	* etc/refcards/pt-br-refcard.tex, etc/refcards/refcard.tex:
	* etc/refcards/ru-refcard.tex, etc/refcards/sk-dired-ref.tex:
	* etc/refcards/sk-refcard.tex, etc/refcards/sk-survival.tex:
	* etc/refcards/survival.tex, etc/refcards/vipcard.tex:
	* etc/refcards/viperCard.tex: Tweak documentation url.

2016-11-28  Glenn Morris  <rgm@gnu.org>

	Improve treatment of Fortran's "class is"

	* lisp/progmodes/f90.el (f90-start-block-re, f90-no-block-limit):
	Handle "class is".  (Bug#25039)
	* test/automated/f90.el (f90-test-bug25039): New test.

2016-11-28  Nicolas Petton  <nicolas@petton.fr>

	Bump Emacs version to 25.1.90

	* README:
	* configure.ac:
	* msdos/sed2v2.inp:
	* nt/README.W32: Bump Emacs version to 25.1.90

2016-11-27  Nicolas Petton  <nicolas@petton.fr>

	Bump Emacs version

	* README:
	* configure.ac:
	* etc/NEWS:
	* msdos/sed2v2.inp:
	* nt/README.W32: Bump Emacs version to 25.2.90

2016-11-26  Karl Fogel  <kfogel@red-bean.com>

	Handle TeX comments when making new paragraph

	* lisp/textmodes/tex-mode.el (tex-handle-newline): New function.
	  Handle comment case directly, and dispatch to `tex-terminate-paragraph'
	  for original behavior in non-comment case.
	  (tex-mode-map): Bind above to C-j, replacing `tex-terminate-paragraph'.

2016-11-25  Eli Zaretskii  <eliz@gnu.org>

	Restore keystroke echo in 'C-q'

	* lisp/simple.el (read-quoted-char): Use 'read-event' instead of
	'read-key', to avoid losing the keystroke echo in 'C-q'.  (Bug#24635)

2016-11-25  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'current-word'

	* lisp/simple.el (current-word): Clarify and improve the doc
	string.  (Bug#24979)

2016-11-25  Chunyang Xu  <mail@xuchunyang.me>

	Fix a typo in an Eshell defcustom

	* lisp/eshell/esh-mode.el (eshell-scroll-to-bottom-on-output): Fix
	a typo in the 'others' standard value.  (Bug#24983)

2016-11-24  Hong Xu  <hong@topbug.net>  (tiny change)

	Minor copyedits of electric-pair-mode

	* doc/emacs/programs.texi (Matching): Add index entries.  Fix
	typos.  (Bug#25012)

2016-11-24  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of 'invocation-directory'

	* doc/lispref/os.texi (System Environment): Fix wording of the
	description of 'invocation-directory'.  (Bug#24999)

2016-11-23  Glenn Morris  <rgm@gnu.org>

	* admin/authors.el (authors-aliases): Add an entry.

2016-11-22  Philipp Stephani  <phst@google.com>

	Guard terminal parameter in XTerm mouse mode

	It has been observed (in the HTerm terminal emulator) that the
	event stored in the 'xterm-mouse-last-down' terminal parameter gets
	overwritten during a mouse drag operation, causing Emacs to attempt to
	synthesize the non-existing <drag-mouse-0> event.  Copy the event into
	the terminal parameter to protect against such modifications.

	* lisp/xt-mouse.el (xterm-mouse-translate-1): Guard against modification
	of input event list.

2016-11-21  Nicolas Petton  <nicolas@petton.fr>

	* etc/AUTHORS: Regenerate the AUTHORS file

2016-11-21  Nicolas Petton  <nicolas@petton.fr>

	Update ChangeLog files and authors.el

	* admin/authors.el (authors-renamed-files-alist): Add entries for
	  obsolete files.
	* ChangeLog.2: Update.

2016-11-21  Eli Zaretskii  <eliz@gnu.org>

	Fix menu bindings of Dired 'A' and 'Q' commands

	* lisp/dired.el (dired-mode-map): Rebind "Search Files" and "Query
	Replace in Files" menu items to 'dired-do-find-regexp' and
	'dired-do-find-regexp-and-replace', respectively.  (Bug#24977)

2016-11-20  Eli Zaretskii  <eliz@gnu.org>

	Avoid errors in shr-pixel-column due to dedicated windows

	* lisp/net/shr.el (shr-pixel-column): If we are switching to
	another buffer in the selected window, make that window
	temporarily non-dedicated.  (Bug#24950)

2016-11-20  Tino Calancha  <tino.calancha@gmail.com>

	Update format-time-string documentation

	* doc/lispref/os.texi (Time Parsing):
	Document %F, %g, %G, %u and %V.

2016-11-19  Eli Zaretskii  <eliz@gnu.org>

	* admin/release-process: Update versions and blocking bug numbers.

2016-11-18  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of functions that accept time values

	* doc/lispref/os.texi (Time Calculations): Mention the meaning of
	'nil' or a scalar number as the time-value argument.  Add a
	cross-reference to 'float-time' for computing a time difference as
	a scalar number of seconds.

	* src/editfns.c (Fformat_time_string, Ftime_less_p)
	(Ftime_subtract, Ftime_add, Fdecode_time, Fcurrent_time_string)
	(Fcurrent_time_zone): Mention in the doc strings the meaning of
	nil argument and the fact that a time value can be a scalar number
	of seconds since the epoch.
	(Ftime_subtract): Mention 'float-time'.

2016-11-18  Daniel Colascione  <dancol@dancol.org>

	Speed up initialization by preferring /dev/urandom to GnuTLS

	* src/sysdep.c (init_random): Try /dev/urandom before GnuTLS.

	(cherry picked from commit a37eba849eddc41375ad73974f6fcb1258aa8eba)

2016-11-18  Glenn Morris  <rgm@gnu.org>

	Add a comment in generated refcards about the source

	* etc/refcards/calccard.tex, etc/refcards/cs-dired-ref.tex:
	* etc/refcards/cs-refcard.tex, etc/refcards/cs-survival.tex:
	* etc/refcards/de-refcard.tex, etc/refcards/dired-ref.tex:
	* etc/refcards/fr-dired-ref.tex, etc/refcards/fr-refcard.tex:
	* etc/refcards/fr-survival.tex, etc/refcards/gnus-refcard.tex:
	* etc/refcards/orgcard.tex, etc/refcards/pl-refcard.tex:
	* etc/refcards/pt-br-refcard.tex, etc/refcards/refcard.tex:
	* etc/refcards/ru-refcard.tex, etc/refcards/sk-dired-ref.tex:
	* etc/refcards/sk-refcard.tex, etc/refcards/sk-survival.tex:
	* etc/refcards/survival.tex, etc/refcards/vipcard.tex:
	* etc/refcards/viperCard.tex: Add comment about the source.

2016-11-17  Dmitry Gutov  <dgutov@yandex.ru>

	js-mode: Fix indent problem after a regexp

	* lisp/progmodes/js.el (js--looking-at-operator-p): Check that the
	slash is not ending a regexp (bug#24854).

2016-11-16  Eli Zaretskii  <eliz@gnu.org>

	Fix sluggish display of symbols in UTF-8 language environment

	* lisp/international/fontset.el (setup-default-fontset): Make sure
	Symbola and FreeMono are set up in the default fontset as belonging
	to the "iso10646-1" registry.  In the UTF-8 locale, this avoids a
	long and futile search for a suitable font, whose side effect is a
	lot of consing, which then hits the font-cache compacting issue,
	and causes very sluggish redisplay of characters displayed by
	these fonts.  All this happens because the default for the
	registry is "iso8859-1".  (Bug#24953)

2016-11-16  Glenn Morris  <rgm@gnu.org>

	Don't confuse how Texinfo outputs @var with the input

	* doc/emacs/rmail.texi (Movemail):
	* doc/lispref/control.texi (Pattern matching case statement):
	* doc/lispref/frames.texi (Size and Position):
	* doc/lispref/processes.texi (Asynchronous Processes):
	* doc/lispref/text.texi (Document Object Model):
	* doc/lispref/windows.texi (Coordinates and Windows):
	Do not upper-case the argument of @var.

2016-11-16  Glenn Morris  <rgm@gnu.org>

	* doc/lispref/display.texi (Scroll Bars):
	* doc/lispref/frames.texi (Size and Position):
	* doc/lispref/windows.texi (Window Sizes): Fix arglist typos.

	* doc/emacs/cmdargs.texi (Initial Options): Copyedit for --daemon.

2016-11-15  Eli Zaretskii  <eliz@gnu.org>

	More fixes in copyright notices in etc/refcards/

	* etc/refcards/calccard.tex:
	* etc/refcards/cs-dired-ref.tex:
	* etc/refcards/cs-refcard.tex:
	* etc/refcards/cs-survival.tex:
	* etc/refcards/de-refcard.tex:
	* etc/refcards/dired-ref.tex:
	* etc/refcards/fr-dired-ref.tex:
	* etc/refcards/fr-refcard.tex:
	* etc/refcards/fr-survival.tex:
	* etc/refcards/orgcard.tex:
	* etc/refcards/pl-refcard.tex:
	* etc/refcards/pt-br-refcard.tex:
	* etc/refcards/refcard.tex:
	* etc/refcards/ru-refcard.tex:
	* etc/refcards/sk-dired-ref.tex:
	* etc/refcards/sk-refcard.tex:
	* etc/refcards/sk-survival.tex:
	* etc/refcards/survival.tex:
	* etc/refcards/vipcard.tex:
	* etc/refcards/viperCard.tex: Change "GNU Emacs" to "this
	document" in copyright notices.  (Bug#24520)

2016-11-13  Eli Zaretskii  <eliz@gnu.org>

	Update copyright text in refcards

	* etc/refcards/viperCard.tex:
	* etc/refcards/vipcard.tex:
	* etc/refcards/survival.tex:
	* etc/refcards/sk-survival.tex:
	* etc/refcards/sk-dired-ref.tex:
	* etc/refcards/sk-refcard.tex:
	* etc/refcards/ru-refcard.tex:
	* etc/refcards/refcard.tex:
	* etc/refcards/pt-br-refcard.tex:
	* etc/refcards/pl-refcard.tex:
	* etc/refcards/orgcard.tex:
	* etc/refcards/gnus-refcard.tex:
	* etc/refcards/fr-survival.tex:
	* etc/refcards/fr-refcard.tex:
	* etc/refcards/fr-dired-ref.tex:
	* etc/refcards/dired-ref.tex:
	* etc/refcards/de-refcard.tex:
	* etc/refcards/cs-survival.tex:
	* etc/refcards/cs-refcard.tex:
	* etc/refcards/cs-dired-ref.tex:
	* etc/refcards/calccard.tex: Update the copyright blurb.  (Bug#24520)

2016-11-12  Eli Zaretskii  <eliz@gnu.org>

	Fix Outline command names

	* doc/emacs/text.texi (Foldout): Use the outline-* names instead
	of the obsolete aliases.  (Bug#24890)

2016-11-10  Philipp Stephani  <phst@google.com>

	Send text received by bracketed paste to process

	See Bug#24639.

	* lisp/term.el (term--xterm-paste): New function.
	(term-raw-map): Use it.
	(xterm--pasted-text): Declare function from xterm.el.

2016-11-10  Alan Mackenzie  <acm@muc.de>

	Correct the statement about programming modes always running prog-mode-hook.

	* doc/emacs/modes.texi (Major Modes): Amend the statement about programming
	modes running prog-mode-hook to say that it applies to many (not all) such
	modes, and specifying exactly which modes.

2016-11-10  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'occur'

	* doc/emacs/search.texi (Other Repeating Search): Clarify how to
	use Occur with search strings from last Isearch.  (Bug#24890)

2016-11-09  Noam Postavsky  <npostavs@gmail.com>

	Do call debugger on failed cl-assert

	"Don't call debug on failed cl-assert..." removed the call to `debug' in
	cl--assertion-failed because `debug' calls `kill-emacs' in batch mode,
	thus messing up ert test runs.  However, calling the debugger is useful
	because it allows catching failed assertions even inside
	`condition-case' calls.  The problem with ert can be avoided by calling
	`debugger' instead of `debug' directly, since ert installs its own
	debugger while running tests.

	* lisp/emacs-lisp/cl-preloaded.el (cl--assertion-failed): Call
	`debugger' if `debug-on-error' is non-nil.

2016-11-09  Daniel Colascione  <dancol@dancol.org>

	Avoid infloop in python

	Fix bug#24905

	* lisp/progmodes/python.el (python-info-docstring-p): Improve
	infloop avoidance: replace (bobp) with generic test for
	forward progress.
	* test/automated/python-tests.el (python-bob-infloop-avoid): Add
	test for bug#24905

2016-11-07  Eli Zaretskii  <eliz@gnu.org>

	Don't refer to obsolete FEATURE-unload-hook

	* doc/lispref/tips.texi (Coding Conventions): Refer to
	FEATURE-unload-function rather than its obsolete variant
	FEATURE-unload-hook.  (Bug#24890)

2016-11-07  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of dabbrevs

	* lisp/dabbrev.el (dabbrev-expand): Doc fix.  (Bug#24890)

	* doc/emacs/abbrevs.texi (Dynamic Abbrevs): Mention
	'dabbrev-check-all-buffers', 'dabbrev-check-other-buffers', and
	'dabbrev-ignored-buffer-names' and their purpose.  (Bug#24890)

2016-11-07  Eli Zaretskii  <eliz@gnu.org>

	* lisp/chistory.el (list-command-history): Doc fix.  (Bug#24890)

	* lisp/simple.el (set-mark-command): Doc fix.  (Bug#24890)

2016-11-07  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of some Help commands

	* doc/emacs/help.texi (Help Mode): Fix mistake in key sequences.
	Mention the 'l' and 'r' keys.
	(Misc Help): Mention that 'C-h m' describes key bindings.
	(Bug#24890)

2016-11-07  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of yes-or-no prompts

	* doc/emacs/mini.texi (Yes or No Prompts): Fix mistakes in key
	sequences.  (Bug#24890)

2016-11-07  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of partial completion style

	* doc/emacs/mini.texi (Completion Styles): Fix the description of
	the wildcard '*'.  (Bug#24890)

2016-11-07  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of the mode line on emacsclient frames

	* doc/emacs/screen.texi (Mode Line): Document the '@' indicator on
	emacsclient frames.

2016-11-07  Eli Zaretskii  <eliz@gnu.org>

	Fix description of 'C-z' in User manual

	* doc/emacs/entering.texi (Exiting): 'C-z' is bound to
	'suspend-frame'.  (Bug#24890)

2016-11-07  Eli Zaretskii  <eliz@gnu.org>

	Improve and clarify documentation of Outline Mode

	* doc/emacs/text.texi (Outline Visibility): Use the outline-*
	names instead of the obsolete aliases.  (Bug#24890)

	* lisp/outline.el (outline-hide-sublevels, outline-hide-other)
	(outline-hide-body): Doc fixes.  (Bug#24890)

2016-11-06  Eli Zaretskii  <eliz@gnu.org>

	Add Emacs version number to nt/README.W32

	* nt/README.W32: Include the version number of the latest Emacs
	release.

	* admin/admin.el (set-version): Update the version in nt/README.W32.

2016-11-06  Noam Postavsky  <npostavs@gmail.com>

	Fix python-mode hideshow regexp

	2015-02-07 "Fix hideshow integration[...]" changed the regexp added to
	`hs-special-modes-alist' so that it worked when not searching from the
	beginning of the line.  However, this allows matching tokens ending in
	"def" or "class", not just those keywords.  This results in an infinite
	loop in hs-hide-all (Bug #24815).

	* lisp/progmodes/python.el (python-mode): Add symbol boundaries around
	the def|class matching part of the regexp added to
	hs-special-modes-alist.

2016-11-06  Paul Eggert  <eggert@cs.ucla.edu>

	Modernize usage of 'macOS' in doc and comments

	Apple changed the spelling of its operating system again, to "macOS",
	effective with macOS 10.12 Sierra (2016-09-20).  Change Emacs
	documentation and comments to match this.  Stick with older OS
	spellings ("OS X", "Mac OS X") when talking about older releases where
	the older names are more correct.

2016-11-06  Paul Eggert  <eggert@cs.ucla.edu>

	Prefer comments /* like this */ in C code

	Emacs C code assumes C99 features, but has long used traditional
	comments /* like this */ instead of C99-style comments // like this.
	Stick with traditional comments for now, partly for style, partly as
	it may be safer with compilers that are not fully in C99 mode.

2016-11-05  Noam Postavsky  <npostavs@gmail.com>

	* doc/lispref/loading.texi (Autoload): Better link (Bug#24845).

2016-11-05  Eli Zaretskii  <eliz@gnu.org>

	Clarify documentation of face attribute functions

	* doc/lispref/display.texi (Attribute Functions): Make sure to
	document that an omitted FRAME argument means the same as nil.
	(Bug#24879)

2016-11-05  Noam Postavsky  <npostavs@gmail.com>

	Don't call debug on failed cl-assert

	Doing this causes problems when running ert tests, for
	instance (Bug#24778).  The call to `debug` when `debug-on-error' is
	non-nil was introduced in 2015-02-14 "* lisp/emacs-lisp/cl*.el: Use
	define-inline and move some code...".

	* lisp/emacs-lisp/cl-preloaded.el (cl--assertion-failed): Don't call
	`debug' directly.

2016-11-04  Phillip Lord  <phillip.lord@russet.org.uk>

	Update README for precompiled windows Emacs.

	 * nt/README.W32: Describe 64 and 32-bit downloads, optional
	   dependencies bundle. Remove old material on sourcing dependencies.
	   Remove references to Windows 95. Update GUI references to recent
	   Windows. Remove references to Usenet.

2016-11-04  Hong Xu  <hong@topbug.net>

	Clarify documentation of 'vc-responsible-backend' wrt symlinks

	* lisp/vc/vc.el (vc-responsible-backend): Clarify that symlinks
	are not resolved when the VC backend is reported.

	* doc/lispref/files.texi (Truenames): Document
	'vc-responsible-backend'.  (Bug#23436)
	* doc/emacs/maintaining.texi (Version Control Systems): Fix a
	typo.

2016-11-04  Eli Zaretskii  <eliz@gnu.org>

	Clarify doc string of 'transpose-sexps'

	* lisp/simple.el (transpose-sexps): Clarify the conditions for
	transposing sexps that are lists or strings.  Mention the effect
	of the prefix argument.  (Bug#24860)

2016-11-04  Tibor Csögör  <tibi@tiborius.net>  (tiny change)

	Fix docstring of 'browse-url-firefox-new-window-is-tab'

	* lisp/net/browse-url.el (browse-url-firefox-new-window-is-tab):
	Remove obsolete note from docstring (obsoleted by previous commits).
	(Bug#24843)

2016-11-04  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'font-lock-remove-keywords'

	* doc/lispref/modes.texi (Customizing Keywords): Clarify the
	'keywords' argument of 'font-lock-remove-keywords'.  Suggested by
	Hong Xu <hong@topbug.net>.  (Bug#24830)

2016-11-04  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of the command summary key

	* doc/misc/info.texi (Help-^L, Help-Xref, Top): Emacs Info uses
	'?' for the summary of commands, whereas the stand-alone reader
	uses 'H'.  (Bug#24825)

2016-11-04  Eli Zaretskii  <eliz@gnu.org>

	Mark relocation workarounds with REL_ALLOC

	* src/search.c (boyer_moore): Mark workarounds for ralloc.c
	relocation of buffer text with "#ifdef REL_ALLOC".

2016-11-02  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	Fix documentation for 'eudc-options-file'

	* doc/misc/eudc.texi (The Server Hotlist): Update the default
	value of 'eudc-options-file'.

	Backport:

	(cherry picked from commit 0575fd95d0b92a9a0ebff8df183a449190f74dbc)

2016-11-02  Tibor Csögör  <tibi@tiborius.net>

	Fix documentation of 'eudc-inline-expansion-format'

	* doc/misc/eudc.texi (Inline Query Expansion): Fix the default value of
	'eudc-inline-expansion-format'. (Bug#24840)

	Backport:

	(cherry picked from commit 1fef1387c387d80f8ece326621539b89a6965702)

2016-10-31  Clément Pit--Claudel  <clement.pitclaudel@live.com>

	python.el: Fix detection of native completion in Python 3 (bug #24401)

	With Python 3.5, (python-shell-completion-native-get-completions ... "")
	would return an empty list, causing python.el to think that native
	completion was unavailable (the difference between Python 2 and Python 3
	is due to https://bugs.python.org/issue25660).

	* lisp/progmodes/python.el (python-shell-completion-native-try): Use "_"
	  to check whether native completion is available instead of "".

2016-10-26  Glenn Morris  <rgm@gnu.org>

	* Makefile.in (install-arch-indep): Skip etc/refcards/emacsver.tex.in.

2016-10-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/subr.el (set-transient-map): Exit for unbound events (bug#24755).

2016-10-26  Eli Zaretskii  <eliz@gnu.org>

	Update category-table for Chinese characters

	* lisp/international/characters.el (standard-category-table):
	Update the ranges of Han and Chinese characters.  (Bug#24798)

2016-10-26  Noam Postavsky  <npostavs@gmail.com>

	Inhibit buffer relocation during regex searches

	* src/search.c (looking_at_1, fast_looking_at, search_buffer): Prevent
	relocation of buffer contents during calls to re_search_2.  This ensures
	the pointers into buffer text won't be invalidated by
	r_alloc_sbrk (called from malloc with configurations where
	REL_ALLOC=yes).

2016-10-26  Noam Postavsky  <npostavs@gmail.com>

	Revert fixes to allocation of regex matching

	The fix was not complete, and completing it was proving too complicated.

	- Revert "* src/regex.c (re_search_2): Make new code safe for
	          -Wjump-misses-init."
	  This reverts commit c2a17924a57483d14692c8913edbe8ad24b5ffbb.
	- Revert "Port to GCC 6.2.1 + --enable-gcc-warnings"
	  This reverts commit f6134bbda259c115c06d4a9a3ab5c39340a15949.
	- Revert "Fix handling of allocation in regex matching"
	  This reverts commit ad66b3fadb7ae22a4cbb82bb1507c39ceadf3897.
	- Revert "Fix handling of buffer relocation in regex.c functions"
	  This reverts commit ee04aedc723b035eedaf975422d4eb242894121b.

2016-10-25  Eli Zaretskii  <eliz@gnu.org>

	Comment for bug#24793

	* lisp/info.el (Info-mode-font-lock-keywords): Add a comment
	explaining why `..' quoting is not fontified using the
	'Info-quoted' face.  (Bug#24793)

2016-10-25  Paul Eggert  <eggert@cs.ucla.edu>

	Default REL_ALLOC to 'no'

	This should make ralloc-related bugs less likely on GNU/Linux
	systems with bleeding-edge glibc.  See the email thread containing:
	https://lists.gnu.org/r/emacs-devel/2016-10/msg00801.html
	Do not merge to master.
	* configure.ac (REL_ALLOC): Default to 'no' on all platforms, not
	merely on platforms with Doug Lea malloc.  Although bleeding-edge
	glibc no longer exports __malloc_initialize_hook and so longer
	passes the configure-time test for Doug Lea malloc, ralloc tickles
	longstanding bugs like Bug#24358 and Bug#24764 and Emacs is likely
	to be more reliable without it.  This patch is not needed on
	master, which uses hybrid malloc in this situation.

2016-10-24  Eli Zaretskii  <eliz@gnu.org>

	Yet another fix for using pointers into buffer text

	* src/search.c (boyer_moore): Update pointers to buffer text
	after call to set_search_regs.  (Bug#24358)

2016-10-24  Eli Zaretskii  <eliz@gnu.org>

	Another fix for using pointer to buffer text

	* src/search.c (Freplace_match): Move the call to BYTE_POS_ADDR
	after the call to xpalloc, to avoid the danger of buffer text
	relocation after its address was taken.  (Bug#24358)

2016-10-24  Michael Albinus  <michael.albinus@gmx.de>

	Fix Bug#24478

	* lisp/net/tramp-sh.el (tramp-histfile-override): Change default value
	to "~/.tramp_history".
	(tramp-open-shell): Check proper HISTFILE setting.
	(tramp-maybe-open-connection): Cleanup also for errors.  (Bug#24478)

2016-10-24  Paul Eggert  <eggert@cs.ucla.edu>

	Port --enable-gcc-warnings to bleeding-edge glibc

	Bleeding-edge glibc sets emacs_cv_var_doug_lea_malloc to 'no'.
	Do not merge to master.
	* configure.ac: Check for valloc decl when compiling gmalloc.c.
	* src/gmalloc.c (emacs_abort) [emacs]: Adjust decl to match
	what is in lisp.h.  Remove duplicate decl.
	(aligned_alloc): #undef before defining.
	(aligned_alloc, memalign) [!MSDOS]: Declare.
	(valloc) [HAVE_DECL_VALLOC]: Remove duplicate decl.

2016-10-23  Eli Zaretskii  <eliz@gnu.org>

	Fix handling of buffer relocation in regex.c functions

	* src/search.c (search_buffer): Updated the base pointer to buffer
	text after the call to re_search_2.  (Bug#24358)

2016-10-23  Eli Zaretskii  <eliz@gnu.org>

	Avoid relocating buffers while libxml2 reads its text

	* src/xml.c (parse_region) [REL_ALLOC]: Freeze the ralloc arena
	while libxml2 reads the current buffer's text.  (Bug#24764)

2016-10-23  Eli Zaretskii  <eliz@gnu.org>

	Attempt to catch reads from a buffer that is relocated

	* src/xml.c (parse_region): Add assertion to ensure buffer text is
	not relocated while libxml2 is reading it.  (Bug#24764)

2016-10-23  Eli Zaretskii  <eliz@gnu.org>

	Revert "* lisp/simple.el (process-menu-mode, list-processes--refresh):"

	This reverts commit a4285bcb1114e29200001f33af9b4802167d6140.
	Do not merge to master!

2016-10-23  Eli Zaretskii  <eliz@gnu.org>

	Revert "* lisp/ibuf-ext.el (ibuffer-do-shell-command-file):"

	This reverts commit b0c447e4668116cecfda91d0203cb7cac2486d92.
	Do not merge to master!

2016-10-23  Eli Zaretskii  <eliz@gnu.org>

	Revert "* lisp/ibuffer.el (ibuffer): Improve 'other-window' case.  (Bug#23617)"

	This reverts commit cf3c19b0298236293d9c56d5ba425af4f42c1f8e.
	Do not merge to master!

2016-10-23  Eli Zaretskii  <eliz@gnu.org>

	;* src/w32heap.c: Fix typo and wording of the comments.

2016-10-23  Paul Eggert  <eggert@cs.ucla.edu>

	electric-quote mode no longer worries about coding

	* doc/emacs/text.texi (Quotation Marks), etc/NEWS: Document this.
	* lisp/electric.el (electric--insertable-p): Remove.
	All uses removed (Bug#24759).

2016-10-23  Paul Eggert  <eggert@cs.ucla.edu>

	* src/regex.c (re_search_2): Make new code safe for -Wjump-misses-init.

2016-10-23  Paul Eggert  <eggert@cs.ucla.edu>

	Port to GCC 6.2.1 + --enable-gcc-warnings

	* src/regex.c (ENSURE_FAIL_STACK, re_search_2):
	Redo recent regex changes to avoid complaints from GCC 6.2.1 when
	Emacs is configured with --enable-gcc-warnings.  Also, work around
	GCC bug 78081, which was uncovered by this new code.

2016-10-22  Noam Postavsky  <npostavs@gmail.com>

	Explain how to debug emacsclient lisp errors

	* doc/lispref/debugging.texi (Error Debugging): Mention that
	debug-on-signal is useful for getting backtraces from
	emacsclient (Bug#24616).

2016-10-22  Noam Postavsky  <npostavs@gmail.com>

	Let describe-function work for lambda again

	Since commit "* lisp/help-fns.el (describe-function): More type
	checking[...]", `describe-function' throws a user-error when given a
	non-symbol.  This prevents the [back] button in a *Help* buffer from
	working when the page it goes back to describes an anonymous
	function (e.g., the result of `describe-key' on a key which is bound to
	a lambda form).

	* lisp/help-fns.el (describe-function): Move the checks on FUNCTION
	being an fbound symbol into the `interactive' form.  This allows
	non-interactive calls to pass an anonymous function (Bug #24221).  Note
	that passing a non-bound symbol non-interactively will still trigger a
	`void-function' error from `describe-function-1'.

2016-10-22  Noam Postavsky  <npostavs@gmail.com>

	Fix kill-line's docstring

	* lisp/simple.el (kill-line): The effect of show-trailing-whitespace is
	important lines with *no* nonblanks (Bug #16654).

2016-10-22  Noam Postavsky  <npostavs@gmail.com>

	Fix handling of allocation in regex matching

	`re_match_2_internal' uses pointers to the lisp objects that it
	searches.  Since it may call malloc when growing the "fail stack", these
	pointers may be invalidated while searching, resulting in memory
	curruption (Bug #24358).

	To fix this, we check the pointer that the lisp object (as specified by
	re_match_object) points to before and after growing the stack, and
	update existing pointers accordingly.

	* src/regex.c (STR_BASE_PTR): New macro.
	(ENSURE_FAIL_STACK, re_search_2): Use it to convert pointers into
	offsets before possible malloc call, and back into pointers again
	afterwards.
	(POS_AS_IN_BUFFER): Add explanatory comment about punning trick.
	* src/search.c (search_buffer): Instead of storing search location as
	pointers, store them as pointers and recompute the corresponding address
	for each call to `re_search_2'.
	(string_match_1, fast_string_match_internal, fast_looking_at):
	* src/dired.c (directory_files_internal): Set `re_match_object' to Qnil
	after calling `re_search' or `re_match_2'.
	* src/regex.h (re_match_object): Mention new usage in commentary.

2016-10-21  Paul Eggert  <eggert@cs.ucla.edu>

	* lisp/electric.el (electric-quote-mode): Improve doc (Bug#24759).

2016-10-20  Tino Calancha  <tino.calancha@gmail.com>

	vc-region-history: Search just on lines intersecting the region

	* lisp/vc/vc.el (vc-region-history): If region ends in the beginning
	of a line, then exclude that line from the search (Bug#24725).

2016-10-19  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of 'alist-get'

	* doc/lispref/lists.texi (Association Lists): Fix the signature of
	'alist-get'.  Fix the markup, the wording, and the punctuation in
	the description. (Bug#24740)

2016-10-19  Eli Zaretskii  <eliz@gnu.org>

	* src/regex.h (re_match_object): Improve commentary.

2016-10-19  Alan Third  <alan@idiocy.org>

	Fix cursor at bottom left of rectangle (bug#24364)

	* lisp/rect.el (rectangle--col-pos): Don't assume point at EOL doesn't
	require rectangle--point-crutches to be set.

2016-10-19  Michael Albinus  <michael.albinus@gmx.de>

	Change Tramp version to "2.2.13.25.2"

	* doc/misc/trampver.texi:
	* lisp/net/trampver.el: Change version to "2.2.13.25.2".

2016-10-19  Eli Zaretskii  <eliz@gnu.org>

	* lisp/emacs-lisp/autoload.el (update-directory-autoloads): Fix last change.

2016-10-19  Eli Zaretskii  <eliz@gnu.org>

	Don't scan compiled module files for autoloads

	* lisp/emacs-lisp/autoload.el (update-directory-autoloads): Ignore
	compiled module files.  Make sure the extension really ends the
	file name.

2016-10-18  Michael Albinus  <michael.albinus@gmx.de>

	Fix Bug#24698

	* lisp/net/tramp-sh.el (tramp-open-connection-setup-interactive-shell):
	Don't send "stty tab0" to *BSD and Darwin machines.  (Bug#24698)

2016-10-18  Eli Zaretskii  <eliz@gnu.org>

	* lisp/subr.el (start-process): Doc fix.  (Bug#24693)

2016-10-18  Göktuğ Kayaalp  <self@gkayaalp.com>

	Fix display of vc-dir CVS file statuses in subdirectories

	* lisp/vc/vc-cvs.el (vc-cvs-dir-status-files): Use 'cvs update'
	instead of 'cvs status'.  It's faster, easier to parse, and
	relieves us of the need to use vc-expand-dirs.  (Bug#24082)
	(vc-cvs-after-dir-status): Parse its output.

2016-10-17  Eli Zaretskii  <eliz@gnu.org>

	Update URL of MS-Windows optional DLLs

	* nt/README.W32:
	* nt/INSTALL: Update the URL of the MS-Windows binaries of the
	optional libraries built with MSYS2/MinGW64 project tools.

2016-10-17  Eli Zaretskii  <eliz@gnu.org>

	Fix time-related data types in 2 editfns.c functions

	* src/editfns.c (format_time_string, Fcurrent_time_zone): Pass a
	pointer to time_t value to emacs_localtime_rz and gmtime_r,
	instead of relying on struct timespec's tv_sec member to be of
	compatible type.

2016-10-17  Tino Calancha  <f92capac@gmail.com>

	* lisp/simple.el (process-menu-mode, list-processes--refresh):
	Include PID.  (Bug#21725)

	(cherry picked from commit b7adc2f23787eb72015cd705b873e229db6a5049)

2016-10-17  Tino Calancha  <f92capac@gmail.com>

	* lisp/ibuf-ext.el (ibuffer-do-shell-command-file):
	Fix non-file-visiting-buffer case.  (Bug#22678)

	(cherry picked from commit 738738259ba77fe17e433c64e0758ea59ab5bc75)

2016-10-17  Tino Calancha  <f92capac@gmail.com>

	* lisp/ibuffer.el (ibuffer): Improve 'other-window' case.  (Bug#23617)

	(cherry picked from commit f4ef1a1fea15aa58fbb5e7a59bff260720658e49)

2016-10-17  Paul Eggert  <eggert@cs.ucla.edu>

	Port to Ubuntu 16.10, which needs gcc -nopie

	* configure.ac (emacs_cv_prog_cc_no_pie): Rename from
	emacs_cv_prog_cc_nopie.  All usages changed.  Check for -no-pie in
	preference to -nopie (Bug#24682).  Backport from master.

2016-10-17  Glenn Morris  <rgm@gnu.org>

	* lisp/cus-start.el (exec-path): Handle nil elements.  (Bug#24471)

2016-10-16  Andreas Politz  <politza@hochschule-trier.de>

	Catch the imenu-unavailable error in sh-mode completion table

	* lisp/progmodes/sh-script.el (sh--cmd-completion-table):
	Catch the imenu-unavailable error (bug#24238).

2016-10-16  Eli Zaretskii  <eliz@gnu.org>

	More char-width fixes

	* lisp/international/characters.el (char-width-table): More fixes
	according to the latest EastAsianWidth.txt.  (Bug#24705)

2016-10-15  Eli Zaretskii  <eliz@gnu.org>

	Fix char-width-table values for some Emoji

	* lisp/international/characters.el (char-width-table): Add missing
	range U+1F400..U+1F43E.  (Bug#24699)

	* admin/notes/unicode: Mention the need to verify char-width-table
	setting against data in EastAsianWidth.txt.

2016-10-15  Eli Zaretskii  <eliz@gnu.org>

	Keep point when switching from and to *terminal* buffer

	* lisp/term.el (term-reset-size): Don't reset the size if it
	didn't change.  If the size did change, restore point after
	adjusting the size.  (Bug#24465)

2016-10-15  Michael Albinus  <michael.albinus@gmx.de>

	* INSTALL: Use correct Emacs release number 25.

2016-10-14  Eli Zaretskii  <eliz@gnu.org>

	Avoid crashes due to objects read with the #n=object form

	* src/lread.c (read1): Use Fcons for 'placeholder', not AUTO_CONS,
	because elements of the list in 'read_objects' cannot be allocated
	off the stack.  (Bug#24640)

2016-10-13  Eli Zaretskii  <eliz@gnu.org>

	Improve doc string of 'completion-at-point-functions'

	* lisp/minibuffer.el (completion-at-point-functions): Doc fix.
	(Bug#24663)

2016-10-13  Philipp Stephani  <phst@google.com>

	Fix crash in evaluating functions

	See Bug#24673

	* src/eval.c (funcall_lambda): Fix crash for bogus functions such
	as (closure).

2016-10-13  Paul Eggert  <eggert@cs.ucla.edu>

	* src/filelock.c (current_lock_owner): Update comment.

2016-10-12  Paul Eggert  <eggert@cs.ucla.edu>

	Port --enable-gcc-warnings to GCC 6.2.1

	Backport from master.
	* src/conf_post.h (GNUC_PREREQ): New macro.
	* src/keyboard.c: Use it to work around GCC bug 54561.
	* src/process.c (would_block): New function.
	(server_accept_connection, wait_reading_process_output, send_process):
	Use it.

2016-10-12  Paul Eggert  <eggert@cs.ucla.edu>

	Work around Samba bug with ':' in symlink contents

	* src/filelock.c (current_lock_owner): When reading the contents
	of a lock, treat the UTF-8 for U+F022 as if it were ':' (Bug#24656).
	Backport from master.

2016-10-12  Paul Eggert  <eggert@cs.ucla.edu>

	Port last_marked change to full-program optimizers

	* src/alloc.c (last_marked): Now EXTERNALLY_VISIBLE.

2016-10-12  Eli Zaretskii  <eliz@gnu.org>

	Adapt GDB scripts to '--enable-check-lisp-object-type' builds

	* etc/emacs-buffer.gdb <$qnil>: New variable.
	(ybuffer-list, yset-buffer): Use $qnil for comparing against
	'nil', as direct comparison with Qnil doesn't work in a build with
	'--enable-check-lisp-object-type'.

	* src/.gdbinit: Adapt commands of the temporary breakpoint in
	init_sys_modes to a build with '--enable-check-lisp-object-type'.

2016-10-11  Eli Zaretskii  <eliz@gnu.org>

	Avoid optimizing out the last_marked[] array

	* src/alloc.c <last_marked>: No longer 'static', to avoid having
	it optimized out in optimized builds, which then makes debugging
	GC problems harder.

2016-10-09  Alan Mackenzie  <acm@muc.de>

	CC Mode manual: remove reference to former Emacs variable last-command-char

	* doc/misc/cc-mode.texi (Hanging Semicolons and Commas): Replace reference to
	variable last-command-char by one to macro c-last-command-char.

2016-10-08  Eli Zaretskii  <eliz@gnu.org>

	Allow to disable compaction of font caches

	* src/font.c (syms_of_font) <inhibit-compacting-font-caches>: New
	boolean variable.
	* src/alloc.c (compact_font_caches): Use it to bypass the call to
	compact_font_cache_entry.  (Bug#24634)  (Bug#24565)

	* etc/NEWS: Mention the new variable.

2016-10-08  Eli Zaretskii  <eliz@gnu.org>

	Allow selection of font for symbols as in Emacs 24.x

	* src/fontset.c (syms_of_fontset) <use-default-font-for-symbols>:
	New boolean variable.
	(face_for_char): Use it to fall back to pre-Emacs 25.1 behavior
	when selecting fonts for displaying symbol and punctuation
	characters.  (Bug#24644)

	* etc/NEWS: Mention the new variable.

2016-10-08  Eli Zaretskii  <eliz@gnu.org>

	Fix horizontal scrolling during Isearch

	* lisp/isearch.el (isearch-update): Compute the window's body
	width in a way that is correct when there are no fringes.
	(Bug#24584)

2016-10-08  Eli Zaretskii  <eliz@gnu.org>

	Fix infloop in redisplay due to truncated lines and invisible text

	* src/xdisp.c (forward_to_next_line_start): Don't call
	'get_next_display_element' after finding the end of line.  This
	avoids setting the row's end position to the wrong value when the
	next screen line begins with invisible text; that wrong value
	caused set_cursor_from_row position the cursor in the wrong screen
	line, and eventually triggered bug#24109.

2016-10-07  David Engster  <deng@randomsample.de>

	gitmerge: Add cherry pick to gitmerge-skip-regexp

	* admin/gitmerge.el (gitmerge-skip-regexp): Add "cherry picked
	from commit", which is the string appended by 'git cherry-pick
	-x'.

	(cherry picked from commit f648e4866981b142fca788372e1fd9013a0bb16a)

2016-10-06  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'menu-bar-open'

	* lisp/term/w32-win.el (w32-menu-bar-open): Clarify that sometimes
	two ESC keypresses are needed to exit the menu.

	* doc/emacs/screen.texi (Menu Bar): Qualify the description of how
	to exit menus.  (Bug#24596)

2016-10-06  Eli Zaretskii  <eliz@gnu.org>

	Fix compilation with MinGW runtime 3.22.2 and w32api 3.18.2

	* nt/inc/ms-w32.h (_WIN32_WINNT) [!MINGW_W64]: Undefine before
	defining to avoid redefinition warnings.

	* nt/inc/sys/stat.h (_SYS_STAT_H, _INC_STAT_H): Define, to avoid
	inclusion of sys/stat.h from the system headers, which could then
	lead to compilation errors due to redefinition of 'struct stat'
	etc.  This is needed because latest versions of MinGW runtime
	include sys/stat.h from wchar.h.

	* src/image.c (__MINGW_MAJOR_VERSION) [WINDOWSNT]: Temporarily
	redefine to 4 to avoid conflict between 2 definitions of
	MemoryBarrier.  (Bug#24613)

	Do not merge to master!

2016-10-05  John Wiegley  <johnw@newartisans.com>

	Add documentation note from Alex

2016-10-05  Aurelien Aptel  <aaptel@suse.com>

	* src/alloc.c: call only non-null finalizers

2016-10-04  Karl Fogel  <kfogel@red-bean.com>

	Clarify that doc fixes are okay in feature freeze

	* CONTRIBUTE (branches): Explain that doc fixes are always safe, even
	on a release branch in feature freeze.  Tweak wording of paragraph
	after that to avoid a misleading contrast.

2016-10-04  Eli Zaretskii  <eliz@gnu.org>

	Avoid crashes when setting the cursor

	* src/xdisp.c (display_and_set_cursor): Don't index glyphs of a
	glyph row if hpos is out of valid bounds.  This avoids crashes in
	some rare cases.  (Bug#24614)

2016-10-04  Philippe Vaucher  <philippe.vaucher@gmail.com>

	Restore 'command-debug-status' functionality

	* src/callint.c (Fcall_interactively): Bind command-debug-status
	to nil.  This restores functionality inadvertently removed in
	Emacs 25.1.  (Bug#24555)

	* lisp/subr.el (command-debug-status): Declare obsolete.

	* doc/lispref/debugging.texi (Internals of Debugger): Document
	that 'command-debug-status' is obsolete.

2016-10-03  Karl Fogel  <kfogel@red-bean.com>

	Document yank behavior in the right place

	* lisp/simple.el (yank): Document the handling of the
	`yank-handled-properties' and `yank-excluded-properties' variables,
	and the `yank-handler' text property.
	(yank-pop): Refer to `yank' now (bug#286)

	* lisp/subr.el (insert-for-yank): Refer to `yank' now.
	(insert-for-yank-1): Refer to `insert-for-yank' now.

	See this thread for discussion:

	  https://lists.gnu.org/r/emacs-devel/2016-09/threads.html#00329
	  From: Karl Fogel
	  To: Emacs Devel
	  Subject: Question about intended behavior of 'insert-for-yank-1'.
	  Date: Mon, 12 Sep 2016 00:17:14 -0500
	  Message-ID: <874m5lr92d.fsf@red-bean.com>

2016-10-03  Philipp Stephani  <phst@google.com>

	Document nil args of compare-buffer-substrings

	* src/editfns.c (Fcompare_buffer_substrings): Document behavior when
	the arguments are nil.

2016-10-03  Katsumi Yamaoka  <yamaoka@jpl.org>

	* doc/misc/message.texi (Bcc Warning): Fix markup.

	* doc/misc/message.texi (Bcc Warning):
	Document mml-secure-safe-bcc-list.

2016-10-02  Noam Postavsky  <npostavs@gmail.com>

	Don't require isearch-update before isearch-done

	It is useful to be able to call `isearch-done' unconditionally to
	ensure a non-isearching state.

	* lisp/isearch.el (isearch-done): Check that `isearch--current-buffer'
	is a live buffer before using it (Bug #21091).
	* test/automated/isearch-tests.el (isearch--test-done): Test it.

	(cherry picked from commit 68f4b5292781bc331b040105c4079902b993835c)

2016-10-02  Peder O. Klingenberg  <peder@klingenberg.no>

	Avoid error in icalendar--read-element

	* lisp/calendar/icalendar.el (icalendar--read-element): Avoid a regex
	stack overflow by not using regex to extract values from calendar
	events. (Bug#24315)

	(cherry picked from commit 55dde6c1a21a792d3d75c19e612c74dd054aaf1e)

2016-10-02  Lars Ingebrigtsen  <larsi@gnus.org>

	Make a menu less ambiguous

	* doc/emacs/custom.texi (Key Bindings): The Modifier Keys node
	is about using modifier keys, not binding them (bug#10942).

	(cherry picked from commit 214f85a0a68b96a552ca605d601b33f6eef5c4ca)

2016-10-02  Devon Sean McCullough  <Emacs-Hacker2012@jovi.net>

	Doc fix for url-http

	* lisp/url/url-http.el (url-http): Document better return values
	  (bug#13187) (tiny change)

	(cherry picked from commit 344303c8d9cb03d4778a73940e80e966280aa694)

2016-10-01  Eli Zaretskii  <eliz@gnu.org>

	* lisp/frame.el (blink-cursor-delay): Doc fix.  (Bug#24372)

2016-09-30  Katsumi Yamaoka  <yamaoka@jpl.org>

	* lisp/gnus/gnus-art.el (gnus-button-handle-library): Fix typo.

2016-09-27  Paul Eggert  <eggert@cs.ucla.edu>

	Regexp Functions doc minor fixes

	* doc/lispref/searching.texi (Regexp Functions):
	Fix misspelling of “matching”.  Use @table for table.
	Reformat code example to fit into info file width (Bug#17862).

2016-09-27  Katsumi Yamaoka  <yamaoka@jpl.org>

	Backport mm-convert-shr-links fix from master (bug#23964)

	* lisp/gnus/mm-decode.el (mm-convert-shr-links):
	Preserve key bindings that shr adds (bug#23964).

2016-09-26  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'expand-abbrev' and wrapper hooks

	* lisp/simple.el (filter-buffer-substring-functions)
	(buffer-substring--filter): Add a link to 'with-wrapper-hook' as
	the place to look for documentation of wrapper hooks.
	* lisp/minibuffer.el (completion-in-region-functions)
	(completion--in-region): Add a link to 'with-wrapper-hook' as the
	place to look for documentation of wrapper hooks.
	* lisp/abbrev.el (expand-abbrev, abbrev--default-expand): Clarify
	the doc strings.  (Bug#24540)

	* doc/lispref/text.texi (Buffer Contents): Mention
	'with-wrapper-hook's doc string as the place to learn about that
	obsolete facility.

2016-09-25  Eli Zaretskii  <eliz@gnu.org>

	Minor copyedits of MS-Windows installation instructions

	* nt/INSTALL:
	* nt/README.W32: Add URL of Emacs dependencies on alpha.gnu.org.

2016-09-23  Eli Zaretskii  <eliz@gnu.org>

	Fix display of cursor when 'blink-cursor-delay' has small value

	* lisp/frame.el (blink-cursor-check, blink-cursor-mode):
	Protect ourselves against too small values of blink-cursor-delay.
	This avoids erratic display of the cursor, or even failure to
	display it, when user types text at high speed or leans on a key
	to invoke the keyboard auto-repeat feature.  (Bug#24372)

2016-09-23  Eli Zaretskii  <eliz@gnu.org>

	Improve the doc string of 'format'

	* src/editfns.c (Fformat): Fix ambiguity in the doc string's usage
	of a literal period.  (Bug#24407)

	This was backported from master
	(cherry picked from commit 7123896626b06c26c4e37839ab41e41980c8f433)

2016-09-23  Eli Zaretskii  <eliz@gnu.org>

	Improve doc strings in whitespace.el

	* lisp/whitespace.el (whitespace-mode, whitespace-newline-mode)
	(global-whitespace-mode, global-whitespace-newline-mode): Improve
	the doc strings.  (Bug#24413)

	This was backported from master
	(cherry picked from commit 3462fe73351f3da5bc3ebf8296ee44dd2e6b1dbc)

2016-09-23  Eli Zaretskii  <eliz@gnu.org>

	Improve detectability of 'next-logical-line' and 'previous-logical-line'

	* lisp/simple.el (next-line, previous-line): Mention
	'next-logical-line' and 'previous-logical-line' in the doc
	strings.  (Bug#24443)

	This was backported from master
	(cherry picked from commit e95d0d15bb1534803b0adb3c3a927c8beb7d4e79)

2016-09-23  Martin Rudalics  <rudalics@gmx.at>

	Fix (next-frame nil t) crash (Bug#24281)

	* src/frame.c (candidate_frame): Check minibuf argument before
	comparing it to zero (Bug#24281).

	This was backported from master
	(cherry picked from commit dc491c3df305a73908fe8de20b7c428a5b38c846)

2016-09-23  Noam Postavsky  <npostavs@gmail.com>

	Fix debugging of string-match-p errors

	* src/eval.c (call_debugger): Bind inhibit-changing-match-data to nil so
	that debugger code that needs to do regexp match won't break
	(Bug #23949, Bug #24166, Bug#16294).

	This was backported from master
	(cherry picked from commit 7fb75680b38fe0805c2ff7e9cca3bec8121ba984)

2016-09-23  Eli Zaretskii  <eliz@gnu.org>

	Fix region display while dragging mouse

	* lisp/mouse.el (mouse-drag-track): Reset deactivate-mark in the
	buffer of the drag event, to allow mark to be set and the region
	be shown as we drag the mouse.  (Bug#24030)

	This was backported from master
	(cherry picked from commit 7d58b02f363ab02961faa950d1ba727df96f2f19)

2016-09-23  Eli Zaretskii  <eliz@gnu.org>

	Fix 'vertical-motion' and 'posn-at-point' under 'visual-line-mode'

	* src/xdisp.c (move_it_in_display_line_to): Don't assume we can
	wrap on a whitespace character if it's followed by another
	whitespace character.  When returning under WORD_WRAP for a screen
	line that is continued, restore to wrap point when atpos/atx
	position would be displayed on the next screen line due to
	line-wrap.  (Bug#23570)

	This is backported from master
	(cherry picked from commit 99848b37d2c3e14c0af45fc6da437a806aa58a80)

2016-09-23  Paul Eggert  <eggert@cs.ucla.edu>

	Improve display of tex-verbatim and Info quoted

	Problem reported by Glenn Morris (Bug#19889).
	* doc/emacs/display.texi (Standard Faces):
	* doc/lispref/display.texi (Basic Faces):
	* etc/NEWS: Mention fixed-pitch-serif.
	* lisp/faces.el (face-font-family-alternatives):
	New family alias Monospace Serif.
	(fixed-pitch-serif): New face, which uses the new family.
	* lisp/info.el (Info-quoted):
	* lisp/textmodes/tex-mode.el (tex-verbatim): Use the new face.
	* test/automated/font-parse-tests.el (font-parse-tests--data):
	Add test case for Monospace Serif.

	This is backport from master
	(cherry picked from commit 36906806ccfc0e53f1d8c365ab0d7151288b7833)

2016-09-23  Lars Ingebrigtsen  <larsi@gnus.org>

	Document how to check for ImageMagick support

	* doc/lispref/display.texi (ImageMagick Images): Say how to
	check for ImageMagick support, which isn't quite obvious
	(bug#20702).

	This is backport from master
	(cherry picked from commit faf07d646575c78d6d956ce91820ebbf38308553)

2016-09-23  Tino Calancha  <f92capac@gmail.com>

	Run find-function-after-hook after finding a symbol

	* lisp/emacs-lisp/find-func.el (find-library):
	* lisp/help-mode.el (help-function-def, help-variable-def):
	Run `find-function-after-hook' inside the help-function of the
	buttons (bug#22583).
	* etc/NEWS: Mention the change.

	This is a backport from master.
	(cherry picked from commit f069d854508946bcc03e4c77ceb430748e3ab6d7)

2016-09-23  Eli Zaretskii  <eliz@gnu.org>

	Document 'timerp'

	* doc/lispref/os.texi (Timers): Document 'timerp'.  (Bug#24511)
	Improve indexing.

2016-09-23  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of overlay priorities

	* doc/lispref/display.texi (Overlay Properties): Minor copyedits.
	By popular demand, mention the '(PRIMNARY . SECONDARY)' form of
	overlay properties used for the region.  (Bug#20253)

2016-09-23  Eli Zaretskii  <eliz@gnu.org>

	Fix 'dired-compress-files'

	* lisp/dired-aux.el (dired-do-compress-to): Make sure the archive
	file name is fully expanded by running it through
	'expand-file-name'.  Suggested by Drew Adams <drew.adams@oracle.com>.
	(Bug#24486)  Doc fix.
	* lisp/dired.el: Regenerated changes in autoloads.

2016-09-23  Eli Zaretskii  <eliz@gnu.org>

	Update commentary of STRING_CHAR and FETCH_MULTIBYTE_CHAR

	* src/character.h (STRING_CHAR):
	* src/buffer.h (FETCH_MULTIBYTE_CHAR): Update commentary: these
	two macros no longer do any character unification, so the caveats
	in those comments are no longer pertinent.

2016-09-23  Eli Zaretskii  <eliz@gnu.org>

	Increment Emacs version to 25.1.50

	* README:
	* configure.ac:
	* etc/NEWS:
	* msdos/sed2v2.inp: Bump the version to 25.1.50.

2016-09-21  Eli Zaretskii  <eliz@gnu.org>

	Document the optional zlib library in MS-Windows builds

	* nt/README.W32:
	* nt/INSTALL.W64:
	* nt/INSTALL: Mention the optional text decompression support and
	the zlib library.

2016-09-21  Eli Zaretskii  <eliz@gnu.org>

	Fix tagging of DEFUN by etags

	* lib-src/etags.c (C_entries): Tag DEFUN twice: once with its C
	name, and then again with its Lisp name.  This restores the
	ability to find Lisp primitives by their C name, which was lost
	when the etags back-end was switched to a more strict search
	criteria.

	* test/etags/ETAGS.good_1:
	* test/etags/ETAGS.good_2:
	* test/etags/ETAGS.good_3:
	* test/etags/ETAGS.good_4:
	* test/etags/ETAGS.good_5:
	* test/etags/ETAGS.good_6:
	* test/etags/CTAGS.good: Adapt to the changes in etags.c wrt
	tagging DEFUN.

2016-09-21  Eli Zaretskii  <eliz@gnu.org>

	Avoid resetting track-mouse by mouse clicks

	* lisp/mouse.el (mouse-drag-line, mouse-drag-track): Don't assume
	the previous value of track-mouse is nil; instead, save and
	restore the previous value.  (Bug#24480)

2016-09-20  Eli Zaretskii  <eliz@gnu.org>

	Improve nt/README.W32 instructions

	* nt/README.W32: Add instructions for installing 64-bit builds of
	optional libraries.  (Bug#24470)

2016-09-17  Eli Zaretskii  <eliz@gnu.org>

	Document that desktop file overrides frame parameters

	* doc/emacs/misc.texi (Saving Emacs Sessions):
	* doc/emacs/frames.texi (Frame Parameters): Document that frame
	parameters restored by desktop.el take precedence over the
	customizations in the init file, and explain how to countermand
	that.  For the details of the issue, see
	https://lists.gnu.org/r/emacs-devel/2016-09/msg00318.html.

2016-09-15  Nicolas Petton  <nicolas@petton.fr>

	* etc/AUTHORS: Regenerate the AUTHORS file

2016-09-16  Nicolas Petton  <nicolas@petton.fr>

	* Version 25.1 released.

2016-09-15  Nicolas Petton  <nicolas@petton.fr>

	* etc/AUTHORS: Regenerate the AUTHORS file

2016-09-15  Eli Zaretskii  <eliz@gnu.org>

	Update admin/authors.el

	* admin/authors.el (authors-fixed-entries): Add an entry for Bob
	Weiner.

2016-09-14  Eli Zaretskii  <eliz@gnu.org>

	Update Antinews in ELisp manual

	* doc/lispref/anti.texi (Antinews): Update for Emacs 25.1.
	* doc/lispref/elisp.texi (Top): Update the main menu entry for
	Antinews.

2016-09-11  Noam Postavsky  <npostavs@gmail.com>

	Fix comments on window height macros

	* src/window.h (WINDOW_MODE_LINE_HEIGHT, WINDOW_HEADER_LINE_HEIGHT): Fix
	confusing claim that "height is in pixels and in lines"; in fact it's in
	pixels.

2016-09-10  Toke Høiland-Jørgensen  <toke@toke.dk>  (tiny change)

	Fix 'url-http-create-request' when cookies are used

	* lisp/url/url-http.el (url-http-create-request): Make sure the
	cookie headers are a unibyte string.  For the details, see
	https://lists.gnu.org/r/emacs-devel/2016-09/msg00202.html.

2016-09-08  Martin Rudalics  <rudalics@gmx.at>

	Fix cross reference in frames.texi

	* doc/lispref/frames.texi (Minibuffers and Frames): Fix cross
	reference.

2016-09-04  immerrr  <immerrr@gmail.com>

	Fix regexp-opt documentation (bug #17862)

	* lisp/emacs-lisp/regexp-opt.el (regexp-opt):
	* doc/lispref/searching.texi (Regexp Functions): Update PAREN doc.

2016-08-31  Nicolas Richard  <youngfrog@members.fsf.org>

	* lisp/emacs-lisp/gv.el (gv-ref): Fix example of PLACE in docstring.

2016-08-27  Noam Postavsky  <npostavs@gmail.com>

	Fix tags-query-replace docstring

	* lisp/progmodes/etags.el (tags-query-replace): Remove incorrect info
	regarding non-existent parameters.

2016-08-26  Eli Zaretskii  <eliz@gnu.org>

	Clarify documentation of precision in format specs

	* doc/lispref/strings.texi (Formatting Strings): Be less
	definitive wrt what precision means in format specs other than
	floating-point, %s and %S.  (Bug#24314)

2016-08-24  Eli Zaretskii  <eliz@gnu.org>

	Improve and clarify documentation of subprocesses

	* doc/lispref/processes.texi (Subprocess Creation, Shell Arguments):
	Mention 'make-process' rather than 'start-process'.  Update wrt
	standard destinations of standard output/error streams and due to
	different formats of arguments accepted by 'make-process'.
	(Processes): Mention process objects that represent connections.
	(Synchronous Processes): Minor clarifications.
	(Asynchronous Processes): Describe 'make-process' and
	'make-pipe-process' before 'start-process'.  Update and expand the
	documentation.
	(Deleting Processes, Process Information, Input to Processes)
	(Signals to Processes, Query Before Exit, Network): Update and
	expand the documentation, especially wrt process objects that
	represent connections.
	(Output from Processes): Mention the possibility of separating
	stderr via 'make-process'.
	(Filter Functions): Mention that stderr by default arrives at the
	filter function together with stdout.  (Bug#24287)

	* src/process.c (Fprocess_id, Fprocess_command)
	(Fprocess_contact, Fprocess_type, Fstop_process): Doc fixes for
	process objects that represent connections.

2016-08-23  Paul Eggert  <eggert@cs.ucla.edu>

	* etc/PROBLEMS: Mention gnutls-cli 3.5.3 (Bug#24247).

2016-08-21  Nicolas Petton  <nicolas@petton.fr>

	* etc/AUTHORS: Update the AUTHORS file

2016-08-20  Philipp Stephani  <phst@google.com>

	Some assorted documentation clarifications

	* src/fileio.c (Fwrite_region): Clarify that END is ignored if
	START is nil.
	* src/editfns.c (Fbuffer_size): Add short discussion about
	narrowing.
	* src/callproc.c (Fcall_process_region): Discuss behavior when
	START and END are not buffer positions.

2016-08-18  Eli Zaretskii  <eliz@gnu.org>

	Improve commentary in src/character.h

	* src/character.h (BYTES_BY_CHAR_HEAD, MULTIBYTE_LENGTH)
	(MULTIBYTE_LENGTH_NO_CHECK, STRING_CHAR_AND_LENGTH): Remove stale
	info from commentary and improve it.

2016-08-17  Dmitry Gutov  <dgutov@yandex.ru>

	* etc/NEWS: Mention the change in json-encode-string.

	The change was made to fix bug#20154, and came up again in bug#24239.

2016-08-16  Eli Zaretskii  <eliz@gnu.org>

	* src/doc.c (Fsubstitute_command_keys): Another fix for smart quotes.

	(Bug#24206)

2016-08-16  Eli Zaretskii  <eliz@gnu.org>

	Avoid segfaults due to quoting in 'substitute-command-keys'

	* src/doc.c (Fsubstitute_command_keys): Correct character counts
	when the input string is unibyte.  (Bug#24206)

2016-08-16  Martin Rudalics  <rudalics@gmx.at>

	In NEWS describe new handling of window margins (Bug#24193)

	* etc/NEWS: Describe new handling of margins when splitting or
	resizing windows (Bug#24193).

2016-08-16  Martin Rudalics  <rudalics@gmx.at>

	Facultatively ignore margins when splitting and resizing windows (Bug#24193)

	Provide a new window parameter 'min-margins' which allows to
	ignore the actual widths of a window's margins when splitting or
	resizing that window horizontally.  This should serve as a
	workaround for handling the problems raised by Bug#24193.

	* lisp/window.el (window--min-size-1): Handle new window
	parameter 'min-margins'.
	(split-window): Fix text of error messages.
	* doc/lispref/windows.texi (Window Parameters): Describe new
	parameter 'min-margins'.

2016-08-14  Noam Postavsky  <npostavs@gmail.com>

	Document CATEGORY arg to modify-category-entry

	* src/category.c (Fmodify_category_entry): Document CATEGORY argument.

2016-08-13  Noam Postavsky  <npostavs@gmail.com>

	Document char-script-table's effect on word motion

	* doc/lispref/positions.texi (Word Motion): Talk about
	char-script-table (Bug #10494).

2016-08-13  Eli Zaretskii  <eliz@gnu.org>

	Further fix for 'url-http-create-request' and multibyte strings

	* lisp/url/url-http.el (url-http-create-request): Run
	url-mime-charset-string through url-http--encode-string.
	(Bug#24117)

2016-08-13  Noam Postavsky  <npostavs@gmail.com>

	Fix docstring of eval-expression

	* lisp/simple.el (eval-expression): Fix the docstring to reflect the
	fact that the prefix argument does not affect formatting for
	integers (Bug #20691).

2016-08-11  Eli Zaretskii  <eliz@gnu.org>

	Clarify when 'cursor' property is in effect

	* doc/lispref/text.texi (Special Properties): Minor copyedits.
	(Bug#24179)

2016-08-11  Dmitry Gutov  <dgutov@yandex.ru>

	Convert the remaining strings to unibyte before concatenating

	* lisp/url/url-http.el (url-http--encode-string): New function.
	(url-http-create-request): Use it to convert ASCII to unibyte.
	(Bug#24117)

2016-08-11  Eli Zaretskii  <eliz@gnu.org>

	Fix bug with handling the bidi cache

	* src/xdisp.c (redisplay_window): Save and restore the state of
	the bidi cache before reusing the iterator after calls to
	try_window and try_window_reusing_current_matrix.

2016-08-10  Eli Zaretskii  <eliz@gnu.org>

	* doc/lispref/text.texi (Change Hooks): Minor copyedits.

2016-08-09  Eli Zaretskii  <eliz@gnu.org>

	Clarify documentation of before/after-change-functions

	* doc/lispref/text.texi (Change Hooks): Clarify that the hooks are
	not called in balanced pairs.

2016-08-06  Noam Postavsky  <npostavs@gmail.com>

	Document use of vectors in keymaps

	* doc/lispref/keymaps.texi (Format of Keymaps): Mention vector
	format (Bug #14797).

2016-08-03  Alan Third  <alan@idiocy.org>

	Post AppDefined events from the main thread ONLY (bug#23934)

	* src/nsterm.h: Make nextappdefined var not just GNUStep.
	* src/nsterm.m (ns_send_appdefined, sendFromMainThread): Remove GNUStep

2016-08-03  John Wiegley  <johnw@newartisans.com>

	Update to the AUTHORS file for Bob Weiner

		* etc/AUTHORS: Update the packages attributed to Bob Weiner

2016-08-02  John Wiegley  <johnw@newartisans.com>

	Revert "Fix local printer set to left aligned string formatter."

	This reverts commit 8a38e948b039516e70176ebe20c5349e2ade6ac5.

2016-08-02  John Wiegley  <johnw@newartisans.com>

	Revert "Fix ses-delete-blanks to delete only blanks + documentation."

	This reverts commit 3c97b0f7589e06aeb1ab0147f0ee32974c32926d.

2016-08-02  John Wiegley  <johnw@newartisans.com>

	Revert "Fix English."

	This reverts commit b275cc76f0c5ab49e81445fcc3420c8772aefd42.

2016-08-01  Eli Zaretskii  <eliz@gnu.org>

	Improve doc strings of 'gud-gdb' and 'gdb'

	* lisp/progmodes/gdb-mi.el (gdb):
	* lisp/progmodes/gud.el (gud-gdb): Doc fix.  (Bug#24125)

2016-08-01  Eli Zaretskii  <eliz@gnu.org>

	Fix doc string of 'minibuffer-message-timeout'

	* src/keyboard.c (syms_of_keyboard) <minibuffer-message-timeout>:
	Doc fix.  (Bug#24123)

2016-07-29  Vincent Belaïche  <vincentb1@users.sourceforge.net>

	Fix English.

	* doc/misc/ses.texi (Nonrelocatable references): Fix grammatically
	  incorrect English.

2016-07-29  Vincent Belaïche  <vincentb1@users.sourceforge.net>

	Fix ses-delete-blanks to delete only blanks + documentation.

	* doc/misc/ses.texi (Quick Tutorial): Mention the '!'
	'ses-range' modifier as an alternative to 'ses+'.
	(Advanced Features): Add a refernce to node 'Nonrelocatable
	references' concerning function 'ses-rename-cell'.
	(Standard formula functions): Mention the '!' 'ses-range'
	modifier as an alternative to 'ses-delete-blanks'.
	(More on cell printing): Fix fallback printer
	definition.  Minor editorial formatting changes.
	(Nonrelocatable references): Document the use of
	'ses-rename-cell' as a better way to make cell reference
	non-relocatable.
	(The data area): Document the presence of local printer
	definitions in the data area.

	* lisp/ses.el (ses-delete-blanks): Do not remove
	*error*.  Any error in an argument should propagate into the
	using formula rather than being silently hidden !

2016-07-29  Noam Postavsky  <npostavs@gmail.com>

	profiler: document prefix arg for tree expansion

	* doc/lispref/debugging.texi (Profiling):
	* lisp/profiler.el (profiler-report-toggle-entry): Document use of
	prefix argument to expand whole call trees.

2016-07-29  Noam Postavsky  <npostavs@gmail.com>

	Clarify usage of eshell-visual-options

	* lisp/eshell/em-term.el (eshell-visual-options): Add second option to
	example usage (Bug #19627).

2016-07-29  Noam Postavsky  <npostavs@gmail.com>

	Fix comment in files-in-below-directory

	* doc/lispintro/emacs-lisp-intro.texi (Files List): Comment should not
	say append, since the code is adding to front of list (Bug #21589).

2016-07-28  Vincent Belaïche  <vincentb1@users.sourceforge.net>

	Fix local printer set to left aligned string formatter.

	* lisp/ses.el (ses-local-printer-compile): Add missing case
	for left-aligned string formatter.

2016-07-24  Nicolas Petton  <nicolas@petton.fr>

	Bump Emacs version to 25.1 for the first RC

	* README:
	* configure.ac:
	* lisp/ldefs-boot.el:
	* msdos/sed2v2.inp: Bump Emacs version to 25.1.

2016-07-24  Nicolas Petton  <nicolas@petton.fr>

	* etc/AUTHORS: Update the AUTHORS file

	;; * ChangeLog.2: ChangeLog update.

2016-07-24  Nicolas Petton  <nicolas@petton.fr>

	* admin/authors.el (authors-valid-file-names): Addition.

2016-07-23  Eli Zaretskii  <eliz@gnu.org>

	Warn about Cairo-related problems

	* etc/NEWS: Warn about known problems in the Cairo build.
	(Bug#23925)

2016-07-23  Paul Pogonyshev  <pogonyshev@gmail.com>

	Don't let completion break `declare' handling

	* lisp/progmodes/elisp-mode.el (elisp-completion-at-point): Fix to not alter
	`defun-declarations-alist' by side effect (Bug #23648).

2016-07-23  Noam Postavsky  <npostavs@gmail.com>

	Adjust match data before calling after-change-funs

	It's important to adjust the match data in between calling
	before-change-functions and after-change-functions, so that buffer
	change hooks will always see match-data consistent with buffer content.
	(Bug #23917)

	* src/insdel.c (replace_range): Add new parameter ADJUST_MATCH_DATA, if
	true call update_search_regs.  Update all callers (except
	Freplace_match) to pass 0 for the new parameter.
	* src/search.c (update_search_regs): New function, extracted from
	Freplace_match.
	(Freplace_match): Remove match data adjustment code, pass 1 for
	ADJUST_MATCH_DATA to replace_range instead.

2016-07-21  Mark Oteiza  <mvoteiza@udel.edu>

	Do not show string-rectangle preview if minibuffer is empty

	* lisp/rect.el (rectangle--string-preview): Remove condition that sets
	preview string to the default replacement string.

2016-07-21  Achim Gratz  <Stromeko@nexgo.de>

	* etc/PROBLEMS: Add entry about selection problems under Plasma 5.

	Bug#24013

2016-07-21  Paul Eggert  <eggert@cs.ucla.edu>

	Port to glibc 2.24 (pre-release) + ppc64

	Backport from master (Bug#24033).
	Inspired by a suggestion by Florian Weimer in:
	https://sourceware.org/ml/libc-alpha/2016-07/msg00425.html
	* src/emacs.c (main) [__PPC64__]:
	Special case for __PPC64__, which needs ASLR disabled in
	dumped Emacs too.

2016-07-21  Katsumi Yamaoka  <yamaoka@jpl.org>

	* lisp/net/shr.el (shr-fill-line): Withdraw the last commit (4157159).

	* lisp/net/shr.el (shr-fill-line):
	Preserve text properties in folded lines (bug#24034).

2016-07-17  Robert Cochran  <robert-git@cochranmail.com>  (tiny change)

	Expand FIXME near definition of fboundp

	This expansion of the FIXME is so that future developers are aware of
	the potential problems of aliasing fboundp to symbol-function without
	taking backwards compatibility into account.

	* src/data.c (fboundp): Note potential backwards compatibility issues in
	FIXME.

2016-07-17  Noam Postavsky  <npostavs@gmail.com>

	kill-rectangle should mention killed-rectangle

	* lisp/rect.el (kill-rectangle): Mention `killed-rectangle' in docstring
	and warning message, rather than kill ring (Bug#19773).

2016-07-16  Eli Zaretskii  <eliz@gnu.org>

	Avoid assertion violations in nhexl-mode

	* src/bidi.c (bidi_resolve_neutral): Convert an assertion to real
	code executed in all builds.  (Bug#24001)

2016-07-15  Fredrik Bergroth  <fbergroth@gmail.com>  (tiny change)

	Use memmove instead of memcpy on overlapping regions

	* src/editfns.c (Ftranspose_regions): Regions may overlap, so
	use memmove instead of memcpy (bug#19213).


	This is a backport from trunk.
	(cherry picked from commit 354f9f0fc6cc05ed98883447f9b2f37943d79160)

2016-07-15  Noam Postavsky  <npostavs@gmail.com>

	Document buffer-swap-text+save-excursion interaction

	* doc/lispref/buffers.texi (Swapping Text):
	* src/buffer.c (Fbuffer_swap_text): Add warning about interaction of
	`buffer-swap-text' and `save-excursion' (Bug #4655).

2016-07-14  Stefan Monnier  <monnier@iro.umontreal.ca>

	Fix eieio vs cl-generic incompatibilities found in Rudel (bug#23947)

	* lisp/emacs-lisp/cl-generic.el (cl-generic-apply): New function.
	* lisp/emacs-lisp/eieio-compat.el (eieio--defmethod): Fix incorrect
	mapping between cl-no-applicable-method and EIEIO's no-applicable-method.
	* lisp/emacs-lisp/eieio-core.el (eieio--class-precedence-c3):
	`class' is not a symbol but a class object.

2016-07-14  Stefan Monnier  <monnier@iro.umontreal.ca>

	Include cl-generic in package--builtin-versions (bug#22817)

	* lisp/emacs-lisp/cl-generic.el (package--builtin-versions):
	Add ourselves manually.  Don't merge since there's a better fix on master.

2016-07-14  Michael Albinus  <michael.albinus@gmx.de>

	Improve timing in `tramp-test29-environment-variables'

	* test/automated/tramp-tests.el
	(tramp-test--shell-command-to-string-asynchronously):
	Add additional `accept-process-output' call.
	(tramp-test29-environment-variables): Remove additional sleep calls.

2016-07-14  Michael Albinus  <michael.albinus@gmx.de>

	Add test for handling environment variables in Tramp

	* test/automated/tramp-tests.el
	(tramp-test--shell-command-to-string-asynchronously): New defun.
	(tramp-test29-environment-variables): New test.
	(tramp-test30-vc-registered)
	(tramp-test31-make-auto-save-file-name)
	(tramp-test32-special-characters)
	(tramp-test32-special-characters-with-stat)
	(tramp-test32-special-characters-with-perl)
	(tramp-test32-special-characters-with-ls, tramp-test33-utf8)
	(tramp-test33-utf8-with-stat, tramp-test33-utf8-with-perl)
	(tramp-test33-utf8-with-ls)
	(tramp-test34-asynchronous-requests)
	(tramp-test35-recursive-load, tramp-test36-unload): Rename.

2016-07-13  Glenn Morris  <rgm@gnu.org>

	* lisp/emacs-lisp/package.el (describe-package-1)
	(package-status-external): Fix face references.  (Bug#23927)

2016-07-12  Stephen Berman  <stephen.berman@gmx.net>

	Improve documentation of search functions

	Make the documentation of the search functions more accurate,
	complete, and uniform; in particular, extend the description of
	the effect when the 'count' parameter is a negative number to all
	of these functions.

	* src/search.c (Fsearch_backward, Fsearch_forward)
	(Fre_search_backward, Fre_search_forward)
	(Fposix_search_backward, Fposix_search_forward):
	* lisp/isearch.el (word-search-backward, word-search-forward)
	(word-search-backward-lax, word-search-forward-lax): Improve doc
	strings as described above.

	* doc/lispref/searching.texi (String Search, Regexp Search)
	(POSIX Regexps): Use 'count' instead of 'repeat' as the name of
	the fourth parameter of the *-search-{forward,backward} functions
	and improve documentation as described above.

2016-07-12  Michael Albinus  <michael.albinus@gmx.de>

	Delete environment variables in Tramp when needed

	* lisp/net/tramp-sh.el (tramp-get-env-with-u-option): New defun.
	(tramp-sh-handle-start-file-process)
	(tramp-sh-handle-process-file, ): Use it.  (Bug#23952)

2016-07-12  Eli Zaretskii  <eliz@gnu.org>

	Add "New in Emacs 25" section to the FAQ

	* doc/misc/efaq.texi (Latest version of Emacs): Update for later
	versions.
	(New in Emacs 25): New node.
	(Status of Emacs): Add it to the menu.

2016-07-10  Eli Zaretskii  <eliz@gnu.org>

	Fix 'vertical-motion' in non-interactive sessions

	* src/indent.c (Fvertical_motion): Don't return uninitialized
	value in non-interactive session.  This fixes random errors in
	batch mode, see
	https://lists.gnu.org/r/emacs-devel/2016-06/msg00609.html
	and
	https://lists.gnu.org/r/emacs-devel/2016-07/msg00500.html
	for the details.

2016-07-10  Andreas Schwab  <schwab@linux-m68k.org>

	Fix memory leak in imagemagick-types

	* src/image.c (Fimagemagick_types): Use AcquireExceptionInfo to
	avoid memory leak.

2016-07-10  Eli Zaretskii  <eliz@gnu.org>

	Update ELisp manual to match 'string-collate-equalp' doc string

	* doc/lispref/strings.texi (Text Comparison): Remove reference to
	sorting from the description of 'string-collate-equalp'.  (Bug#23902)

2016-07-09  Noam Postavsky  <npostavs@gmail.com>

	Clarify docstring of find-feature-regexp

	* lisp/emacs-lisp/find-func.el (find-feature-regexp): Explain that `%s'
	is optional (Bug #23520).

2016-07-09  Noam Postavsky  <npostavs@gmail.com>

	Add details to cl-lib defining macros' docstrings

	* lisp/emacs-lisp/cl-macs.el (cl-defun, cl-defmacro): Add terse summary
	of supported arglist forms (Bug #22462).

2016-07-09  Eli Zaretskii  <eliz@gnu.org>

	Clarify doc string of 'save-buffer'

	* lisp/files.el (save-buffer): Clarify that backups might not be
	made even if this command is invoked with 2 or 3 "C-u"s.
	(Bug#3702)

2016-07-08  Eli Zaretskii  <eliz@gnu.org>

	Un-confuse doc string of 'string-collate-equalp'

	* src/fns.c (Fstring_collate_equalp): Remove confusing text from
	doc string.  (Bug#23902)

2016-07-07  Eli Zaretskii  <eliz@gnu.org>

	Clarify documentation of 'mouse-on-link-p'

	* lisp/mouse.el (mouse-on-link-p): Clarify the form of the POS
	argument.  (Bug#23899)

2016-07-06  Phillip Lord  <phillip.lord@russet.org.uk>

	Fix missing undo-boundary on revert-buffer.

	* lisp/simple.el (undo-auto--undoable-change-no-timer): New function.
	* src/fileio.c (insert-buffer-contents): Call
	  undo-auto--undoably-changed-buffers before changes.

	Addresses Bug#23785.

	Do not merge to master as c98bc98 also addresses the same bug.

2016-07-06  Martin Rudalics  <rudalics@gmx.at>

	Amend last addition to etc/PROBLEMS

	* etc/PROBLEMS: Mention GTK+ problem with unexpected frame widenings

2016-07-06  Paul Eggert  <eggert@cs.ucla.edu>

	Fix open-network-stream responsiveness

	Problem reported by Christer Ekholm (Bug#23864).
	Backport from master.
	* src/process.c (wait_reading_process_output):
	Fix typo introduced in 2015-07-06T02:19:13Z!eggert@cs.ucla.edu
	when wait == INFINITY and got_output_end_time is invalid.
	In this case the code should break, not continue.

2016-07-05  Phillip Lord  <phillip.lord@russet.org.uk>

	Fix missing point information in undo

	* src/undo.c (record_insert): Use record_point instead of
	  prepare_record, and do so unconditionally.
	  (prepare_record): Do not record first change.
	  (record_point): Now conditional on state before the last command.
	  (record_delete): Call record_point unconditionally.
	  (record_property_change): Use prepare_record.
	  (record_marker_adjustments): Use prepare_record.

	Addresses Bug# 21722

2016-07-04  Eli Zaretskii  <eliz@gnu.org>

	Avoid crashes when buffer modification hooks clobber match data

	* src/search.c (Freplace_match): Error out if buffer modification
	hooks triggered by buffer changes in replace_range, upcase-region,
	and upcase-initials-region clobber the match data needed to be
	adjusted for the replacement.  (Bug#23869)

2016-07-03  Noam Postavsky  <npostavs@gmail.com>

	Note combine-and-quote-strings doesn't shell quote

	* doc/lispref/processes.texi (Shell Arguments):
	* lisp/subr.el (combine-and-quote-strings): Add a note that
	combine-and-quote-strings doesn't protect arguments against shell
	evaluation (Bug #20333).

2016-07-03  Noam Postavsky  <npostavs@gmail.com>

	Explain when package-initialize isn't called

	* doc/lispref/os.texi (Startup Summary): Explain that package-initialize
	is not called when options -q, -Q, or --batch were passed (Bug #19151).

2016-07-03  Noam Postavsky  <npostavs@gmail.com>

	Fix escaping in sh-indent-after-continuation docstr

	* lisp/progmodes/sh-script.el (sh-indent-after-continuation): Properly
	escape backslashes in docstring (Bug#23046).

2016-07-02  Eli Zaretskii  <eliz@gnu.org>

	Clarify the documentation of back-references in replacements

	* doc/emacs/search.texi (Regexp Replace): Clarify that \D starts
	with \1, not \0.

	* lisp/replace.el (query-replace-regexp)
	(query-replace-regexp-eval, replace-regexp): Doc fix (Bug#23884)

2016-07-01  Noam Postavsky  <npostavs@gmail.com>

	Clarify lexical binding with symbol args behavior

	* doc/lispref/variables.texi (Lexical Binding): Clarify that symbol
	arguments always refer to dynamic values (Bug #23781).  Remove mention
	of obsolete restriction regarding lexical binding for defun and
	defmacro, this no longer applies since 61b108cc 2012-05-29 "*
	lisp/emacs-lisp/byte-run.el (defmacro, defun): Move from C...".

2016-06-30  Michael Albinus  <michael.albinus@gmx.de>

	* lisp/net/tramp-sh.el (tramp-remote-path): Doc fix.

2016-06-29  Eli Zaretskii  <eliz@gnu.org>

	* lisp/net/tramp-sh.el (tramp-remote-path): Doc fix.  (Bug#23865)

2016-06-29  Eli Zaretskii  <eliz@gnu.org>

	Avoid assertion violations when rendering some fonts

	* src/dispextern.h (FONT_TOO_HIGH): Don't consider a font "too
	high" if its pixel_size value is zero.  This avoids assertion
	violations at the end of x_produce_glyphs.

2016-06-28  Noam Postavsky  <npostavs@gmail.com>

	Document more details of package activation

	* doc/emacs/package.texi (Package Installation): Explain that package
	activation adds to load-path (Bug #21704).

2016-06-28  Noam Postavsky  <npostavs@gmail.com>

	Fixup warning message regarding HOME a bit more

	* src/w32.c (init_environment): The manual section title is "Windows
	HOME" (Bug #11612).  Move newline so warning fits in 80 character lines.

2016-06-27  Eli Zaretskii  <eliz@gnu.org>

	* lisp/leim/quail/indian.el ("bengali-probhat"): Change indicator to BngPB.

2016-06-27  Michael Albinus  <michael.albinus@gmx.de>

	Fix input method "probhat" for Bengali

	Author: উৎসব রায় <uroybd@gmail.com>

	* lisp/leim/quail/indian.el ("bengali-probhat"): Fix entry.

2016-06-27  Noam Postavsky  <npostavs@gmail.com>

	Add to elisp-completion-at-point's docstring

	* lisp/progmodes/elisp-mode.el (elisp-completion-at-point): Document
	position dependent behavior (Bug #19854).

2016-06-27  Noam Postavsky  <npostavs@gmail.com>
	    Eli Zaretskii  <eliz@gnu.org>

	Give more helpful warning about setting HOME

	* src/w32.c (init_environment): Improve warning message that pops when
	Emacs sets HOME according to existence of C:\.emacs (Bug #11612).

2016-06-26  Eli Zaretskii  <eliz@gnu.org>

	Fix slow redisplay in term-mode

	* lisp/term.el (term-mode): Move the setting of
	bidi-paragraph-direction from 'ansi-term' to here, since term-mode
	is also affected.  Do not merge to master, since there the problem
	is solved in bidi.c by changing the regexps that delimit a
	paragraph.  (Bug#23801)

2016-06-26  উৎসব রায়  <uroybd@gmail.com>

	New input method "probhat" for Bengali

	* lisp/leim/quail/indian.el ("probhat"): New input method.
	(Bug#23822)

	* etc/NEWS: Mention the new input method.

2016-06-25  Noam Postavsky  <npostavs@gmail.com>
	    Drew Adams  <drew.adams@oracle.com>

	Update docs for `customize-mode'

	* lisp/cus-edit.el (customize-mode): This function works with both major
	and minor modes, make docstring and prompt reflect that (Bug #23649).

	* doc/lispref/modes.texi (Derived Modes): Remove note about
	customize-mode being experimental; it has been around since Emacs
	22 (Bug #11299).

2016-06-23  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of 'assoc-string' and 'compare-strings'

	* src/minibuf.c (Fassoc_string): Clarify how CASE-FOLD affects the
	string comparison.  (Bug#23833)
	* src/fns.c (Fcompare_strings): Fix the description of how
	IGNORE-CASE affects the comparison.

	* doc/lispref/strings.texi (Text Comparison): Clarify how
	CASE-FOLD affects the string comparison in 'assoc-string'.  Fix
	the description of how IGNORE-CASE affects the comparison in
	'compare-strings'.

2016-06-22  Dmitry Gutov  <dgutov@yandex.ru>

	Error on multibyte characters in HTTP request

	* lisp/url/url-http.el (url-http-create-request): Check the
	constructed request in the end to verify that it does not contain
	multibyte characters (bug#23750).

2016-06-22  Katsumi Yamaoka  <yamaoka@jpl.org>

	* lisp/gnus/mm-decode.el (mm-convert-shr-links):
	Mask keys that launch `widget-button-click' (bug#22157).

2016-06-22  Dmitry Gutov  <dgutov@yandex.ru>

	Unset GIT_DIR when calling Git commands

	* lisp/vc/vc-git.el (vc-git--call, vc-git-command):
	Unset GIT_DIR (bug#23769).

2016-06-21  Phillip Lord  <phillip.lord@russet.org.uk>

	Ensure undo-boundary after insert-file-contents.

	* src/fileio.c: Record undoable change during insert-file-contents.

	Addresses Bug #23785.

2016-06-21  Eli Zaretskii  <eliz@gnu.org>

	Clarify documentation of 'line-spacing' and 'line-height'

	* doc/lispref/display.texi (Line Height): Clarify how the line
	height is determined via variables and text properties.  (Bug#23806)

2016-06-20  Eli Zaretskii  <eliz@gnu.org>

	Fix removal of variables from process-environment

	* src/callproc.c (add_env): Fix comparison of a variable with a
	value against the same variable without a value.  (Bug#23779)

2016-06-20  Glenn Morris  <rgm@gnu.org>

	* admin/authors.el (authors-ignored-files, authors-valid-file-names)
	(authors-renamed-files-alist): Additions.

	* admin/authors.el (authors-aliases, authors-fixed-case): Additions.

2016-06-18  Noam Postavsky  <npostavs@gmail.com>

	Fix documentation of completion functions

	So that the described behavior matches the code (and docstrings).

	* doc/lispref/minibuf.texi (Basic Completion): Symbol keys of hash table
	collections are used like string keys, not ignored (Bug #10416).

2016-06-18  Eli Zaretskii  <eliz@gnu.org>

	Clarify documentation of 'font-lock-maximum-decoration'

	* doc/emacs/display.texi (Font Lock): Explain how to make the
	customization of 'font-lock-maximum-decoration' effective for an
	existing buffer.  (Bug#23783)

2016-06-17  Glenn Morris  <rgm@gnu.org>

	* doc/misc/cl.texi (Usage): Add some more details.

2016-06-17  Noam Postavsky  <npostavs@gmail.com>

	Fbackward_prefix_chars: stay within buffer bounds

	The commit 1fd3172d "(Fbackward_prefix_chars): Set point properly while
	scanning" (1998-03-18), moved the check against of the position against the
	buffer beginning out the loop condition so that we might end up checking
	the syntax of characters before the beginning of the buffer.  This can
	cause segfaults or trigger a "Point before start of properties" error in
	`update_interval' (called indirectly from `char_quoted').

	* src/syntax.c (Fbackward_prefix_chars): Stop the loop when beginning of
	buffer is reached (Bug #3552, Bug #17132, Bug #19379).

2016-06-16  Paul Eggert  <eggert@cs.ucla.edu>

	Fix ifdef-vs-if typo with RANDR13_LIBRARY

	* src/xfns.c (x_get_monitor_attributes_xrandr): Use #if, not #ifdef.
	This ports to systems that predate xrandr 1.3. See Christian Lynbech in:
	https://lists.gnu.org/r/emacs-devel/2016-06/msg00198.html

	(cherry picked from commit dce99f222f1ca33265cd56ddb157817be1dc078e)

2016-06-16  Stephen Berman  <stephen.berman@gmx.net>

	Fix last todo-mode change

	* lisp/calendar/todo-mode.el (todo-read-category): Return the
	keymap in order to use its defined key bindings.

2016-06-15  Stephen Berman  <stephen.berman@gmx.net>

	Improve last todo-mode fix

	* lisp/calendar/todo-mode.el (todo-read-category): Use
	set-keymap-parent instead of copy-keymap, and default (as
	previously) to the global binding (for rationale, see
	https://lists.gnu.org/r/emacs-devel/2016-06/msg00217.html).

2016-06-14  Stephen Berman  <stephen.berman@gmx.net>

	Fix todo-mode use of minibuffer completion keymap (bug#23695).

	* lisp/calendar/todo-mode.el (todo-read-category): Don't
	override minibuffer-local-completion-map globally (bug#23695).
	Bind <SPC> key to self-insert-command.

2016-06-14  Glenn Morris  <rgm@gnu.org>

	* src/alloc.c (ALIGN): Avoid error on DragonFly BSD.  (Bug#23764)

	* lisp/emacs-lisp/nadvice.el (advice--make-docstring):
	Avoid mangling autoloads with unspecified arguments.  (Bug#21299)

2016-06-13  Glenn Morris  <rgm@gnu.org>

	* lisp/help-fns.el (describe-function-1): Avoid reporting advised
	autoloads as aliases.  (Bug#21299)

2016-06-13  Stephen Berman  <stephen.berman@gmx.net>

	Minor grammar fix (bug#23746)

	* doc/lispref/processes.texi (Synchronous Processes):
	Another minor grammar fix (bug#23746).

2016-06-13  Stephen Berman  <stephen.berman@gmx.net>

	Doc fixes for grammar and typos (bug#23746)

	* doc/emacs/files.texi (Customize Save):
	* doc/emacs/frames.texi (Window Dividers):
	* doc/emacs/misc.texi (Printing):
	* doc/lispref/compile.texi (Compiler Errors):
	* doc/lispref/keymaps.texi (Changing Key Bindings):
	* doc/lispref/loading.texi (Named Features):
	* doc/lispref/markers.texi (Marker Insertion Types):
	* doc/lispref/modes.texi (Mode Hooks):
	* doc/lispref/text.texi (Undo):
	* src/floatfns.c (Fldexp):
	* src/xfaces.c (syms_of_xfaces):
	Minor doc fixes for grammar and typos (bug#23746).

2016-06-13  Eli Zaretskii  <eliz@gnu.org>

	* doc/lispref/processes.texi (Process Buffers): Minor rewording.  (Bug#23446)

2016-06-13  Eli Zaretskii  <eliz@gnu.org>

	Add cross-reference to ELisp manual

	* doc/lispref/commands.texi (Classifying Events): Add
	cross-reference to "Motion Events".  (Bug#23756)

2016-06-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/emacs-lisp/macroexp.el (macroexp--expand-all): Fix (bug#19704)

	Don't rewrite (funcall 'f ...) to (f ...).

2016-06-11  Phillip Lord  <phillip.lord@russet.org.uk>

	Restore initial undo boundary with viper

	* lisp/emulation/viper-cmd.el (viper-adjust-undo): Add back last undo
	  boundary if it has been removed.

	Addresses Bug#22295.

2016-06-11  Phillip Lord  <phillip.lord@russet.org.uk>

	Revert "Fix viper undo breakage from undo-boundary changes"

	This reverts commit c0139e32f1f3bb287b04e02a69a7848d6a040003.

2016-06-11  Ken Brown  <kbrown@cornell.edu>

	Fix dbus crash on 32-bit Cygwin

	* src/dbusbind.c (Fdbus__init_bus): Use make_save_pointer to store
	connection address.  (Bug#23741)
	(xd_lisp_dbus_to_dbus): Use XSAVE_POINTER to retrieve connection
	address.

2016-06-10  Nicolas Petton  <nicolas@petton.fr>

	Bump version to 25.0.95

	* README:
	* configure.ac:
	* lisp/ldefs-boot.el:
	* msdos/sed2v2.inp: Bump Emacs version to 25.0.95.

2016-06-10  Nicolas Petton  <nicolas@petton.fr>

	* etc/AUTHORS: Update the AUTHORS file

2016-06-10  Nicolas Petton  <nicolas@petton.fr>

	add entries to authors.el

	* admin/authors.el (authors-renamed-files-alist): Add char-fold files.

2016-06-10  Jules Tamagnan  <jtamagnan@gmail.com>

	Fix eldoc-related freezes in python mode

	* lisp/progmodes/python.el (python-eldoc-get-doc): New defvar.
	(python-eldoc-function-timeout)
	(python-eldoc-function-timeout-permanent): New defcustoms.
	(python-eldoc-function): If python-eldoc--get-doc-at-point times
	out, effectively turn off ElDoc in current buffer.  (Bug#23609)

2016-06-09  Martin Rudalics  <rudalics@gmx.at>

	Handle mouse leaving initial window in `mouse-set-region' (Bug#23707)

	* lisp/mouse.el (mouse-set-region): If the mouse ends up in
	another window or on the menu bar, use `window-point' of
	selected window instead of `posn-point' of the event end
	(Bug#23707).

2016-06-08  Marco Wahl  <marcowahlsoft@gmail.com>

	org.el: Fix bindings of < and > for calendar scrolling

	[This patch taken from upstream Org repo with 8b63dc9 dated
	2014-10-20 (Bug#23725).]
	* lisp/org/org.el (org-read-date-minibuffer-local-map):
	Switch to the current calendar API for scrolling the calendar.

2016-06-08  Phillip Lord  <phillip.lord@russet.org.uk>

	Fix undo boundary in recursive edit (Bug#23632)

	 * src/keyboard.c (recursive_edit_1): specbind
	   undo-auto--undoably-changed-buffers.
	 * lisp/simple.el (undo-auto--undoably-changed-buffers):
	   fix docstring.

2016-06-07  Glenn Morris  <rgm@gnu.org>

	Doc fixes re alist-get.  (Bug#23548)

	* lisp/subr.el (alist-get): Doc fix.
	* doc/lispref/lists.texi (Association Lists): Improve alist-get.

2016-06-07  Glenn Morris  <rgm@gnu.org>

	* lisp/progmodes/python.el (inferior-python-mode):
	Avoid tabs.  (Bug#23616)

	* src/syntax.c (syms_of_syntax) <comment-end-can-be-escaped>: Doc fix.

2016-06-07  Tino Calancha  <f92capac@gmail.com>

	* lisp/help-fns.el (describe-function-1):
	Fix handling of file name for aliases.  (Bug#21950)

	* lisp/emacs-lisp/cl-macs.el (cl-loop): Doc fix re "by".

	* doc/misc/cl.texi (Mapping over Sequences): Fix cl-notevery.

2016-06-07  Paul Eggert  <eggert@cs.ucla.edu>

	Fix crash in syntax.c after GC

	Problem reported by Vincent Belaïche (Bug#23704).
	* src/syntax.c (skip_chars): Recompute pointers into the
	buffer after every call to update_syntax_table_forward,
	as it can GC.

2016-06-06  Dmitry Gutov  <dgutov@yandex.ru>

	Improve squiggly heredoc support in non-SMIE Ruby mode

	* lisp/progmodes/ruby-mode.el (ruby-parse-partial): Support
	squiggly heredocs here, too (port from upstream).

2016-06-06  Stephen Berman  <stephen.berman@gmx.net>

	Fix doc string quoting

	* lisp/files.el (shell-quote-wildcard-pattern):
	* lisp/progmodes/vhdl-mode.el (vhdl-mode):
	* lisp/subr.el (replace-regexp-in-string):
	* lisp/view.el (view-mode):
	* src/nsfns.m (syms_of_nsfns):
	* src/syntax.c (Fbackward_prefix_chars):
	Fix quoting problems in doc strings (Bug#23696).

2016-06-05  Martin Rudalics  <rudalics@gmx.at>

	Fix mouse dragging of vertical dividers with scroll bars on left (Bug#23690)

	* lisp/mouse.el (mouse-drag-line): With scroll bars on the left
	adjust trailing edge of window on the left when dragging the
	vertical divider of the mode line.  (Bug#23690)

2016-06-04  Eli Zaretskii  <eliz@gnu.org>

	* etc/PROBLEMS: Mention the link-time problems on FreeBSD 11.

	(Bug#23641)

2016-05-31  Glenn Morris  <rgm@gnu.org>

	* test/automated/viper-tests.el (viper-test-undo-kmacro):
	Delete temp-file at end.

	* lisp/mail/footnote.el (footnote-mode): Fix doc typo.

	* doc/misc/smtpmail.texi (Encryption): Fix 2012-12-22 typo.

	* lisp/emacs-lisp/lisp-mode.el (lisp--mode-syntax-table):
	Fix typo.  (Bug#23654)

2016-05-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/recentf.el (recentf-dialog-mode-map): Remove follow-link (bug#22434)

2016-05-30  Bill Wohler  <wohler@newt.com>

	Correct cl-flet usage (Bug#22317)

	* lisp/mh-e/mh-compat.el: Rename mh-cl-flet to mh-flet and convert alias to
	macro using patch from Katsumi Yamaoka <yamaoka@jpl.org>.
	* lisp/mh-e/mh-thread.el (mh-thread-set-tables):
	* lisp/mh-e/mh-show.el (mh-gnus-article-highlight-citation):
	* lisp/mh-e/mh-mime.el (mh-display-with-external-viewer):
	(mh-mime-display, mh-press-button, mh-push-button):
	(mh-display-emphasis): Call mh-flet instead of mh-cl-flet.

2016-05-30  Bill Wohler  <wohler@newt.com>

	Release MH-E manual version 8.6

	* doc/misc/mh-e.texi (VERSION, EDITION, UPDATED, UPDATE-MONTH):
	Update for release 8.6.

2016-05-30  Mike Kupfer  <m.kupfer@acm.org>

	Update MH-E's documentation about HTML renderers

	* doc/misc/mh-e.texi (HTML): Remove the footnote with the minimum Gnus
	version (we are no longer trying to support multiple Emacs
	releases). Sort the table of HTML renderers by name (the previous
	ordering was based on a 10-year-old survey). Add shr and gnus-w3m to
	the table. Remove the entry for w3 (no longer available).  Update
	existing entries so that they are more consistent about what features
	are discussed, and to reflect recent testing (Debian 8). Small tweaks
	to existing text.

2016-05-30  Dmitry Gutov  <dgutov@yandex.ru>

	Fx the we->the typo

	* doc/emacs/trouble.texi (Sending Patches):
	Fix the typo (bug#23657).

2016-05-30  Paul Eggert  <eggert@cs.ucla.edu>

	Restore frames into the current display by default

	* lisp/desktop.el (desktop-restore-in-current-display):
	Default to t, not nil (Bug#23604).
	* etc/NEWS: Mention the change.

2016-05-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/recentf.el (recentf-open-files-item): Quick fix for (bug#22434).

	etc/TODO: Remove out-of-place issue

2016-05-29  Eli Zaretskii  <eliz@gnu.org>

	Clarify doc string of 'file-name-sans-extension'

	* lisp/files.el (file-name-sans-extension, file-name-extension):
	Clarify in the doc strings what is the extension, and which
	leading period doesn't count.  (Bug#23643)

2016-05-28  Eli Zaretskii  <eliz@gnu.org>

	Fix the MSDOS build

	* msdos/sed1v2.inp (PAXCTL_dumped, PAXCTL_notdumped): Define to
	empty, and remove the lines which use them in recipes, as that
	causes weird error message from Make and breaks the MSDOS build.

2016-05-28  Andreas Schwab  <schwab@linux-m68k.org>

	* lisp/progmodes/elisp-mode.el (elisp-function-argstring): Call
	substitute-command-keys to undo help--docstring-quote. (Bug#23634)

2016-05-27  Eli Zaretskii  <eliz@gnu.org>

	* src/dired.c (Ffile_name_all_completions): Doc fix.  (Bug#23631)

2016-05-27  Eli Zaretskii  <eliz@gnu.org>

	Fix infloop in 'number-sequence'

	* lisp/subr.el (number-sequence): Avoid overflow leading to an
	infloop.  (Bug#23627)

	* test/automated/subr-tests.el (number-sequence-test): New test.

2016-05-26  Glenn Morris  <rgm@gnu.org>

	* lisp/emacs-lisp/find-func.el (find-function-library):

	Update for symbol-function no longer erroring.  (Bug#23626)

2016-05-26  Glenn Morris  <rgm@gnu.org>

	* lisp/w32-fns.el (set-message-beep, w32-get-locale-info)
	(w32-get-valid-locale-ids): Improve declarations.

2016-05-26  Vincent Belaïche  <vincentb1@users.sourceforge.net>

	Correct old cell name unbinding when renaming cell.

	Bug is to unbind old cell names when renaming a cell with
	'makunbound'. when the old cell name is of A1 type, then
	'kill-local-variable' must be used instead, so that only the current
	spreadsheet is affected. When the old cell name is a renamed cell,
	then 'ses--unbind-cell-name' must be used in order to remove the old
	name from the name hashmap.

	* lisp/ses.el (ses-rename-cell): check consistency of cell symbol from
	text-property and from array object. Instead of 'makunbound', use
	either 'ses--unbind-cell-name' or 'kill-local-variable' depending on
	whether the cell old name is a named cell or an A1 type cell

2016-05-25  Vincent Belaïche  <vincentb1@users.sourceforge.net>

	Document problem: slow screen refresh on missing font.

	See discussion of bug#22519 for more on this.

2016-05-25  Glenn Morris  <rgm@gnu.org>

	* admin/admin.el (add-release-logs): Basic check of existing ChangeLog.

2016-05-25  Glenn Morris  <rgm@gnu.org>

	* build-aux/gitlog-to-emacslog: Handle empty generated ChangeLog.

	This is relevant for M-x add-release-logs right after M-x authors.

2016-05-25  Glenn Morris  <rgm@gnu.org>

	* admin/admin.el (add-release-logs): Generate ChangeLog if needed.

2016-05-25  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/misc/texinfo.tex: Revert previous change (Bug#23611).

2016-05-25  Glenn Morris  <rgm@gnu.org>

	* admin/authors.el (authors): First update the ChangeLog.

	* admin/make-tarball.txt: Related updates.

2016-05-24  Dmitry Gutov  <dgutov@yandex.ru>

	Rename vc-stay-local back to vc-cvs-stay-local

	* lisp/vc/vc-cvs.el (vc-cvs-stay-local): Rename back from
	vc-stay-local (bug#19548).  Improve the docstring.
	(vc-cvs-stay-local-p): Update accordingly.

2016-05-24  Glenn Morris  <rgm@gnu.org>

	* doc/emacs/files.texi (Comparing Files):
	* doc/emacs/trouble.texi (Sending Patches): Fix external xrefs.

	* doc/misc/eww.texi (Advanced): Fix xref.

2016-05-24  Eli Zaretskii  <eliz@gnu.org>

	Fix cross-references between manuals

	* doc/misc/viper.texi (Viper Specials):
	* doc/misc/url.texi (Tramp):
	* doc/misc/sem-user.texi (Smart Jump):
	* doc/lispintro/emacs-lisp-intro.texi (Finding More):
	* doc/misc/efaq.texi (Replacing text across multiple files): Fix
	cross-references between manuals.  (Bug#23612)
	* doc/lispintro/emacs-lisp-intro.texi (etags): Node deleted: no
	longer relevant to Emacs Lisp programming.

2016-05-24  Glenn Morris  <rgm@gnu.org>

	* doc/misc/vhdl-mode.texi (Sample Init File): Rename node to avoid ".".

	* admin/admin.el (add-release-logs): Also update etc/HISTORY.

2016-05-24  Eli Zaretskii  <eliz@gnu.org>

	Avoid aborting due to errors in arguments of 'set-face-attribute'

	* src/xfaces.c (Finternal_set_lisp_face_attribute): Check the
	FRAME argument before using it.  This avoids gratuitous aborts in
	Emacs built with --enable-checking when the luser was unlucky
	enough to get the argument list in wrong order.

2016-05-23  Phillip Lord  <phillip.lord@russet.org.uk>

	Add automated test for viper-tests.el

2016-05-23  Phillip Lord  <phillip.lord@russet.org.uk>

	Fix viper undo breakage from undo-boundary changes

	* lisp/simple.el (undo-auto-disable-boundaries): New variable
	* lisp/emulation/viper-init.el (viper-undo-in-complex-command,
	  viper-undo-needs-adjustment): Rename
	  variable to reflect new purpose,
	  (viper-buffer-undo-list-mark): Remove
	* lisp/emulation/viper-cmd.el (viper-set-complex-command-for-undo):
	  Add undo using `undo-boundary', disable default undo-boundary
	  addition.
	* lisp/emulation/viper-cmd.el
	  (viper-complete-complex-command-for-undo,viper-adjust-undo):
	  Change function name, remove old undo list manipulation.
	* lisp/emulation/viper-cmd.el (viper-undo,viper-repeat,
	  viper-change-state-to-vi,viper-change-state):
	  Update for function name change.

	Addresses Bug #22295

2016-05-22  Kaushal Modi  <kaushal.modi@gmail.com>

	Fix reference to obsolete fn ps-eval-switch

	lpr-eval-switch is functionally the same as ps-eval-switch,
	which was obsoleted in 2cdeb903c57126d3ad5f0cbd72e182584b76ee29.
	So use that instead (Bug#19717).
	* lisp/printing.el (pr-switches): Use lpr-eval-switch instead of
	ps-eval-switch.

2016-05-22  Paul Eggert  <eggert@cs.ucla.edu>

	Do not trash symlinks to init file

	If the user’s init file is a symbolic link, do not break the link
	when initializing the package system.  Problem reported by Jackson
	Hamilton (Bug#23050).
	* lisp/emacs-lisp/package.el (package--ensure-init-file):
	Bind find-file-visit-truename when visiting the init file, and
	save and restore the buffer name the way cus-edit does in a
	similar situation (Bug#454).

2016-05-22  Alan Mackenzie  <acm@muc.de>

	Don't print the "decomposition" line for control chars in what-cursor-position

	This is a temporary workaround for bug #23594, where the decomposition line
	for linefeed corrupted the display on a Linux virtual terminal.

	* lisp/descr-text.el (describe-char): Remove `decomposition' from the list of
	character code properties printed for control characters.

2016-05-22  Paul Eggert  <eggert@cs.ucla.edu>

	Bring back xterm pasting with middle mouse

	Problem reported by Jan Synáček.
	Solution suggested by Stefan Monnier (Bug#23519).
	* lisp/isearch.el (isearch-mode-map): Add a binding for xterm-paste.
	(xterm--pasted-text): New decl.
	(isearch-xterm-paste): New function.
	* lisp/term/xterm.el (xterm--pasted-text): New function,
	taken from xterm-paste internals.
	(xterm-paste): Use it.

2016-05-22  Eli Zaretskii  <eliz@gnu.org>

	Provide workaround for xftfont rendering problem

	* src/xftfont.c (syms_of_xftfont) <xft-font-ascent-descent-override>:
	New variable.
	(xftfont_open): Use it to work around problems with rendering some
	fonts.  (Bug#23360)

2016-05-21  Jun Hao  <jun_hao@aol.com>

	* lisp/desktop.el: Disable restore frameset if in non-graphic display.

	(Bug#17693)

2016-05-21  Eli Zaretskii  <eliz@gnu.org>

	Mention GTK+ problems in etc/PROBLEMS

	* etc/PROBLEMS (GDK_SCALE, GDK_DPI_SCALE): Mention the possible
	problems this could create and the workaround.  (Bug#23587)

2016-05-20  Artur Malabarba  <bruce.connor.am@gmail.com>

	* lisp/emacs-lisp/package.el (package-refresh-contents):

	Don't change the value of `package-check-signature'.
	(package-check-signature): Use `epg-find-configuration'
	instead of `executable-find'.

2016-05-20  Daiki Ueno  <ueno@gnu.org>

	Revert "epg: Add a way to detect gpg1 executable for tests"

	This reverts commit d4ae6d7033b34e8b75c59aaf1584131e439ef2d5.

2016-05-19  Eli Zaretskii  <eliz@gnu.org>

	Avoid errors with Czech and Slovak input methods

	* lisp/leim/quail/slovak.el (slovak, slovak-prog-1, slovak-prog-2)
	(slovak-prog-3): Remove the kp-* key bindings, they are not needed
	and cause errors in "C-u C-x =".
	* lisp/leim/quail/czech.el (czech, czech-qwerty, czech-prog-1)
	(czech-prog-2, czech-prog-3): Remove the kp-* key bindings.
	(Bug#23559)

2016-05-19  Daiki Ueno  <ueno@gnu.org>

	epg: Add a way to detect gpg1 executable for tests

	Fixes bug#23561.

	* test/automated/epg-tests.el
	(epg-tests-program-alist-for-passphrase-callback): New
	constant.
	(epg-tests-find-usable-gpg-configuration): New function,
	renamed from `epg-tests-gpg-usable'.  All callers changed.
	(epg-tests-gpg-usable): Remove.

	* lisp/epg-config.el (epg-config--program-alist): Factor out
	constructor element to...
	(epg-config--configuration-constructor-alist): ...here.
	(epg-find-configuration): Rename FORCE argument to NO-CACHE,
	and add PROGRAM-ALIST argument.

2016-05-18  Artur Malabarba  <bruce.connor.am@gmail.com>

	* lisp/emacs-lisp/package.el: Fix free variable warnings.

	(package--with-response-buffer): Replace two usages of
	`macroexp-let2*' with `let'.

2016-05-18  Artur Malabarba  <bruce.connor.am@gmail.com>

	* lisp/emacs-lisp/package.el (package--with-response-buffer):

	Fix some macro locals leaking into body.  (Bug#22440)

	* test/automated/package-test.el (package-test-signed):
	Manually check all possible values of `package-check-signature'.

2016-05-18  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'server-name'

	* doc/emacs/misc.texi (Emacs Server): Fix example of setting
	'server-name'.  Mention how to do that with daemon sessions.
	(Bug#23576)

2016-05-18  Paul Eggert  <eggert@cs.ucla.edu>

	Modernize ASLR advice in etc/PROBLEMS

	* etc/PROBLEMS (Segfault during 'make'): Modernize advice for
	seccomp, Docker, and NetBSD (Bug#23529).

2016-05-17  Juri Linkov  <juri@linkov.net>

	* lisp/char-fold.el: Rename from character-fold.el.

	* lisp/replace.el (replace-char-fold): Rename from replace-character-fold.
	* test/automated/char-fold-tests.el: Rename from character-fold-tests.el.
	https://lists.gnu.org/r/emacs-devel/2015-12/msg00529.html

2016-05-17  Nicolas Petton  <nicolas@petton.fr>

	Bump version to 25.0.94

	* README:
	* configure.ac:
	* msdos/sed2v2.inp: Bump Emacs version to 25.0.94.

2016-05-17  Nicolas Petton  <nicolas@petton.fr>

	etc/AUTHORS: Update the AUTHORS file

2016-05-16  Alan Third  <alan@idiocy.org>

	Fix bug#23462: Crash when iconifying frame on OS X.

	* src/nsterm.m (x_iconify_frame): Block input while miniaturize is
	running.

2016-05-16  Paul Eggert  <eggert@cs.ucla.edu>

	Avoid shrinking windows with Gtk+ 3.20.3

	Problem reported by Matthias Clasen (Bug#23144).
	This was fixed in a different way in master.
	Do not merge to master.
	* src/xterm.c (handle_one_xevent) [GTK_CHECK_VERSION (3, 20, 3)]:
	Do not call xg_frame_resized in the MapNotify case.

2016-05-16  Eli Zaretskii  <eliz@gnu.org>

	Fix bug in default setting of 'ps-paper-type'

	* lisp/international/mule-cmds.el (set-locale-environment): Don't
	inherit the value of locale from previous examination of different
	environment variables, which didn't look at LC_PAPER, and so using
	that value would effectively ignore the setting of LC_PAPER.
	(Bug#23544)

2016-05-13  Paul Eggert  <eggert@cs.ucla.edu>  (tiny change)

	Properly reject malformed or empty package sigs

	Problem report and fix by Lizzie Dixon (Bug#23513).
	* lisp/emacs-lisp/package.el (package--check-signature-content):
	Report an error if no good signatures OR if a fatal error.  Not AND.

2016-05-13  Paul Eggert  <eggert@cs.ucla.edu>

	Remove buggy non-native image scrolling

	This never worked, and could cause infinite recursion.
	Problem reported by Glenn Morris (Bug#22465).
	* lisp/xwidget.el (xwidget-webkit-scroll-behavior): Remove.
	All uses removed.

2016-05-13  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/misc/texinfo.tex: Sync from gnulib.

2016-05-12  Glenn Morris  <rgm@gnu.org>

	* lisp/emacs-lisp/find-func.el (find-feature-regexp)
	(find-alias-regexp): Fix :version.

2016-05-11  Dmitry Gutov  <dgutov@yandex.ru>

	Do not mistake colon at the end of regexp for slash symbol

	* lisp/progmodes/ruby-mode.el (ruby-syntax-propertize):
	Check the parse state in the "Symbols with special characters"
	rule (bug#23515).

2016-05-11  Dmitry Gutov  <dgutov@yandex.ru>

	Make package-install-from-buffer not move point

	* lisp/emacs-lisp/package.el (package-install-from-buffer):
	Use save-excursion here (bug#22616).

2016-05-11  Dmitry Gutov  <dgutov@yandex.ru>

	Redo the fix for bug#21839

	* lisp/help.el (help-add-fundoc-usage): Undo the previous change.
	(help--make-usage-docstring): Escape newlines when printing.

	* lisp/emacs-lisp/cl-macs.el (cl--transform-lambda):
	Ditto (bug#21839).

2016-05-10  Dmitry Gutov  <dgutov@yandex.ru>

	Don't treat JS spread as contination method call

	* lisp/progmodes/js.el (js--indent-operator-re):
	Allow only one dot (bug#23492).

	* test/indent/js.js (default): Add a corresponding example.

2016-05-09  Dmitry Gutov  <dgutov@yandex.ru>

	Allow newlines inside cl function arglists

	* lisp/help.el (help-add-fundoc-usage): Allow newlines inside
	ARGLIST (bug#21839).

2016-05-09  Dmitry Gutov  <dgutov@yandex.ru>

	Publicize cl--generic-all-functions

	* lisp/emacs-lisp/cl-generic.el (cl-generic-all-functions):
	Rename from cl--generic-all-functions.  Update both callers.

	* lisp/cedet/semantic/db-el.el
	(semanticdb-find-tags-external-children-of-type-method):
	And use it here (bug#23042).

2016-05-09  Alan Mackenzie  <acm@muc.de>

	Add some "safe-local-variable" declarations for compatibility with master.

	These enable C files from the master repository to be visited in Emacs 25
	without generating irritating questions about configuration variable safety.

	* lisp/progmodes/cc-vars.el: (c-string-list-p, c-string-or-string-list-p): New
	functions.
	(c-noise-macro-names, c-noise-macro-with-parens-names): give the
	safe-local-variable property c-string-list-p.
	(c-macro-names-with-semicolon): give the safe-local-variable property
	c-string-or-string-list-p.

2016-05-09  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix doc string in `insert'

	* src/editfns.c (Finsert_and_inherit): The before-insertion
	markers do not move.
	(Finsert): Ditto.

2016-05-08  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/misc/emacs-mime.texi (time-date): Document now-builtins better.

2016-05-07  Dmitry Gutov  <dgutov@yandex.ru>

	Say 'All results processed' at the end

	* lisp/progmodes/xref.el (xref--query-replace-1):
	Say 'All results processed' at the end if the user hadn't
	cancelled the process (bug#23284).

2016-05-07  Eli Zaretskii  <eliz@gnu.org>

	Document automatic adjustment of process' logical window dimensions

	* doc/lispref/processes.texi (Process Buffers): Document
	'set-process-window-size' and
	'window-adjust-process-window-size-function'.

	* etc/NEWS: Mention the new functionality and variable.

	* src/process.c (Fset_process_window_size): Improve the doc string.

2016-05-06  Michael Albinus  <michael.albinus@gmx.de>

	tramp-sh.el: Work around a stat bug (backport from master)

	* lisp/net/tramp-sh.el (tramp-get-remote-stat): Do not use
	stat versions which produce shell quoted output.  See also
	coreutils Bug#23422.

	(cherry picked from commit 6aad36ace9953b9672b13be68416d205532d5e59)

2016-05-05  Paul Eggert  <eggert@cs.ucla.edu>

	Doc fixes for fclist and grep

	A newline is needed between two fc-list calls.
	egrep and fgrep have been withdrawn from POSIX,
	so document grep -E and grep -F instead.

2016-05-05  Paul Eggert  <eggert@cs.ucla.edu>

	Minor doc fixes for quoting

	* doc/lispref/control.texi (Signaling Errors):
	* doc/lispref/display.texi (Displaying Messages):
	Don’t say that formats “generate”.  Try to word more clearly.
	* etc/NEWS: Coalesce near-duplicate entries.

2016-05-05  Dmitry Gutov  <dgutov@yandex.ru>

	`nreverse' the marker pairs list

	* lisp/progmodes/xref.el (xref--buf-pairs-iterator): `nreverse'
	the marker pairs list for each buffer before returning.

2016-05-04  Dmitry Gutov  <dgutov@yandex.ru>

	Use save-excursion in xref-location-marker more

	* lisp/progmodes/elisp-mode.el (xref-location-marker): Use
	save-excursion, in order not to alter the value of point if the
	buffer is currently open in the background (problem reported by
	Robert Weiner).

	* lisp/progmodes/etags.el (xref-location-marker): Same.

2016-05-04  Dmitry Gutov  <dgutov@yandex.ru>

	shell-quote-argument DIR when appropriate

	* lisp/progmodes/project.el (project-file-completion-table):
	`shell-quote-argument' DIR as well.

	* lisp/progmodes/xref.el (xref--rgrep-command): Pass DIR through
	`shell-quote-argument' (bug#23453).  Thanks for Kaushal Modi for
	pointing out the problem.  Assert that DIR doesn't start with `~'.

2016-05-04  Dmitry Gutov  <dgutov@yandex.ru>

	Rework xref-query-replace-in-results

	* lisp/progmodes/xref.el (xref-query-replace-in-results): Collect
	all xrefs from the buffer first, then delegate most of the
	processing to the value returned by xref--buf-pairs-iterator.
	(xref--buf-pairs-iterator): New function.  Return an "iterator"
	which partitions returned markers into buffers, and only processes
	markers from one buffer at a time.  When an xref is out of date,
	skip it with a message instead of signaling error (bug#23284).
	(xref--outdated-p): Extract from xref--buf-pairs-iterator.  Trim
	CR from both strings before comparing.
	(xref--query-replace-1): Remove the variable current-buf, no need
	to track it anymore.  Simplify the filter-predicate and search
	functions accordingly.  Iterate over buffer-markers pairs returned
	by the iterator, and call `perform-replace' for each of them.  Use
	multi-query-replace-map (bug#23284).  Use `switch-to-buffer' every
	time after the first, in order not to jump between windows.

	* test/automated/xref-tests.el
	(xref--buf-pairs-iterator-groups-markers-by-buffers-1)
	(xref--buf-pairs-iterator-groups-markers-by-buffers-2)
	(xref--buf-pairs-iterator-cleans-up-markers): New tests.

2016-05-04  Juri Linkov  <juri@linkov.net>

	* lisp/replace.el (query-replace-read-from): Use minibuffer-with-setup-hook

	to set minibuffer-local value of text-property-default-nonsticky.
	(Bug#23418, bug#23127)

2016-05-04  Stephen Berman  <stephen.berman@gmx.net>

	Fix todo-mode bug involving archived items (bug#23447)

	* lisp/calendar/todo-mode.el (todo-jump-to-category): When jumping
	from Todo Categories mode to a category with only archived items
	and todo-skip-archived-categories is non-nil, make sure the
	archive file buffer is in Todo Archive mode to prevent
	todo-category-select from raising an error, and don't set
	todo-current-todo-file, since that makes todo-show display the
	archived category.  Remove a no-op call to kill-buffer, which is
	already called in todo-insert-category-line.

2016-05-03  Dmitry Gutov  <dgutov@yandex.ru>

	Handle "empty line" regexp in xref searches

	* lisp/progmodes/xref.el (xref--collect-matches-1): Stop after one
	match if re-search-forward doesn't move point (bug#23426).

	* test/automated/xref-tests.el
	(xref-collect-matches-finds-an-empty-line-regexp-match):
	Uncomment test.

2016-05-03  Dmitry Gutov  <dgutov@yandex.ru>

	Add tests for xref-collect-matches

	* test/automated/xref-tests.el: New file.  Add tests for
	xref-collect-matches.

2016-05-03  Dmitry Gutov  <dgutov@yandex.ru>

	Use grep-find-ignored-directories instead of vc-directory-exclusion-list

	* lisp/dired-aux.el (dired-do-find-regexp):
	Use grep-find-ignored-directories instead of
	vc-directory-exclusion-list.  The result should be functionally
	similar (the former uses the latter as the default value), but it
	should be more consistent and appropriate WRT user
	customizations.
	(dired-do-find-regexp-and-replace): Update the docstring.

	* lisp/dired.el: Update the corresponding autoloads.

	* doc/emacs/dired.texi (Operating on Files): Update the
	documentation accordingly.

2016-05-03  Dmitry Gutov  <dgutov@yandex.ru>

	Clear buffer-undo-list when showing xrefs

	* lisp/progmodes/xref.el (xref--show-xref-buffer): Clear
	buffer-undo-list and temporarily bind it to t while rendering the
	buffer contents.

2016-05-03  Alan Mackenzie  <acm@muc.de>

	Note the quote translation in `message' in section "incompatible changes".

	* etc/NEWS: Note that `message' translates quotes, that the translation
	cannot be disabled, and that `format' can be used to get the old
	behavior back.

2016-05-03  Paul Eggert  <eggert@cs.ucla.edu>

	* etc/NEWS: Mention (message "%s" (format ...)).

2016-05-03  Lars Ingebrigtsen  <larsi@gnus.org>

	(Common Keywords): Correct what missing :group means

	* doc/lispref/customize.texi (Common Keywords): Correct what
	missing :group means.

2016-05-03  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of Dired's 'A' and 'Q' commands

	* lisp/dired-aux.el (dired-do-find-regexp)
	(dired-do-find-regexp-and-replace): Mention
	'grep-find-ignored-files' and 'vc-directory-exclusion-list', and
	also the fact that REGEXP should be palatable by Grep.  (Bug#23426)
	* lisp/dired.el: Update the corresponding autoload forms.

	* doc/emacs/dired.texi (Operating on Files): Mention
	'grep-find-ignored-files' and 'vc-directory-exclusion-list'.
	(Bug#23429)

2016-05-03  Paul Eggert  <eggert@cs.ucla.edu>

	Doc fixes for quoting

	* doc/emacs/text.texi, doc/lispintro/emacs-lisp-intro.texi:
	* doc/lispref/control.texi, doc/lispref/display.texi:
	* doc/lispref/help.texi, doc/lispref/strings.texi, lisp/subr.el:
	* src/callint.c, src/doprnt.c, src/editfns.c:
	Document quoting a bit more systematically.
	Problem reported by Alan Mackenzie (Bug#23425).

2016-05-02  Lars Ingebrigtsen  <larsi@gnus.org>

	posnp doc clarification

	* lisp/subr.el (posnp): Mention that a posn object is returned
	from `event-start' (bug#18211).

2016-05-02  Lars Ingebrigtsen  <larsi@gnus.org>

	Mention what a missing :group does

	* doc/lispref/customize.texi (Common Keywords): Document that
	a missing :group reuses the group from the preceding item (bug#21601).

2016-05-02  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of dired-aux search/replace commands

	* lisp/dired-aux.el (dired-do-find-regexp)
	(dired-do-find-regexp-and-replace): Doc fixes.  (Bug#23429)
	* lisp/dired.el: Update the corresponding autoload forms.

2016-05-02  Paul Eggert  <eggert@cs.ucla.edu>

	Fix quoting problem in cc-engine debug message

	* lisp/progmodes/cc-engine.el (c-replay-parse-state-state):
	Use "%s" format to pass through ‘'’ unscathed (Bug#23425), and
	likewise for ‘`’, and ‘%’.

2016-05-02  Philipp Stephani  <phst@google.com>

	Add electric-quote-string unit test

	* test/automated/electric-tests.el (electric-quote-string): New test.

2016-05-02  Paul Eggert  <eggert@cs.ucla.edu>

	Don’t electrically quote ‘'’ in Python

	Problem reported by Philipp Stephani (Bug#23387).
	* lisp/electric.el (electric-quote-post-self-insert-function):
	Do not requote a string starter or ender.

2016-05-02  Dmitry Gutov  <dgutov@yandex.ru>

	`nreverse' Grep hits before passing them to xref--convert-hits

	* lisp/progmodes/xref.el (xref-collect-matches): `nreverse' hits
	before passing them to xref--convert-hits.  Fixes a regression
	from cc0b7132.

2016-05-01  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/misc/texinfo.tex: Sync from gnulib.

2016-05-01  Juri Linkov  <juri@linkov.net>

	* lisp/isearch.el (isearch-forward-symbol-at-point): Add isearch-push-state.

	(Bug#23410)

2016-05-01  Michael Albinus  <michael.albinus@gmx.de>

	tramp.texi: Revert last change due to backward compatibility

	(cherry picked from commit 910f9a0a936aacbffe9b9b790d7f698dfd287aac)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	cua-prefix-override-inhibit-delay doc fix

	* lisp/emulation/cua-base.el
	(cua-prefix-override-inhibit-delay): Typo fix in doc string
	(bug#23401).

	(cherry picked from commit 2b4c099822811ede787fc6e575bfbb17b3cc0681)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	global-eldoc-mode doc fix

	* lisp/emacs-lisp/eldoc.el (global-eldoc-mode): Be more
	specific about what "applicable" means (bug#23071).

	(cherry picked from commit 25e95b5dd8cd92e03788e589bf99a4b399f03114)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	normal-top-level-add-subdirs-to-load-path doc fix

	* lisp/startup.el (normal-top-level-add-subdirs-to-load-path):
	Doc fix (bug#21962).

	(cherry picked from commit 28aaa6d20586e3330a23b017a65e56dd6461c003)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	isearch-search-fun-function doc tweak

	* lisp/isearch.el (isearch-search-fun-function): Mention what
	the STRING parameter is (bug#21552).

	(cherry picked from commit cafc2a5940cdc523cfea6dcf1cf540f48367c62a)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Fill some imenu--index-alist doc lines

	* lisp/imenu.el (imenu--index-alist): Fill some doc lines (bug#21269).

	(cherry picked from commit 4b7bb8f596550628eaa83b82c0f7eabe59a84964)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Fmarker_position doc string clarification

	* src/marker.c (Fmarker_position): Clarify the doc string
	(bug#21231).

	(cherry picked from commit eeac7c57273cec3f9408b18392dd2bafe3be4450)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Further define-obsolete-* doc fixups

	* lisp/emacs-lisp/byte-run.el (define-obsolete-face-alias):
	Fix up last change.
	(define-obsolete-variable-alias): Ditto.

	(cherry picked from commit 28e9f4390d8391c2c36be4ef515cf3a2c679a5a5)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Describe WHEN in all the define-obsolete- macros

	* lisp/emacs-lisp/byte-run.el (define-obsolete-face-alias):
	Say more verbosely what WHEN is (bug#21225).
	(define-obsolete-function-alias): Describe the WHEN parameter.
	(define-obsolete-variable-alias): Ditto.

	(cherry picked from commit 247c388f160581d207e41ca5926990bbf69d4a0f)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Mention with-silent-modifications in the lispref manual

	* doc/lispref/text.texi (Changing Properties): Document
	with-silent-modifications (bug#21171).

	(cherry picked from commit fcd0d854eef6e439d51e8f07cf734d5e34e502b3)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	with-silent-modifications doc clarification

	* lisp/subr.el (with-silent-modifications): Rearrange the doc
	string a bit so that the most pertinent information is at the
	top (bug#21171).

	(cherry picked from commit e0e70f030e69d9696a963a86f5f7caaff4df06eb)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	clear-visited-file-modtime doc string fix

	* lisp/files.el (clear-visited-file-modtime): Fix possibly
	confusing doc string wording (bug#21169).

	(cherry picked from commit 1aaeaf1450756a71c9254a2a5b174c72084ca67a)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Document mode line variables

	* doc/lispref/modes.texi (Mode Line Variables): Document
	`mode-line-front-space, `mode-line-misc-info',
	`mode-line-end-spaces' (bug#21014).

	(cherry picked from commit bf7a630b0a5d3900f2afb0e7a881ce62e2b9f935)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Add a cross ref to Optional Mode Line

	* doc/lispref/modes.texi (Mode Line Variables): Add a cross
	reference to the Emacs mode line node that explains things
	like `display-time-string' (bug#21002).

	(cherry picked from commit a3151a28789f413af73b14fbba557b2a587fca53)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Add a doc string to display-time-string

	* lisp/time.el: Add a doc string to `display-time-string',
	because it's referred to in the manual, and is too mysterious
	otherwise (bug#21002).

	(cherry picked from commit 45559c584e5a4ddeed1539b028b50b95baa372f8)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	custom-buffer-style doc fix

	* lisp/cus-edit.el (custom-buffer-style): Document the `tree'
	value (bug#20724).

	(cherry picked from commit bcf0291d0cd02095b0809b1eb91f1e5c5c2ac5e3)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Rearrange the doc of query-replace slightly

	* lisp/replace.el (query-replace): Move the mention of the
	interactive prefix arg earlier so that users can find it
	(bug#20654).

	(cherry picked from commit bcc10761c3b968fa4534718116a0a601ed7da389)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	apropos-print doc fix

	* lisp/apropos.el (apropos-print): Document the undocumented
	parameters (bug#20520).

	(cherry picked from commit 0714d7387812a151f59993ac77c7321724ef79b1)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	completion-table-with-predicate doc string fix

	* lisp/minibuffer.el (completion-table-with-predicate): t ->
	non-nil in the doc string (bug#20460).

	(cherry picked from commit b6a4d162208f239bc7804696d611ae52c686f138)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Fill the completion-table-with-predicate doc string

	* lisp/minibuffer.el (completion-table-with-predicate): Fill
	the doc string (bug#20460).

	(cherry picked from commit 207a31432c1ed8b548003a3e4af32c49aa3441e9)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	replace-match-maybe-edit doc clarification

	* lisp/replace.el (replace-match-maybe-edit): Say what
	MATCH-DATA is (bug#20304).

	(cherry picked from commit 139874ba53c2e2de9868f8e5234d6ea2bcb97af8)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	add-timeout doc fix

	* lisp/emacs-lisp/timer.el (add-timeout): Mention the return
	value (bug#20181).

	(cherry picked from commit 921b40476f597c84d7c34aa289cd43caeb389c4a)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Extremely minor doc fix in Choosing Window

	* doc/lispref/windows.texi (Choosing Window): There's only one
	action alist, I think (bug#20158).

	(cherry picked from commit 6c7e7f421d02d9290d6d1d85320737371160aef7)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Transform mentions of `eval-after-load' to `with-eval-after-load'

	* doc/lispref/loading.texi (Hooks for Loading): Update text to
	not mention `eval-after-load' (bug#20038).

	(cherry picked from commit 9392193be56eebdfac702a0bbb5e954088371c7a)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	cursor-type doc fix

	* src/buffer.c (syms_of_buffer): Mention that cursor-type's
	WIDHT/HEIGHT can't exceed the frame char size (bug#19215).

	(cherry picked from commit 77c5f4554ebb3b7c7d49bc881e45a550f6c93987)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Add a link from Tool Bar to Images

	* doc/lispref/keymaps.texi (Tool Bar): Add a link to the
	Images node (bug#19722).

	(cherry picked from commit da5d0786163a91400eced4fddba4a92b652458d1)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	(default-mode-line-format): More explicit obsolete info

	* lisp/subr.el (default-mode-line-format): Be more explicit in
	how default values are now handled (bug#19424).

	(cherry picked from commit 9dc5f6d830e72420dc4d41c8f6ca1ca6b28609c0)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Fcompare_buffer_substrings doc string clarification

	* src/editfns.c (Fcompare_buffer_substrings): Extremely minor
	doc string clarification (bug#19255).

	(cherry picked from commit aa692acbb598a1cc8219ed7a87dde25fd7626ba5)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	insert-file-contents-literally doc fix

	* lisp/files.el (insert-file-contents-literally): Say that the
	parameters are explained in the other function (bug#18317).

	(cherry picked from commit b6481b19bc9592492b1f70dfecb4de6256f537fe)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix custom types for cursor-in-non-selected-windows

	* lisp/cus-start.el (standard): Use the same custom types for
	cursor-in-non-selected-windows as for cursor-type (bug#19214).

	(cherry picked from commit b66bc0cced786e0320e1c3b0758bd3c434d4e8b5)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Doc clarification to mwheel-scroll

	* lisp/mwheel.el (mwheel-scroll): Mention that the restriction
	does not apply to Windows (bug#19209).

	(cherry picked from commit 696052b5fdfbc5c25dff3c6b081aebe70f6d06c7)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Clarify the doc of eval-expression-print-format

	* lisp/simple.el (eval-expression-print-format): Doc
	clarification (bug#19114).

	(cherry picked from commit cd193a871f5a8e1c81ba86fc398ac382fa814383)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Explictly explain that package-initialize loads the packages

	* lisp/emacs-lisp/package.el (package-initialize): Be explicit
	in saying that `package-initialize' obviates adjusting the
	path or requiring the packages, as this is a question that
	apparently comes up now and then (bug#18829).

	(cherry picked from commit 619e0aedb2f3dbfe6821ac34e2d25b4e5c181117)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Have the doc strings of `load-path' and `require' mention each other

	* src/fns.c (Frequire): Mention `load-path' and fill the doc
	string (bug#18829).

	* src/lread.c (syms_of_lread): Mention that `require' uses
	`load-path'.

	(cherry picked from commit 3eca9a03816f95da0030665223c0b5262f223ba7)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Doc fix for insert-pair-alist

	* lisp/emacs-lisp/lisp.el (insert-pair-alist): Say what
	COMMAND-CHAR is (bug#18809).

	(cherry picked from commit 2824c587e9749a8f350f1d3dddd65176b4561dcb)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Move doc of backup-directory-alist to the Backup node

	* doc/emacs/files.texi (Backup): Move the documentation of
	`backup-directory-alist' here from the "Single or Numbered
	Backups" node, because it doesn't seem to have much to do with
	numbering (bug#18692).

	(cherry picked from commit e77b8d84b4161f2cf8720dec2bf44a3e50134398)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Tiny doc clarification for create-fontset-from-fontset-spec

	* lisp/international/fontset.el (create-fontset-from-fontset-spec):
	Clarify what the optional part is (bug#18686).

	(cherry picked from commit c05d186455ce9907eeb6b21ea4227e453996c681)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Fill the doc string of font-lock-keywords

	* lisp/font-lock.el (font-lock-keywords): Fill the lines and
	reorganize some explanations (bug#21427).

	(cherry picked from commit c05716d3a26ea7518b89eacfccaf70c9d0731df7)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Doc fix for font-lock-remove-keywords

	* lisp/font-lock.el (font-lock-remove-keywords): Add a link to
	`font-lock-add-keywords' to describe KEYWORDS (bug#18634).

	(cherry picked from commit bc00dcf12983cd399127d0eea39647f29778eb02)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Clarify whitespace-style doc string

	* lisp/whitespace.el (whitespace-style): Doc clarification
	(bug#18296).

	(cherry picked from commit d96c720d0cca7c9ffbb4c712ad315bb707d6625c)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Doc fixed for next-error-buffer-p

	* lisp/simple.el (next-error-buffer-p): Clarify doc string
	(bug#18202).

	(cherry picked from commit a10eb168cc96db9f0dab2d75550cbd8f08be2363)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Tiny doc fix

	* src/fileio.c (Ffile_accessible_directory_p): Tiny doc fix
	(and fill) (bug#18201).

	(cherry picked from commit 2ef0040e2363a669d9b93df935d31c98fa130132)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Doc fix

	* src/keymap.c (Fdefine_prefix_command): Clarify doc string
	slightly (bug#18092).

	(cherry picked from commit 6b769c81d024f7eeb90b167e7df6f87d859614d4)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	delsel doc touch ups

	* lisp/delsel.el (delete-selection-helper): Use non-nil
	instead of t and clarify function return values (bug#18089).

	(cherry picked from commit d7a5b5be9a5869bcd233434ec3103dd1976d7df7)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Doc fixes for menu-bar.el

	* lisp/menu-bar.el (clipboard-kill-ring-save): Describe the
	REGION parameter (bug#18028).
	(clipboard-kill-region): Ditto.

	(cherry picked from commit 33d2c67bff0992ecbc0fe38556683242b9d1a4ae)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Doc fix

	* lisp/rect.el (delete-whitespace-rectangle): Doc fix (bug#18026).

	(cherry picked from commit 6baca4911ec901579749dbf7596011d90fea3781)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Minor doc clarification

	* lisp/subr.el (y-or-n-p): Document the return value from "n"
	(bug#18024).

	(cherry picked from commit 5d1f3192d484edee92caa46cd7d699da3e920259)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Fill font-lock-mode doc string

	* lisp/font-core.el (font-lock-mode): Fill the text to make it
	narrower (bug#18008).

	(cherry picked from commit 27abf372836532c57be2e9e3ed23413729cc07fc)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Wrap the auto-generated doc string

	* lisp/emacs-lisp/easy-mmode.el (define-minor-mode): Wrap a
	string to make it less likely that we get overlong lines
	(bug#17999).

	(cherry picked from commit 323b69664914d687fd4b48593479cea223dfbcb4)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Clarify hi-lock-find-patterns

	* lisp/hi-lock.el (hi-lock-find-patterns): Doc clarification
	(bug#17989).

	(cherry picked from commit 552e90ce7dff3a7107243fdf71c4de3af443e13a)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Add a doc string to `winner-mode'

	* lisp/winner.el (winner-mode): Add a doc string based on the
	comments in the file (bug#17716).

	(cherry picked from commit 2c3ab9b6e39a3d600e7d82deacc24effaec051bb)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Doc fix for align-newline-and-indent

	* lisp/align.el (align-newline-and-indent): Mention that
	alignment is done by `align' (bug#17707).

	(cherry picked from commit 340a224ec3e01706112a07164da9a9f3f369a5aa)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Doc fix for `kbd'

	* lisp/subr.el (kbd): Describe more fully the format of the
	parameter (bug#17039).

	(cherry picked from commit 3a33afe25d8518f194fa4706eaccdb2a786a0348)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Doc tweak

	* lisp/simple.el (use-empty-active-region): Doc tweak.
	There's only one region (bug#16513).

	(cherry picked from commit 35fb7897f161d5e5a87e039dc1e427094640b0c8)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Link from (emacs)Exiting to (lisp)Killing Emacs

	* doc/emacs/entering.texi (Exiting): Link to the lispref
	manual for further customizations (bug#15445).

	(cherry picked from commit bc5f27aa099cdde02ca66e71501b89300685ab28)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	find-lisp doc touchups

	* lisp/find-lisp.el (find-lisp-format): Copy over the doc
	string (bug#15047).
	(find-lisp-find-files): Clarify doc.

	(cherry picked from commit e4c7657b0d1a31d64ca24bc64b5480cd7687e332)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Don't have the manual claim that it lists all CL incompatibilities

	* doc/misc/cl.texi (Common Lisp Compatibility): The list of
	incompatibilities isn't exhaustive, so don't say that it is
	(bug#15171).

	(cherry picked from commit fb685bc91a72508c97ce7e30f970d4157677f371)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Change all occurrences of "Mouse-[0-9]" to "mouse-[0-9]"

	* doc/emacs/*.texi: Change all occurrences of "Mouse-[0-9]" to
	"mouse-[0-9]".  These are case sensitive, and the keys are lower case
	(bug#14554).

	(cherry picked from commit e4c26271f2c2fe08f8490e25c63a436ab2a804ca)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Doc string change to enable-recursive-minibuffers

	* src/minibuf.c (syms_of_minibuf): Mention
	minibuffer-depth-indicator-mode in the doc string to
	enable-recursive-minibuffers (bug#14147).

	(cherry picked from commit 23ba488a5e8290c4de91e0ff4161641efa364c0d)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Clarify the `interactive' doc string slightly

	* src/callint.c (Finteractive): Clarify the doc string slightly
	  (bug#14577).

	(cherry picked from commit cd993be60da2d12db0d390001373d486c1091c47)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Clarify some doc strings

	* lisp/emacs-lisp/syntax.el (syntax-propertize-via-font-lock):
	Clarify doc string (bug#8693).
	(syntax-propertize): Clarify doc string.

	(cherry picked from commit ad3ef417f3c40f086de9c547d6272e5685595e42)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Add some concept index entries for custom types

	* doc/lispref/customize.texi (Composite Types): Add concept
	index entries for restricted-sexp, radio and choice (bug#7385).

	(cherry picked from commit 388bb723fa078158d3148de05e942f9c01e95dd8)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Mention `lisp-indent-function' in the lispref manual

	* doc/lispref/macros.texi (Indenting Macros): Mention
	`lisp-indent-function' (bug#3393).

	(cherry picked from commit a1627691a896b2afaa264f93534178bc763564c9)

2016-05-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Clarify doc string of internal compilation function

	* lisp/progmodes/compile.el (compilation-get-file-structure):
	Clarify doc string (bug#3137).

	(cherry picked from commit 123191decb7428db3b32a6c01631fa755088393a)

2016-05-01  Paul Eggert  <eggert@cs.ucla.edu>

	Use ‘T *restrict’ proto, not ‘T[restrict]’

	* src/fns.c (sort_vector_copy): Use a different way to attempt to
	work around GCC 3.0-and-earlier incompatibility with C99, one that
	does not have problems with modern non-GCC compilers.

2016-05-01  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of 'url-retrieve-synchronously'

	* doc/misc/url.texi (Retrieving URLs): Update argument list of
	'url-retrieve-synchronously'.  (Bug#23411)

2016-05-01  Eli Zaretskii  <eliz@gnu.org>

	* lisp/url/url.el (url-retrieve-synchronously): Doc fix.  (Bug#23411)

2016-04-30  Leo Liu  <sdl.web@gmail.com>

	Fix last change to isearch-update (bug#23406)

	* lisp/isearch.el (isearch-update): Remove (setq cursor-sensor-inhibit
	  nil) ie remove the original (unless (boundp 'cursor-sensor-inhibit)
	  ...) form.

2016-04-30  Leo Liu  <sdl.web@gmail.com>

	Autoload cursor-sensor-inhibit (bug#23406)

	* lisp/emacs-lisp/cursor-sensor.el (cursor-sensor-inhibit): Autoload.
	* lisp/isearch.el (isearch-update): Remove boundp check.

2016-04-30  Phillip Lord  <phillip.lord@newcastle.ac.uk>

	org-map-entries: Fix org-agenda-prepare-buffers call

	* lisp/org/org.el (org-map-entries): Check that buffer-file-name is non-nil
	  before passing to org-agenda-prepare-buffers.

	This is a backport of commit 44c8cd7136e3fcd1e6bfa08895cac437b7a691fa
	from upstream org-mode. Addresses bug #23365.

2016-04-30  Eli Zaretskii  <eliz@gnu.org>

	Followup for last commit in the user manual

	* doc/emacs/basic.texi (Moving Point): Clarify that
	set-goal-column has buffer-local effect.  (Bug#23405)

2016-04-30  Eli Zaretskii  <eliz@gnu.org>

	Improve doc string of 'set-goal-column'

	* lisp/simple.el (set-goal-column): Doc fix.  (Bug#23405)

2016-04-30  Eli Zaretskii  <eliz@gnu.org>

	Fix the MSDOS build

	* config.bat:
	* msdos/sedlisp.inp:
	* msdos/sedlibmk.inp:
	* msdos/sedleim.inp:
	* msdos/sedadmin.inp:
	* msdos/sed6.inp:
	* msdos/sed3v2.inp:
	* msdos/sed2v2.inp:
	* msdos/sed1v2.inp: Adapt to Emacs 25.

	* src/process.c (remove_slash_colon): Move out of "#ifdef
	subprocesses" block, as it its called unconditionally.  Move
	ADD_SUBFEATURE calls into "#ifdef subprocesses" block, as they
	reference variables only defined in that block.
	* src/msdos.h: Provide prototypes for IT_set_frame_parameters,
	faccessat, msdos_fatal_signal, syms_of_msdos, pthread_sigmask,
	dos_keysns, dos_keyread, run_msdos_command, and
	syms_of_win16select, to avoid compiler warnings.
	* src/msdos.c (SYS_ENVIRON): Define to either '_environ' or
	'environ', depending on the DJGPP version.
	Remove declarations of externally-visible Lisp objects, like
	Qbackground_color and Qreverse.
	(run_msdos_command): First argument is not signed, not unsigned.
	Use SYS_ENVIRON.
	(sys_select): Use 'timespec_cmp' instead of 'timespec_sign', as
	the latter doesn't work when 'time_t' is an unsigned data type.
	This caused idle timers to behave incorrectly: they only fired
	after a keyboard input event.
	* src/frame.c (adjust_frame_size) [MSDOS]: Account for
	FRAME_TOP_MARGIN that isn't counted in the frame's number of
	lines, but dos_set_window_size needs it to be added.
	* src/lread.c (INFINITY, NAN) [DJGPP < 2.05]: Provide definitions.
	* src/fns.c (sort_vector_copy) [__GNUC__ < 4]: Provide a prototype
	that works around compilation errors with older GCC versions.
	* src/w16select.c: Don't declare QCLIPBOARD and QPRIMARY as Lisp
	Objects.
	* src/filelock.c [MSDOS]: Ifdef away most of the code.  Provide
	no-op implementations for 'lock_file' and 'unlock_file'.
	(Ffile_locked_p) [MSDOS]: Always return nil.  This avoids multiple
	ifdefs in all users of filelock.c functionality.
	* src/conf_post.h (EOVERFLOW, SIZE_MAX) [DJGPP < 2.04]: Define.
	* src/emacs.c [MSDOS]: Include dosfns.h, to avoid compiler
	warnings.
	* src/dosfns.h: Provide prototypes for dos_cleanup,
	syms_of_dosfns, and init_dosfns.
	* src/deps.mk (atimer.o): Depend on msdos.h.
	(emacs.o): Depend on dosfns.h.
	* src/atimer.c [MSDOS]: Include msdos.h, to avoid compiler
	warnings.

	* lisp/window.el (window--adjust-process-windows): Skip the body
	if 'process-list' is not available.  This avoids failure to start
	up on MS-DOS.
	* lisp/vc/diff.el (diff-no-select): Test 'make-process', not
	'start-process', as the latter is now available on all platforms.
	* lisp/textmodes/ispell.el (ispell-async-processp): Replace
	'start-process' with 'make-process' in a comment.
	* lisp/term/internal.el (IT-unicode-translations): Modify and add
	a few translations to display Info files with Unicode markup.  Fix
	an ancient off-by-one mismatch error with Unicode codepoints.
	* lisp/progmodes/compile.el (compilation-start): Test
	'make-process', not 'start-process', as the latter is now
	available on all platforms.
	* lisp/man.el (Man-build-man-command, Man-getpage-in-background):
	Test 'make-process', not 'start-process', as the latter is now
	available on all platforms.
	* lisp/international/mule-cmds.el (set-coding-system-map): Test
	'make-process', not 'start-process', as the latter is now
	available on all platforms.
	* lisp/eshell/esh-cmd.el (eshell-do-pipelines-synchronously): Doc
	fix.
	(eshell-execute-pipeline): Test 'make-process', not
	'start-process', as the latter is now available on all platforms.

2016-04-30  Andreas Schwab  <schwab@linux-m68k.org>

	Remove \= from format string (bug#18190)

	* lisp/emacs-lisp/eieio.el (defclass): Remove \= from format
	string.

2016-04-30  Eli Zaretskii  <eliz@gnu.org>

	Fix variable-pitch font on MS-Windows

	* lisp/faces.el (variable-pitch) [w32]: Name a variable-pitch font
	explicitly, to avoid Emacs picking up a bold-italic variant on
	some MS-Windows systems.  See this thread for details:
	https://lists.gnu.org/r/emacs-devel/2016-04/msg00746.html.

2016-04-29  Alan Mackenzie  <acm@muc.de>

	Restore follow-scroll-up/down to scrolling by the combined size of all windows

	Also rename the current follow-scroll-up/down functions to
	follow-scroll-up-window and follow-scroll-down-window.  These scroll by the
	height of the current window.

	This fixes bug #23347.

	* lisp/follow.el (follow-mode): Tweak the doc string.
	(follow-scroll-up-arg, follow-scroll-down-arg): new functions, extracted from
	follow-scroll-up/down.
	(follow-scroll-up-window, follow-scroll-down-window): Functions renamed from
	follow-scroll-up/down.
	(follow-scroll-up, follow-scroll-down): Restore the historic functionality.

2016-04-29  Alan Mackenzie  <acm@muc.de>

	Revert unneeded change which harms syntactic parsing.  This fixes bug #23308.

	* lisp/progmodes/cc-engine.el (c-invalidate-state-cache): User
	c-state-old-cpp-end as an argument to c-with-all-but-one-cpps-commented-out
	regardless of the value of `here'.

2016-04-29  Alan Mackenzie  <acm@muc.de>

	Correct indentation of ids in a C++ enum after a protection keyword.

	Also correct the misfontification of the last enum identifier.

	* lisp/progmodes/cc-engine.el (c-forward-keyword-prefixed-id): setq
	c-last-identifier-range to nil to ensure that only types recognized by this
	macro are set for fontification as types.
	(c-backward-typed-enum-colon): Function renamed from
	c-backward-colon-prefixed-type.  On finding a colon in the backward search,
	check it is preceded by an identifier rather than a keyword.

2016-04-27  Glenn Morris  <rgm@gnu.org>

	* lisp/window.el (window--process-window-list): No-op if no processes.

	This avoids an issue with save-selected-window (from walk-windows)
	failing if frame.el is not loaded, eg if the terminal is resized
	during startup of a -nw CANNOT_DUMP build.  (Bug#23369).

2016-04-27  Paul Eggert  <eggert@penguin.cs.ucla.edu>

	Port dumping to NetBSD with PaX

	Problem reported by Thomas Klausner (Bug#23371).
	* configure.ac (PAXCTL_dumped, PAXCTL_notdumped): New vars.
	Set them to setfattr and/or paxctl commands appropriate for
	GNU/Linux and/or NetBSD; the latter prefers paxctl +a.  Search
	for paxctl only if setfattr is not found.
	* src/Makefile.in (PAXCTL_dumped, PAXCTL_notdumped):
	New vars, replacing PAXCTL_if_present and SETFATTR_if_present.
	All uses changed.

2016-04-27  Dmitry Gutov  <dgutov@yandex.ru>

	Don't mistake `for' inside a function for a part of array comprehension

	* lisp/progmodes/js.el (js--indent-in-array-comp): Also check the
	depth in parens between the bracket and `for' (bug#23391).

	* test/indent/js.js: Add a corresponding example.

2016-04-27  Anders Lindgren  <andlind@gmail.com>

	Fix bug#22891: wrong terminal width when a fringe width is zero.

	When either fringe width is zero, Emacs reserved one column for a
	continuation glyph. Terminal windows does not take this into
	account when the frame is resized.

	* lisp/window.el (window-adjust-process-window-size): Use
	`window-max-chars-per-line' instead of `window-body-width'.
	* lisp/term.el (term-window-width): Remove function. (It does the
	same as `window-max-chars-per-line' but without recent bug fixes.)
	(term-mode): Use `window-max-chars-per-line' instead of
	`term-window-width'.

	Backport

	(cherry picked from commit 5b5403289888efe8783ae6a405845b925f544ec1)

2016-04-27  Leo Liu  <sdl.web@gmail.com>

	Improve last change to vc-git-mode-line-string

	* lisp/vc/vc-git.el (vc-git-mode-line-string): Better fix that caches
	  the result.

2016-04-27  Stephen Berman  <stephen.berman@gmx.net>

	Todo mode doc bug fix

	* lisp/calendar/todo-mode.el (todo-show): Correct obsolete and no
	longer correct information in doc string.

2016-04-27  Leo Liu  <sdl.web@gmail.com>

	Fix revision calculation in vc-git-mode-line-string

	* lisp/vc/vc-git.el (vc-git-mode-line-string): Use
	  vc-git-working-revision because vc-working-revision needs to decide
	  the backend and may return nil.

2016-04-26  Jorgen Schaefer  <contact@jorgenschaefer.de>

	Add Python 3.5 keyword "await"

	* lisp/progmodes/python.el (python-font-lock-keywords): Add await as
	keyword.

2016-04-26  Lele Gaifax  <lele@metapensiero.it>

	Add new keywords of Python 3.5

	Python 3.5, released in mid September 2015, introduced a few new
	keywords to better support asynchronous code, "async" and "await"
	in particular. See https://www.python.org/dev/peps/pep-0492/ for
	details. (Bug#21783)
	* lisp/progmodes/python.el (python-rx-constituents): Add async
	def/for/with as block-start and async def as defun.
	* lisp/progmodes/python.el (python-font-lock-keywords): Add async
	def/for/with as keyword.
	* test/automated/python-tests.el (python-indent-after-async-block-1,
	python-indent-after-async-block-2, python-indent-after-async-block-3,
	python-nav-beginning-of-defun-3): New tests to test indentation and
	navigation for the async keyword.

2016-04-26  Mark Oteiza  <mvoteiza@udel.edu>

	Partially revert previous change.

	This commit partially reverts 0f332848cdb2ed6d46771914a911cbca194cd51a.
	* lisp/rect.el (rectangle--highlight-for-redisplay): Use region face.
	This function is for rectangle-mark-mode, not string-rectangle.

2016-04-25  Paul Eggert  <eggert@penguin.cs.ucla.edu>

	Say why text-quoting-style is not a user option

	* doc/lispref/help.texi (Keys in Documentation):
	* etc/NEWS: Document why text-quoting-style is not a
	customizable variable (Bug#23372).

2016-04-25  Glenn Morris  <rgm@gnu.org>

	* lisp/emacs-lisp/autoload.el (update-directory-autoloads):
	Future-proof against non-time-values.

2016-04-25  Eli Zaretskii  <eliz@gnu.org>

	Don't mention ~/.emacs.bmk literally in doc strings

	* lisp/bookmark.el (bookmark-save-flag, bookmark-load): Don't
	mention "~/.emacs.bmk" explicitly as the default bookmark file in
	the doc strings.  (Bug#23350)

2016-04-25  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* etc/NEWS: Explain why multicolor font display is disabled on OS X Cocoa.

2016-04-24  Paul Eggert  <eggert@cs.ucla.edu>

	Port to Ubuntu 16.04 --enable-gcc-warnings

	* src/image.c (gif_load) [HAVE_GIF]: Fix pointer signedness problem.

2016-04-24  Paul Eggert  <eggert@cs.ucla.edu>

	* etc/NEWS: Improve wording of vc-git-log-output-coding-system etc.

2016-04-24  Tino Calancha  <f92capac@gmail.com>

	Don't kill ~/ if it's the top level directory

	* lisp/dired-aux.el (dired-kill-subdir): Don't kill ~/ if it's
	the top level directory (bug#23017).

2016-04-23  Tino Calancha  <f92capac@gmail.com>  (tiny change)

	describe-char: fix insert char documentation

	* lisp/descr-text.el (describe-char):
	Only 'ucs-names' entries can be inserted by unicode name (Bug#23325).

2016-04-23  Dmitry Gutov  <dgutov@yandex.ru>

	(vc-git-mode-line-string): Don't use `replace-regexp-in-string'

	* lisp/vc/vc-git.el (vc-git-mode-line-string): Use `substring'
	instead of `replace-regexp-in-string', because REV can be nil
	(e.g. when FILE is a directory, bug#23344), and we actually know
	we only need the first 4 characters.

2016-04-22  Nicolas Petton  <nicolas@petton.fr>

	Bump version to 25.0.93

	* README:
	* configure.ac:
	* msdos/sed2v2.inp: Bump Emacs version to 25.0.93.

2016-04-22  Nicolas Petton  <nicolas@petton.fr>

	* etc/AUTHORS: Update the AUTHORS file

	* admin/update_autogen: Use #!/usr/bin/env bash

	* admin/authors.el (authors-ignored-files): Additions.

2016-04-22  Martin Rudalics  <rudalics@gmx.at>

	In x_set_window_size restore do_pending_window_change calls

	* src/xterm.c (x_set_window_size):
	* src/w32term.c (x_set_window_size): Restore
	do_pending_window_change calls after their stupid removal on
	2015-08-31.

2016-04-21  Ilya Zakharevich  <ilya@math.berkeley.edu>

	Fix Alt-modified keys on some European MS-Windows keyboards

	* src/w32fns.c (deliver_wm_chars): If the reported character is
	ASCII, AND Meta modifier is a candidate, behave as if Meta is
	present, i.e. fall back to the legacy code.  (Bug#23251)

2016-04-20  Eli Zaretskii  <eliz@gnu.org>

	Document 'help-go-forward'

	* doc/emacs/help.texi (Help Mode): Document and index
	'help-go-forward'.  (Bug#23323)

2016-04-20  Eli Zaretskii  <eliz@gnu.org>

	Revert "Allow to customize names of executables used by grep.el"

	This reverts commit c93ae7a1e5a94541189a8f36984014344d561ffc.

2016-04-20  Eli Zaretskii  <eliz@gnu.org>

	Revert "Don't use 'find-program'"

	This reverts commit 10597c977d55cbf9304b51c3b364ce58199384a0.

2016-04-20  Eli Zaretskii  <eliz@gnu.org>

	Revert "Use 'grep-find-program' in check-declare.el"

	This reverts commit 33bef6e90bfd20609d044b8a076c1570c627684a.

2016-04-20  Eli Zaretskii  <eliz@gnu.org>

	Clarify documentation of 'dired-mark-files-containing-regexp'

	* doc/emacs/dired.texi (Marks vs Flags): Clarify that for files
	visited in buffers, 'dired-mark-files-containing-regexp' searches
	the buffer rather than the file on disk.  (Bug#22694)

	* lisp/dired.el (dired-mark-files-containing-regexp): Clarify that
	for files visited in buffers, 'dired-mark-files-containing-regexp'
	searches the buffer rather than the file on disk.  (Bug#22694)

2016-04-19  Eli Zaretskii  <eliz@gnu.org>

	Make tmm-menubar work in correct order again

	* lisp/tmm.el (tmm-prompt): Don't reverse 'tmm-km-list' right at the
	beginning; instead, pass a reversed copy to 'tmm--completion-table'.
	(Bug#23309)
	(tmm-menubar): Fix an off-by-one error in determining the menu
	item when the function is called with a non-nil 'x-position'
	argument.

2016-04-18  Dmitry Gutov  <dgutov@yandex.ru>

	Remove the Meta-CVS VC backend

	* lisp/obsolete/vc-mcvs.el: Remove the file (bug#20475).

	* lisp/vc/log-view.el (log-view-extract-comment): Remove the MCVS
	reference.

	* doc/misc/efaq-w32.texi (Version control): Same.

2016-04-18  Michael Albinus  <michael.albinus@gmx.de>

	Fix Bug#23276

	* lisp/autorevert.el (auto-revert-handler): Ignore errors
	coming from `revert-buffer'.  (Bug#23276)

2016-04-17  Reto Zimmermann  <reto@gnu.org>

	Sync with upstream vhdl mode v3.38.1.

	* lisp/progmodes/vhdl-mode.el (vhdl-version, vhdl-time-stamp): Update.
	(vhdl-mode): No longer set comment-padding.
	(vhdl-begin-p): Handle missing space between keyword and parenthesis.
	(vhdl-beginning-of-statement-1): Fix indentation for "else generate".
	(vhdl-template-else, vhdl-template-elsif): Support generate statement.
	(vhdl-re-search-forward, vhdl-re-search-backward): Save match data.

2016-04-16  Paul Eggert  <eggert@cs.ucla.edu>

	Tweak configure.ac syntax in recent module patch

	* configure.ac: Use proper Autoconf parenthesization in
	recent HAVE_MODULES patch.  Although this doesn’t fix any bugs,
	the previous syntax was confusing.

2016-04-16  Paul Eggert  <eggert@cs.ucla.edu>

	Port to GCC 5.3.1 20160406 (Red Hat 5.3.1-6)

	* src/indent.c (Fvertical_motion): Pacify --enable-gcc-warnings
	when using the April 6 Fedora patch to GCC.

2016-04-16  Mark Oteiza  <mvoteiza@udel.edu>

	Make sh-electric-here-document-mode accessible in sh-mode-hook. (Bug#3226)

	* lisp/progmodes/sh-script.el (sh-mode-hook): Add
	sh-electric-here-document-mode as an option and the default value.
	(sh-mode): Mention sh-mode-hook in docstring.
	(sh-mode): Remove sh-electric-here-document-mode invocation.

2016-04-16  Glenn Morris  <rgm@gnu.org>

	* configure.ac (HAVE_MODULES): Exclude gnu-kfreebsd from previous.

2016-04-16  Mark Oteiza  <mvoteiza@udel.edu>

	Make use of rectangle-preview custom variable.

	lisp/rect.el (rectangle--string-preview): Only create a preview if
	rectangle-preview is non-nil (Bug#23248).

2016-04-16  Mark Oteiza  <mvoteiza@udel.edu>

	Make use of rectangle-preview face.

	* lisp/rect.el (rectangle--string-preview):
	(rectangle--highlight-for-redisplay): Replace 'region with
	'rectangle-preview (Bug#23248).

2016-04-16  Eli Zaretskii  <eliz@gnu.org>

	Use 'grep-find-program' in check-declare.el

	* lisp/emacs-lisp/check-declare.el (check-declare-directory): Use
	'grep-find-program', not 'find-program'.

2016-04-16  Eli Zaretskii  <eliz@gnu.org>

	Improve "C-h S" for cl-lib symbols

	* lisp/info-look.el: Add cl.info lookup to emacs-lisp-mode related
	manuals.  (Bug#23289)

2016-04-16  Eli Zaretskii  <eliz@gnu.org>

	Fix minor issues with removing left or right fringes

	* lisp/window.el (window-max-chars-per-line): Account for
	'left-fringe-width' and 'right-fringe-width' variables.

	* doc/lispref/windows.texi (Window Sizes): Document the effect on
	window text width when setting the width of one or both fringes to
	zero.
	* doc/emacs/display.texi (Fringes): Document the effect on window
	text width when setting the width of one or both fringes to zero.
	(Bug#22891)

2016-04-16  Eli Zaretskii  <eliz@gnu.org>

	Speed up redisplay in ansi-term mode

	* lisp/term.el (ansi-term): Force L2R 'bidi-paragraph-direction'.
	(Bug#20611)

2016-04-16  Philipp Stephani  <phst@google.com>

	Simplify 8-bit character handling by terminal for 'raw-text'

	* lisp/international/mule.el (set-keyboard-coding-system): Treat
	'raw-text' as another coding type that requires 8-bit characters.
	* lisp/xt-mouse.el (xterm-mouse--read-coordinate): Use 'no-conversion'
	instead of 'latin-1'.

2016-04-15  Glenn Morris  <rgm@gnu.org>

	* configure.ac (HAVE_MODULES): Treat gnu like gnu-linux.  (Bug#22722)

2016-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix w32 memory-management problem when extending buffer text

	* src/w32heap.c (mmap_realloc): Only attempt extending a region if
	the following region has the same allocation base.  Also, use the
	original allocation base and enlarged size to commit reserved
	memory, to ensure that the allocation base stays at its original
	value.  This fixes several hard-to-debug problems whereby part of
	buffer text was overwritten with binary nulls, because
	mmap_realloc copied only part of buffer text when extending it.
	See
	https://lists.gnu.org/r/emacs-devel/2016-04/msg00325.html
	and https://debbugs.gnu.org/cgi/bugreport.cgi?bug=23223#55 for two
	examples of the related problems.

2016-04-14  Michael Albinus  <michael.albinus@gmx.de>

	Fix Bug#20637.  Do not merge to master

	* lisp/vc/vc-hooks.el (vc-state, vc-working-revision):
	Use `vc-backend' instead of `vc-responsible-backend'.  (Bug#20637)

	* test/automated/vc-tests.el (vc-test--state)
	(vc-test--working-revision): Deactivate now failing checks.

2016-04-14  Paul Eggert  <eggert@cs.ucla.edu>

	substitute-command-keys keeps quotes’ text props

	Problem reported by Clément Pit--Claudel (Bug#23254).
	* src/doc.c: Include intervals.h.
	(Fsubstitute_command_keys): If the only substitutions are for
	quotes, copy the source string’s text properties too, since no
	substring lengths have changed.

2016-04-13  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* src/xwidget.c (x_draw_xwidget_glyph_string): More clipping fixes.

2016-04-12  Dmitry Gutov  <dgutov@yandex.ru>

	Add semantic-symref-filepattern-alist entry for lisp-interaction-mode

	* lisp/cedet/semantic/symref/grep.el
	(semantic-symref-filepattern-alist):
	Add entry for lisp-interaction-mode
	(https://debbugs.gnu.org/cgi/bugreport.cgi?bug=23223#47)

2016-04-12  Dmitry Gutov  <dgutov@yandex.ru>

	Perform xref searches without visiting unopened files

	* lisp/progmodes/xref.el (xref-collect-references): Instead of
	calling `semantic-symref-find-references-by-name', use
	`semantic-symref-instantiate' and `semantic-symref-perform-search'
	directly.  Ask for `line-and-text' results (bug#23223).
	(xref-collect-matches): Include the line text in the "hit"
	structure.
	(xref--convert-hits): New function, split off from
	`xref-collect-references' and `xref-collect-matches', to convert
	"hits" to xref instance list.  Create a temporary buffer here, to
	use it for post-processing all hit lines.
	(xref--collect-matches): Use a different approach for non-visited
	files.  Insert the line text into the temp buffer, apply the
	file's major mode the best we can without reading its whole
	contents, syntax-propertize, and search in the result.
	(xref--collect-matches-1): Extract, to handle the common logic
	between two cases.
	(xref--find-buffer-visiting): New function, a wrapper around
	`find-buffer-visiting' to amortize its cost.

	* lisp/cedet/semantic/symref/idutils.el
	(semantic-symref-idutils--line-re): New constant.
	(semantic-symref-parse-tool-output-one-line): Support result type
	`line-and-text'.

	* lisp/cedet/semantic/symref/grep.el
	(semantic-symref-grep--line-re)
	(semantic-symref-parse-tool-output-one-line): Same.

	* lisp/cedet/semantic/symref/cscope.el
	(semantic-symref-cscope--line-re)
	(semantic-symref-parse-tool-output-one-line): Same.

	* lisp/cedet/semantic/symref/global.el
	(semantic-symref-global--line-re)
	(semantic-symref-parse-tool-output-one-line): Same.

2016-04-12  Phillip Lord  <phillip.lord@newcastle.ac.uk>

	Revert "Prevent bootstrap autoload backup files"

	This reverts commit c23c965bb9d0a4bcc1b6158833ff99aa20fd53e9.

2016-04-12  Paul Eggert  <eggert@cs.ucla.edu>

	Improve time zone documentation

	* doc/lispref/os.texi (Time Zone Rules):
	New section, mostly with material moved here from other sections.
	* doc/emacs/cmdargs.texi (General Variables):
	* doc/lispref/os.texi (Time Conversion, Time Parsing):
	Xref new section.
	* etc/NEWS, etc/PROBLEMS:
	* lisp/org/org.el (org-timestamp-format):
	* src/editfns.c (Fformat_time_string, Fdecode_time)
	(Fencode_time, Fcurrent_time_string, Fcurrent_time_zone)
	(Fset_time_zone_rule):
	When documenting time zone rule strings, mention the TZ
	environment variable in preference to mentioning the
	sort-of-internal function set-time-zone-rule.

2016-04-12  Phillip Lord  <phillip.lord@russet.org.uk>

	Prevent bootstrap autoload backup files

	 * lisp/emacs-lisp/autoload.el (autoload-find-generated-file): Suppress
	   backups in newly created file.

	  (autoload-ensure-default-file): Function split into two.
	  (autoload-ensure-file-writeable): New function from split.

	  (Bug#23203)

2016-04-11  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	Disable multicolor fonts on OS X since they are not supported on free systems

	* src/macfont.m (macfont_list): Don't use color bitmap fonts.

2016-04-11  Paul Eggert  <eggert@cs.ucla.edu>

	Capitalize “Universal Time” in documentation

	It’s a proper noun.
	* lisp/vc/add-log.el (add-log-time-zone-rule): Also, fix typo by
	mentioning ‘format-time-string’ instead of ‘set-time-zone-rule’.

2016-04-11  Eli Zaretskii  <eliz@gnu.org>

	Don't use 'find-program'

	* lisp/progmodes/project.el (project-file-completion-table): Use
	'grep-find-program', rather than the obsolete 'find-program'.

2016-04-11  Paul Eggert  <eggert@cs.ucla.edu>

	Sync with gnulib

	This is for picky compilers whose stdint.h fails our C11 tests.
	Problem reported for clang by Philipp Stephani (Bug#23261).
	This incorporates:
	2016-04-11 stdint: port to strict C11 left shift
	* doc/misc/texinfo.tex, lib/stdint.in.h: Copy from gnulib.

2016-04-11  Leo Liu  <sdl.web@gmail.com>

	Fix last change on 2016-01-02

	* lisp/emacs-lisp/lisp-mode.el (lisp-el-font-lock-keywords-2): Move
	  `cl-errs-re' before `lisp--el-match-keyword'; don't use `prepend'
	  which highlights `cl-errs-re' even in comments or strings.

2016-04-11  Paul Eggert  <eggert@cs.ucla.edu>

	Port run-prolog EMACS to SWI-Prolog 7.2.3

	* lisp/progmodes/prolog.el (prolog-ensure-process):
	Work around incompatibility of SWI-Prolog 7.2.3 and earlier
	with the new way of dealing with the EMACS and INSIDE_EMACS
	environment variables.

2016-04-10  Eli Zaretskii  <eliz@gnu.org>

	Avoid crashes due to unreasonably large or small text scaling

	* lisp/face-remap.el (text-scale-min-amount)
	(text-scale-max-amount): New functions.
	(text-scale-set, text-scale-increase): Use them to limit the text
	scaling to a reasonable range of values.  (Bug#23259)

2016-04-10  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'with-eval-after-load'

	* lisp/subr.el (with-eval-after-load): Doc fix.  (Bug#23258)

2016-04-10  Eli Zaretskii  <eliz@gnu.org>

	Improve handling of non-ASCII characters in Git log messages

	* lisp/vc/vc-git.el (vc-git-commits-coding-system): Now a defcustom.
	(vc-git-log-output-coding-system): New defcustom.
	(vc-git-print-log, vc-git-command, vc-git--call): Use
	'vc-git-log-output-coding-system' for reading stuff from Git.
	Don't override values of 'coding-system-for-read/write' if they
	are bound by caller -- this allows the user to force an encoding
	via "C-x RET c".
	(vc-git-checkin): On MS-Windows, pass the log message via a
	temporary file, to work around the limitations on passing
	non-ASCII characters via command-line arguments.  Force using the
	'locale-coding-system' for Git command-line arguments.  This fixes
	problems with non-ASCII commit log messages on MS-Windows.
	(Bug#23076)

	* etc/NEWS: Mention the new vc-git related defcustoms.

2016-04-09  Philipp Stephani  <phst@google.com>

	Remove undefined behavior in OS X dumper.

	Found by Address Sanitizer.

	* src/unexmacosx.c (unexec_write): Use Mach virtual memory API to
	avoid undefined behavior when reading arbitrary memory.

2016-04-09  Joakim Verona  <joakim@verona.se>

	Fix clipping of xwidgets

	* src/xwidget.c (x_draw_xwidget_glyph_string): Use window_box
	instead of calculating the clipping borders manually.  Suggested
	by YAMAMOTO Mitsuharu <mituharu@math.s.chiba-u.ac.jp>.

2016-04-09  Eli Zaretskii  <eliz@gnu.org>

	Improve Lisp-level documentation of tooltips

	* doc/lispref/display.texi (Tooltips): New section.  (Bug#23246)
	(Display): Update the chapter menu.
	* doc/lispref/text.texi (Special Properties): Make the "tooltip"
	index entry more concrete.  Change the cross-reference to point to
	"Tooltips" in the ELisp manual.
	* doc/lispref/elisp.texi (Top): Update the master menu.
	* doc/emacs/frames.texi (Tooltips): Include more customization
	variables.  Add a cross-reference to the ELisp manual.

2016-04-08  Glenn Morris  <rgm@gnu.org>

	Faces names should not end in "-face".

	* lisp/rect.el (rectangle-preview): Rename from rectangle-preview-face.
	* lisp/vc/vc-hooks.el (vc-state-base): Rename from vc-state-base-face.

2016-04-08  Paul Eggert  <eggert@cs.ucla.edu>

	* src/xsmfns.c (syms_of_xsmfns): Remove stray "s in doc strings.

2016-04-08  Paul Eggert  <eggert@cs.ucla.edu>

	Comint and compile no longer set EMACS

	This mostly restores the change that I reverted on March 23,
	fixing most of Bug#20202.  The only part of the change that is
	still reverted is the change to M-x term, where compatibility with
	current Bash constrains us from moving too quickly (Bug#20484).
	Problem reported by Phillip Lord in: https://bugs.gnu.org/20484#108
	* etc/NEWS: Document this.
	* lisp/comint.el (comint-exec-1):
	* lisp/net/tramp-sh.el (tramp-remote-process-environment):
	* lisp/progmodes/compile.el (compilation-start):
	Don’t set EMACS=t in the subsidiary process.

2016-04-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/subr.el (read-key): Don't let the prompt linger (bug#22714)

2016-04-08  Eli Zaretskii  <eliz@gnu.org>

	Allow to customize names of executables used by grep.el

	* lisp/progmodes/grep.el (grep-find-program): Renamed from
	'find-program', which was a variable.  All uses changed.
	(grep-xargs-program): Renamed from 'xargs-program', which was a
	variable.  All uses changed.
	(grep-program): Now a defcustom rather than a simple variable.
	(Bug#23219)

2016-04-08  Alan Third  <alan@idiocy.org>

	Set locale encoding to UTF-8 when run from OS X GUI.

	* src/nsterm.m (ns_init_locale): Append .UTF-8 when setting LANG.

2016-04-08  Eli Zaretskii  <eliz@gnu.org>

	Avoid signaling errors in 'M-n' at the 'C-x C-f' prompt

	* lisp/ffap.el (ffap-guess-file-name-at-point): Ignore errors
	while 'ffap-guesser' runs.  (Bug#23218)

2016-04-08  Marcin Borkowski  <mbork@mbork.pl>

	Avoid infinite loop in 'studlify-word'

	* lisp/play/studly.el (studlify-region): Call
	'forward-word-strictly' and 'backward-word-strictly' instead of
	'forward-word' and 'backward-word'.  (Bug#19940)

2016-04-07  Paul Eggert  <eggert@cs.ucla.edu>

	Don’t recommend obsolete EMACS env var

	* doc/misc/efaq.texi (Escape sequences in shell output):
	Remove long-obsolete (and now-confusing) notes about
	the EMACS environment variable in Emacs 21.1 and earlier.
	* doc/misc/efaq.texi (^M in the shell buffer):
	* etc/PROBLEMS:
	Remove obsolescent recommendation to consult the EMACS environment
	variable.

2016-04-07  Glenn Morris  <rgm@gnu.org>

	* lisp/emacs-lisp/package.el: Change from a few days ago needs seq.

	* lisp/emacs-lisp/seq.el: Load cl-lib, not cl-extra.

2016-04-07  Leo Liu  <sdl.web@gmail.com>

	Fix "Beginning of buffer" error in forward-page

	* lisp/textmodes/page.el (forward-page): Check before move to prevent
	  "Beginning of buffer" error.

2016-04-06  Dmitry Gutov  <dgutov@yandex.ru>

	Add a `transient' project type

	* lisp/progmodes/project.el (project-roots): Implement for the
	`transient' project type (bug#23224).
	(project-current): Instead of signaling an error, return a
	transient project instance rooted in the chosen directory.

2016-04-06  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	Revert "Backport HTTPS proxy fix"

	This reverts commit 2d1a6054b161bd1055d4feb11c8c5ac95543f5db.

	It's too late in the Emacs 25 release cycle to add things like this to
	Emacs 25.1.  It's border line new feature.

2016-04-06  Tao Fang  <fangtao0901@gmail.com>

	Backport HTTPS proxy fix

	Cherry-picked from 3c623c26ae7d695746e05d8a2e16a67a6256b024

	Backport:

2016-04-06  Paul Eggert  <eggert@cs.ucla.edu>

	Fix stability confusion in sort-tests

	Problem reported by Philipp Stephani (Bug#23205).
	* test/automated/sort-tests.el:
	(sort-tests--insert-words-sort-and-compare):
	Don’t assume that reversing a sorted list is the same
	as sorting with the reverse predicate.  This is not true
	for stable sorts when items compare equal.

2016-04-05  Paul Eggert  <eggert@cs.ucla.edu>

	Avoid describe-key error with lambdas

	Problem reported by Sho Takemori (Bug#22716).
	* lisp/cedet/mode-local.el (describe-mode-local-overload)
	(xref-mode-local-overload): Use function-overload-p instead
	of assuming the argument is a symbol.

2016-04-04  Artur Malabarba  <bruce.connor.am@gmail.com>

	* lisp/emacs-lisp/package.el (package-install-selected-packages):

	Skip unavailable packages.

2016-04-04  Paul Eggert  <eggert@cs.ucla.edu>

	Sync with gnulib

	This incorporates:
	2016-04-03 stdint: detect good enough pre-C++11 stdint.h in C++ mode
	2016-04-01 stddef: support configuring with g++
	* doc/misc/texinfo.tex, lib/stddef.in.h, m4/stdint.m4:
	Copy from gnulib.

2016-04-03  Paul Eggert  <eggert@cs.ucla.edu>

	Fix doc for Universal Time

	* doc/lispref/os.texi (Time of Day, Time Conversion):
	Be more careful about distinguishing UTC (which is not valid for
	pre-1961 time stamps) and UT (which is).
	(Time Parsing): Remove stray obsolete paragraph about a
	UNIVERSAL argument for ‘format-time-string’.

2016-04-03  Michael Albinus  <michael.albinus@gmx.de>

	Handle Bug#23186

	* lisp/net/tramp.el (tramp-encoding-command-switch)
	(tramp-encoding-command-interactive):
	* lisp/net/tramp-sh.el (tramp-maybe-open-connection):
	`tramp-encoding-shell' could be nil.  (Bug#23186)

2016-04-03  Paul Eggert  <eggert@cs.ucla.edu>

	More format-time-string change fixups

	* lisp/net/tramp-sh.el (tramp-sh-handle-set-file-times):
	* lisp/org/org.el (org-timestamp-format):
	Fix doc to match new format-time-string behavior.
	* lisp/org/ox-icalendar.el (org-icalendar-convert-timestamp):
	Use (not (not X)) to treat non-nil values of utc arg as UTC.

2016-04-02  Paul Eggert  <eggert@cs.ucla.edu>

	make-xwidget unused arg cleanup

	* doc/lispref/display.texi (Xwidgets): Remove stray refs.
	* src/xwidget.c (syms_of_xwidget): Qwebkit, not Qwebkit_osr.

2016-04-02  Joakim Verona  <joakim@verona.se>

	Remove unused arguments from make-xwidget

	The arguments BEG and END were unused, and are now removed.

	* doc/emacs/display.texi (Xwidgets): Document the change
	* lisp/xwidget.el (make-xwidget, xwidget-insert)
	(xwidget-webkit-new-session): Reflect changed arguments
	* src/xwidget.c (Fmake_xwidget, syms_of_xwidget): Reflect changed arguments

2016-04-02  Eli Zaretskii  <eliz@gnu.org>

	Document incompatible changes in 'format-time-string'

	* etc/NEWS: Mention the incompatible change in the interpretation
	of the 3rd argument to 'format-time-string'.  (Bug#21943)

2016-04-02  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of byte-code objects

	* doc/lispref/compile.texi (Byte-Code Objects): Document the
	integer format of the argument descriptor.  (Bug#23061)

2016-04-02  Eli Zaretskii  <eliz@gnu.org>

	Adapt calls to 'format-time-string' to changes in Emacs 25

	* lisp/vc/pcvs-info.el (cvs-fileinfo-from-entries): Use t as the
	last argument to format-time-string.  (Bug#23128)
	* lisp/gnus/gmm-utils.el (gmm-format-time-string): Use t as the
	last argument to format-time-string, when the TZ argument is not a
	number, per the doc string.

2016-04-02  Eli Zaretskii  <eliz@gnu.org>

	Improve vc-diff with Git backend

	* lisp/vc/vc-git.el (vc-git-command): Don't override
	coding-system-for-read/write if they are already bound.
	Suggested by joaotavora@gmail.com (João Távora).  (Bug#20892)
	(vc-git-print-log): Don't override coding-system-for-read if it's
	already bound.

2016-04-01  Dmitry Gutov  <dgutov@yandex.ru>

	(js--continued-expression-p): Special-case unary plus and minus

	* lisp/progmodes/js.el (js--continued-expression-p): Make an
	effort to recognize unary plus and minus, in the contexts where
	they make sense (https://github.com/mooz/js2-mode/issues/322).

2016-04-01  Alan Mackenzie  <acm@muc.de>

	Prevent C++ Mode wrongly fontifying some identifiers near templates as types

	This fixes debbugs #7917.

	* lisp/progmodes/cc-engine.el (c-forward-keyword-prefixed-id): Accept 'maybe
	(from c-forward-type) as sufficient to record an id.  Record type id as well
	as ref ids.
	(c-forward-name): Bind c-last-identifier-range around the call to
	c-forward-<>-arglist to prevent it getting corrupted.  Don't automatically
	assume an identifier is a type when a template ">" is followed by a "(".
	(c-forward-type): Don't automatically assume an identifier is a type when a
	template ">" is followed by a "(".

	* lisp/progmodes/cc-fonts.el (c-font-lock-<>-arglists): Don't fontify an
	identifier as a type when its associated ">" is followed by a "(".

2016-04-01  Eli Zaretskii  <eliz@gnu.org>

	Avoid crashes due to insanely large columns in tabulated-list-format

	* src/xdisp.c (append_stretch_glyph, produce_xwidget_glyph)
	(produce_image_glyph): Limit the pixel width of the produced glyph
	to SHRT_MAX.  (Bug#23178)
	(append_composite_glyph, append_glyph, append_glyphless_glyph):
	Add assertions to verify that the pixel width of the glyph will
	never overflow a 'short'.
	* src/term.c (append_composite_glyph): Add assertion to verify
	that the pixel width of the glyph will never overflow a 'short'.

2016-03-31  Mark Oteiza  <mvoteiza@udel.edu>

	Teach M-x disassemble a default argument.

	Adopts default argument in the same way as `describe-function'.
	* lisp/emacs-lisp/disass.el (disassemble): Default to function at point,
	if any.

2016-03-31  Eli Zaretskii  <eliz@gnu.org>

	Fix EOL decoding in vc-annotate with SVN back-end on MS-Windows

	* lisp/vc/vc-annotate.el (vc-annotate): Force DOS EOL decoding on
	MS-Windows and MS-DOS, when processing the output of "svn annotate".

2016-03-31  Michael Albinus  <michael.albinus@gmx.de>

	Fix OS X specific settings in tramp-tests

	* lisp/net/tramp-sh.el (tramp-maybe-open-connection): Use it.

	* lisp/net/tramp.el (tramp-get-local-locale): New defun.

	* test/automated/tramp-tests.el (tramp--test-darwin-p): Remove.
	(tramp--test-utf8): Improve settings of coding systems.
	Do not use `tramp--test-darwin-p' anymore.  (Bug#22145)

2016-03-30  Alan Mackenzie  <acm@muc.de>

	Finish fixing a cacheing bug in CC Mode (see 2016-03-09)

	* lisp/progmodes/cc-cmds.el: (c-beginning-of-defun, c-end-of-defun): Remove
	superfluous invocations of c-self-bind-state-cache.

	* lisp/progmodes/cc-defs.el: (c-self-bind-state-cache): Copy and terminate
	markers correctly.

	* lisp/progmodes/cc-engine.el (c-record-parse-state-state): Terminate stale
	markers.

2016-03-29  Xue Fuqiao  <xfq.free@gmail.com>

	* doc/lispref/text.texi (Columns): Remove a nonexistent reference.

	The example was removed by Chong Yidong on Mar 5, 2012.

2016-03-29  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/man/emacsclient.1: Document +line:column option.

2016-03-29  Eli Zaretskii  <eliz@gnu.org>

	Fix rare problems with echo-area display and multiple frames

	* src/xdisp.c (redisplay_window): Bind inhibit-redisplay non-nil
	around the call to x_consider_frame_title, to prevent
	resize_mini_window from undoing echo-area display.  (Bug#23124)

2016-03-29  Alan Mackenzie  <acm@muc.de>

	In M-%, avoid making buffer-local binding of text-property-default-nonsticky

	This would happen when that variable already has a buffer local binding.  Such
	a binding would not be seen by read-from-minibuffer.  This fixes bug #23127.

	* lisp/replace.el (query-replace-read-from): Move the binding of
	text-property-default-nonsticky to inside of a new with-current-buffer buffer
	form with the minibuffer as argument.

2016-03-27  Dmitry Gutov  <dgutov@yandex.ru>

	Remove prog-indentation-context

	* lisp/progmodes/prog-mode.el: (prog-indentation-context)
	(prog-first-column, prog-widen): Remove, as discussed in
	https://lists.gnu.org/r/emacs-devel/2016-03/msg01425.html.

	* doc/lispref/text.texi (Mode-Specific Indent): Remove references
	to them.

	* etc/NEWS: Ditto.

	* lisp/progmodes/python.el: (prog-widen, prog-first-column):
	Remove the compatibility aliases and all uses.

	Do not merge to master.

2016-03-27  Paul Eggert  <eggert@cs.ucla.edu>

	* src/font.c (QCuser_spec): Add missing colon to :user-spec.

2016-03-27  Eli Zaretskii  <eliz@gnu.org>

	Don't start the 'midnight' timer twice

	* lisp/midnight.el (midnight-mode): Avoid starting the midnight
	timer twice when activating the mode the first time.  (Bug#23123)

2016-03-27  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* src/xwidget.c (Fxwidget_resize): Fix inappropriate use of XFASTINT.

2016-03-26  Stephen Berman  <stephen.berman@gmx.net>

	Fix todo-mode category movement

	* lisp/calendar/todo-mode.el (todo-move-category): Use moved
	category's existing categories sexp instead of invoking
	todo-update-categories-sexp in file moved to, in order to take
	archived items into account.  If the moved category has archived
	items, handle the source archive buffer properly.  Remove
	superfluous code.

2016-03-26  Glenn Morris  <rgm@gnu.org>

	* lisp/xt-mouse.el (xterm-mouse-utf-8): Add :version.

2016-03-26  Eli Zaretskii  <eliz@gnu.org>

	Ignore non-nil. non-cons values of unread-command-events

	* src/keyboard.c (requeued_events_pending_p, read_char)
	(Finput_pending_p): Use CONSP instead of !NILP to see if there are
	unread command events to be processed.  (Bug#22976)

2016-03-26  Eli Zaretskii  <eliz@gnu.org>

	Improve documentatuon of 'truncate-partial-width-windows'

	* src/xdisp.c (syms_of_xdisp) <truncate-partial-width-windows>:
	Clarify in the doc string how the width of partial-width windows
	is computed for the purposes of truncation decision.  (Bug#4338)

	* doc/emacs/windows.texi (Split Window): Clarify how the width of
	windows is calculated for the purposes of truncation decision.
	* doc/emacs/display.texi (Line Truncation): Remove a redundant
	index entry.

2016-03-25  Paul Eggert  <eggert@cs.ucla.edu>

	* src/ftfont.c (ftfont_shape_by_flt): Parenthesize as per GNU style.

2016-03-25  Eli Zaretskii  <eliz@gnu.org>

	Fix 'dired-goto-file' in Dired buffers produced by find-dired

	* lisp/dired.el (dired-goto-file): Try looking for the file as a
	relative name with leading sub-directories, before looking for the
	basename alone.  (Bug#23089)

2016-03-25  Nicolas Petton  <nicolas@petton.fr>

	Fix map-put and map-delete for alists (Bug#23105)

	* lisp/emacs-lisp/map.el (map-put): Do not bind the evaluated place
	expression to a new symbol.
	* test/automated/map-tests.el: Add a regression test.

2016-03-25  Eli Zaretskii  <eliz@gnu.org>

	Minor copyedits of documentation for temporary displays

	* doc/emacs/windows.texi (Temporary Displays): Improve indexing.
	Minor changes in wording.
	(Window Choice, Displaying Buffers, Pop Up Window): Disambiguate
	index entries for 'display-buffer'.

	* etc/NEWS: Minor rewording of the entry about temporary displays.

2016-03-25  Philipp Stephani  <phst@google.com>

	Add customization option for using UTF-8 coordinates in xt-mouse

	* lisp/xt-mouse.el (xterm-mouse-utf-8): New customization option.
	(xterm-mouse--read-coordinate): New function to replace
	`xterm-mouse--read-utf8-char'; uses UTF-8 only if enabled.
	(xterm-mouse--read-number-from-terminal): Adapt to new name.
	(xterm-mouse-tracking-enable-sequence)
	(xterm-mouse-tracking-disable-sequence): Replace constants with
	functions, mark constants as obsolete.
	(xterm-mouse--tracking-sequence): New helper function.
	(turn-on-xterm-mouse-tracking-on-terminal): Use new functions;
	enable UTF-8 only if customization option says so; store UTF-8
	flag in terminal parameter.  (Bug#23009)

	* test/automated/xt-mouse-tests.el: Add tests for xt-mouse.el.

2016-03-25  Eli Zaretskii  <eliz@gnu.org>

	Minor doc string fixes in replace.el

	* lisp/replace.el (query-replace, query-replace-regexp)
	(query-replace-regexp-eval, map-query-replace-regexp)
	(replace-string, replace-regexp): Clarify in doc strings that
	these commands operate from point to the end of the buffer's
	accessible portion.  (Bug#23067)

2016-03-25  Eli Zaretskii  <eliz@gnu.org>

	Fix scrolling upwards with 'xwidget-webkit-browse-url'

	* src/xwidget.c (Fxwidget_set_adjustment): Use CHECK_NUMBER instead
	of CHECK_NATNUM.  Suggested by Shayan Pirani <shayanpirani@gmail.com>.
	(Bug#22918)

2016-03-25  K. Handa  <handa@gnu.org>

	Fix display of Indic scripts

	* src/ftfont.c (ftfont_shape_by_flt): For combining characters out
	of the range U+300...U+36F, use the "combining" FLT only with
	non-OTF fonts.

2016-03-25  Eli Zaretskii  <eliz@gnu.org>

	Fix splash screen display at startup

	* src/frame.c (DEFAULT_ROWS): Enlarge to 36, so that the initial
	window displayed by "emacs -q" has enough space to show the whole
	text even if it includes 2 lines talking about recovering crashes
	sessions.  (Bug#23074)

	* lisp/startup.el (use-fancy-splash-screens-p): Fix off-by-one
	error when computing the window-height from frame-height.

	* etc/NEWS: Mention the change.

2016-03-25  Martin Rudalics  <rudalics@gmx.at>

	Describe temporary displays in Emacs manual

	* doc/emacs/emacs.texi (Temporary Displays): New subsubsection.
	* doc/emacs/windows.texi (Window Choice): Minor fixes.
	(Temporary Displays): New subsubsection describing display of
	temporary buffers and `temp-buffer-resize-mode'.

2016-03-24  Paul Eggert  <eggert@cs.ucla.edu>

	Avoid stray As next to IDLW icons

	* lisp/progmodes/idlw-toolbar.el (idlwave-toolbar-add-everywhere):
	Use "" for empty labels, not "a", as the latter now displays stray
	"A"s (Bug#18997).

2016-03-24  Paul Eggert  <eggert@cs.ucla.edu>

	Avoid GTK 3 crash with icons and masks

	Problem reported by Mosè Giordano (Bug#18997).
	* src/gtkutil.c (xg_get_pixbuf_from_pixmap): Remove.
	(xg_get_pixbuf_from_pix_and_mask): Do not use
	xg_get_pixbuf_from_pixmap, as it is poorly documented.  Instead,
	invoke XGetPixel directly.  This is slow but speed is not
	important here.  Also, fail for unusual situations (not TrueColor,
	or images that are not 8 bits per sample) instead of displaying
	junk or crashing.

2016-03-24  Juri Linkov  <juri@linkov.net>

	* lisp/minibuffer.el (minibuffer-completion-help): Use fit-window-to-buffer

	instead of shrink-window-if-larger-than-buffer.  (Bug#23092)

2016-03-24  Eli Zaretskii  <eliz@gnu.org>

	Define make_save_ptr_ptr unconditionally

	* src/alloc.c (make_save_ptr_ptr): Remove the !(defined
	USE_X_TOOLKIT || defined USE_GTK) conditional.  Reported by
	Philipp Stephani <phst@google.com>.  (Bug#23101)

2016-03-24  Eli Zaretskii  <eliz@gnu.org>

	Preserve current buffer when popping up TTY menus

	* src/term.c (tty_menu_show): Be sure to save and restore the
	current buffer around TTY menu pop-ups.  (Bug#23101)

2016-03-24  Eli Zaretskii  <eliz@gnu.org>

	Improve font selection by family on MS-Windows

	* src/w32font.c (w32font_list_internal): Allow 'ascii-0' charset,
	in addition to 'iso10646-1', 'unicode-bmp', and 'unicode-sip'.
	This avoids rejecting many font families whose members are shown
	by 'font-family-list', in particular 'courier' requested by
	info.el.  Without this change, many values of ':family' attribute
	of a face have no effect on MS-Windows, because they are rejected
	due to bogus mismatch of the charset.

2016-03-23  Paul Eggert  <eggert@penguin.cs.ucla.edu>

	Comint, term, and compile now set EMACS

	This fixes directory tracking in ansi-term, at the expense of
	breaking some usages of 'configure'.  Setting EMACS is meant to be
	a somewhat temporary measure, until Bash 4.4 comes out and is
	common.  (Bug#20484).
	* etc/NEWS: Document this.
	* lisp/comint.el (comint-exec-1):
	* lisp/net/tramp-sh.el (tramp-remote-process-environment):
	* lisp/progmodes/compile.el (compilation-start):
	* lisp/term.el (term-exec-1):
	Go back to setting the EMACS environment variable, for backward
	compatibility to Bash 4.3 and earlier.

2016-03-23  Paul Eggert  <eggert@penguin.cs.ucla.edu>

	Ignore more merges when generating ChangeLog

	* build-aux/gitlog-to-emacslog: Ignore all merges from gnu.org,
	not merely those from master and emacs-NN.  The ChangeLog entries
	they generate are not that useful.

2016-03-23  Paul Eggert  <eggert@cs.ucla.edu>

	Sync with gnulib

	This incorporates:
	2016-03-22 gitlog-to-changelog: suppress ignored chatter
	2016-03-21 sys_select: port to new Cygwin
	* build-aux/gitlog-to-changelog, doc/misc/texinfo.tex:
	* lib/sys_select.in.h: Copy from gnulib.

2016-03-23  Paul Eggert  <eggert@cs.ucla.edu>

	Resurrect GNUS-NEWS autogeneration

	* doc/misc/gnus-coding.texi (Gnus Maintenance Guide): Update
	GNUS-NEWS section to match current file locations and procedure.
	* etc/GNUS-NEWS: Regenerate by using new procedure.
	* lisp/Makefile.in (update-gnus-news): New rule, containing a
	procedure for building GNUS-NEWS.  The old procedure got lost
	somehow when Gnus was merged into Emacs.

2016-03-22  Anders Lindgren  <andlind@gmail.com>

	Make `toggle-frame-maximized' respect the dock on OS X (bug#22988).

	* src/nsterm.m (ns_screen_margins): New function.
	(ns_screen_margins_ignoring_hidden_dock): New function.
	(ns_menu_bar_height): Reimplement in terms of `ns_screen_margins'.
	([EmacsWindow zoom:]): Take all screen margins (except those
	originating from a hidden dock) into account.

2016-03-22  Eli Zaretskii  <eliz@gnu.org>

	Fix bug in displaying header line with a box face

	* src/xdisp.c (get_next_display_element): Handle the case when a
	display string acquires the box face from an underlying string,
	not from the buffer.  (Bug#23091)

2016-03-21  Kaushal Modi  <kaushal.modi@gmail.com>

	Fix an Isearch var to be a string (Bug#23038)

	* lisp/isearch.el (isearch--describe-regexp-mode): The `description' var
	  needs to always be a string.  Add the missing default case for the
	  cond form that ensures that.

	Before this bug fix, for the events when `regexp-function' and
	`search-default-mode' both were nil, `description' also stayed nil.  So
	when `space-before' was non-nil, the "non-string" `description'
	(with a value of nil) got passed as an argument to
	`replace-regexp-in-string' (where a string was expected).  That caused
	the error described in Bug#23038.

2016-03-21  Leo Liu  <sdl.web@gmail.com>

	Fix (args-out-of-range 1) error in cursor-sensor--detect

	* lisp/emacs-lisp/cursor-sensor.el (cursor-sensor--detect): Don't
	  hard-code (point-min) as 1 which fails in narrowed buffers.

2016-03-20  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	Render empty <ul><li><ul> correctly

	* lisp/net/shr.el (shr-tag-ul): Render empty <ul><li><ul>
	correctly (bug#22964).
	(cherry picked from commit 4f6ea3988b66cf132c67fd0cc26d12eb9a300ba1)

	Backport:

2016-03-20  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	Ignore invalid base64 encoded embedded images

	* lisp/net/shr.el (shr-image-from-data): Ignore invalid base64
	encoded embedded images (bug#22928).
	(cherry picked from commit f2da80d0e1ccd121c4891e869a45aeb9c6b1795d)

	Backport:

2016-03-20  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	Fix <p> and <div> newlines with or without <li> in shr

	* lisp/net/shr.el (shr-ensure-newline): Respect that we're in
	a <li>, if we are, and don't insert newlines there.
	(shr-ensure-paragraph): When mixing newlines and paragraph
	ensurements, don't insert too many blank lines.
	(shr-tag-div): A <div> shouldn't introduce a paragraph, but a
	new line.
	(cherry picked from commit 292921facaff2f02ac4e8602c1f7ecbdcfe7ef45)

	Backport:

2016-03-19  Eli Zaretskii  <eliz@gnu.org>

	Avoid errors in 'newline'

	* lisp/simple.el (newline): Don't barf if invoked with
	non-positive argument in the middle of a line.  (Bug#22490)

2016-03-19  Michael Albinus  <michael.albinus@gmx.de>

	Fix Bug#23032

	* doc/misc/eshell.texi (Arguments): Mention the pipe symbol in
	remote file names.  (Bug#23032)

2016-03-19  Eli Zaretskii  <eliz@gnu.org>

	Adjudicate review comments in abbrevs.texi

	* doc/lispref/abbrevs.texi (Abbrev Files, Abbrev Expansion):
	* doc/emacs/abbrevs.texi (Dabbrev Customization): State the
	default values of variables.  Suggested by Steve Byrne
	<sbb@penguinis.org>.  (Bug#23016)

	* admin/release-process (Check manuals): Mark files reviewed by
	Steve Byrne.

2016-03-18  Dmitry Gutov  <dgutov@yandex.ru>

	Fixup the "normal" matcher; highlight global var symbols, too

	* lisp/progmodes/ruby-mode.el (ruby-font-lock-keywords): Highlight
	operator name symbols with the "normal" matcher (it actually
	needed updating).  Highlight global variable symbols, too.

2016-03-18  Marcin Borkowski  <mbork@mbork.pl>

	Honor prefix arg in doc-view-next-line-or-next-page

	* lisp/doc-view.el (doc-view-next-line-or-next-page): Take the
	prefix argument into consideration when continuous scrolling is
	not in effect (i.e., by default) (bug#19559).

2016-03-18  Paul Eggert  <eggert@cs.ucla.edu>

	Port to strict C99 offsetof

	* src/bidi.c (bidi_copy_it):
	* src/lisp.h (CHAR_TABLE_EXTRA_SLOTS):
	Use only a single identifier as the second argument of offsetof.
	Found by using clang -pedantic.

2016-03-18  Paul Eggert  <eggert@cs.ucla.edu>

	Port to GTK with strict C11 compiler

	* src/gtkutil.c (xg_create_frame_widgets, xg_toggle_notify_cb):
	Cast from function type to void * where the C standard requires this.
	This works around a problem in the prototypes for
	g_signal_handler_find and g_signal_handlers_block_by_func, which
	use gpointer instead of GCallback.  Found by using gcc -pedantic.

2016-03-18  Paul Eggert  <eggert@cs.ucla.edu>

	Port to GTK with strict C99 compiler

	* src/emacsgtkfixed.c: Use workaround for GNOME bug 683906 only
	in glib 2.35.6 and earlier, since the bug is fixed in 2.35.7.
	* src/emacsgtkfixed.c (EmacsFixedPrivate):
	* src/emacsgtkfixed.h (EmacsFixedClass):
	Remove duplicate typedef, which strict C99 does not allow (Bug#23003).

2016-03-17  Anders Lindgren  <andlind@gmail.com>

	Avoid screen artifacts with new OS X visible bell after scrolling

	* src/nsterm.m (EmacsBell): Save NSView when displaying the
	visible bell and set `needsDisplay' when removed.
	(hide_bell): Trace.
	(ns_copy_bits): Trace.

2016-03-17  Michael Albinus  <michael.albinus@gmx.de>

	Suppress some Tramp tests for OSX, do not merge with master

	* test/automated/tramp-tests.el (tramp--test-darwin-p): New defun.
	(tramp--test-utf8): Use it.  (Bug#22145)

2016-03-17  Glenn Morris  <rgm@gnu.org>

	* lisp/progmodes/xref.el (xref-buffer-name, xref--window):
	Move definitions before use.

	* lisp/gnus/mm-decode.el (gnus-format-message): Autoload it.

	* lisp/mail/rmail.el (rmail-mime-entity-truncated): Declare.

2016-03-17  Glenn Morris  <rgm@gnu.org>

	Address compilation warnings due to 2016-01-03 mml refactoring.

	* lisp/gnus/mml-sec.el (password-cache, mm-encode): Require.
	(message-options-get): Autoload.
	(message-options-set): Declare.
	(mml-secure-cache-passphrase, mml-secure-passphrase-cache-expiry):
	Simplify default value.
	* lisp/gnus/mml-smime.el (message-options-set): Remove declaration.
	* lisp/gnus/mml1991.el, lisp/gnus/mml2015.el:
	No longer a need for password-cache.

2016-03-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/emacs-lisp/smie.el (smie-indent-keyword): Don't burp in strings

	(bug#22960).

2016-03-16  Glenn Morris  <rgm@gnu.org>

	* lisp/dired-x.el (dired-omit-here-always): Correct error message
	for 2016-01-25 change.

	* lisp/dired-x.el (dired-omit-here-always): Replace undefined function
	removed 2016-01-30.

	* lisp/xml.el (xml-parse-tag-1): Replace undefined function.

2016-03-16  Eli Zaretskii  <eliz@gnu.org>

	Avoid segfaults due to frame image cache being absent

	* src/image.c (cache_image): If the frame doesn't have an image
	cache, create it.  (Bug#23028)

2016-03-16  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of glyphless-character display

	* doc/emacs/display.texi (Text Display): Document and index the
	'glyphless-char' face.

2016-03-16  Dmitry Gutov  <dgutov@yandex.ru>

	Support safe navigation operator in non-SMIE indentation code

	* lisp/progmodes/ruby-mode.el (ruby-calculate-indent):
	Support safe navigation operator in non-SMIE indentation code.
	Cherry-picked from
	https://github.com/ruby/ruby/commit/68e16ddd7961b86e5013e62ae2954e88638de058.

2016-03-16  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	Move xsd:base64Binary decoding fix to debbugs.el 0.9.1

	* lisp/net/soap-client.el (soap-encode-xs-basic-type): Do not
	assume xsd:base64Binary values are UTF-8 strings.
	(soap-decode-xs-basic-type): Likewise.
	(soap-invoke): Document xsd:base64Binary handling.

2016-03-15  Dmitry Gutov  <dgutov@yandex.ru>

	Fix Ruby's operator precedence

	* lisp/progmodes/ruby-mode.el (ruby-smie-grammar):
	Rearrange the smie-precs->prec2 form.

2016-03-15  Dmitry Gutov  <dgutov@yandex.ru>

	(ruby-interpolation-inside-another-interpolation): New failing test

	* test/automated/ruby-mode-tests.el
	(ruby-interpolation-inside-another-interpolation):
	New failing test.

2016-03-15  Paul Eggert  <eggert@cs.ucla.edu>

	Port to clang 3.7.0 on x86-64

	* configure.ac: Use AS_IF so that gl_WARN_ADD’s prerequisites are
	not done conditionally.  This helps clang, which needs
	-Wunknown-warning-option later when configured with warnings.
	* src/editfns.c (invalid_time): Now _Noreturn, since clang isn’t
	smart enough to figure this out on its own if warnings are enabled.
	(lisp_time_struct): Redo for clarity, and to pacify clang.
	* src/xfns.c (x_real_pos_and_offsets) [USE_XCB]: Don’t use
	uninitialized locals.  This avoids undefined behavior and pacifies
	clang.

2016-03-15  Glenn Morris  <rgm@gnu.org>

	* test/automated/package-test.el (package-test-signed): Tweak skip
	condition, for hydra.

2016-03-15  Paul Eggert  <eggert@cs.ucla.edu>

	Sync with gnulib

	This incorporates:
	2016-03-15 time_rz: port to clang -Wunused-const-variable
	2016-03-15 select: port more to Intel 2016.1.150 compiler
	* lib/sys_select.in.h, lib/time_rz.c: Copy from gnulib.

2016-03-15  Eli Zaretskii  <eliz@gnu.org>

	Fix startup of "emacs -nw" on systems that CANNOT_DUMP

	* src/xdisp.c (syms_of_xdisp) <resize-mini-windows>: Initialize to
	nil.

	* lisp/loadup.el <resize-mini-windows>: Set to 'grow-only' after
	loading window.el.  (Bug#22975)

2016-03-14  Dmitry Gutov  <dgutov@yandex.ru>

	Do not tokenize a comment before continuation as ';'

	* lisp/progmodes/ruby-mode.el (ruby-smie--implicit-semi-p):
	Account for a comment right after point.

2016-03-14  Dmitry Gutov  <dgutov@yandex.ru>

	Don't misindent arguments of a method call inside continuation

	* lisp/progmodes/ruby-mode.el (ruby-smie-rules):
	Use smie-indent-virtual instead of smie-rule-parent (bug#23015).
	Simplify the traversal loop.

2016-03-14  Stefan Monnier  <monnier@iro.umontreal.ca>

	* src/keyboard.c (echo_keystrokes_p): Don't test cursor_in_echo_area

	(read_key_sequence): Test it here, as before.
	(bug#22825).

2016-03-14  Paul Eggert  <eggert@cs.ucla.edu>

	ASCII-only etc/NEWS etc.

	* etc/NEWS, nextstep/README: Revert the recently-added curved
	quotes, and stick to ASCII.  This typically involves replacing
	curved with straight quotes.  Since etc/NEWS is viewed so often by
	UTF-8-ignorant tools, rewrite its non-ASCII text to spell out
	Unicode, e.g., replace ‘‒’ with ‘U+2012 (FIGURE DASH)’.

2016-03-14  Alan Mackenzie  <acm@muc.de>

	Fix a cacheing bug, which led to inordinately slow c-beginning-of-defun.

	* lisp/progmodes/cc-defs.el (c-self-bind-state-cache): New macro.

	* lisp/progmodes/cc-engine.el (c-ssb-lit-begin): Always call c-parse-state
	rather than just using the cache variable c-state-cache.
	(c-syntactic-skip-backward): Invoke c-self-bind-state-cache to isolate calls
	to c-parse-state from other uses of the parse state cache.

	* lisp/progmodes/cc-cmds.el (c-beginning-of-defun, c-end-of-defun): Invoke
	c-self-bind-state-cache around the processing, replacing flawed bindings of
	c-state-cache.

2016-03-14  Alan Mackenzie  <acm@muc.de>

	Fix a cacheing bug, which led to inordinately slow c-beginning-of-defun.

	* lisp/progmodes/cc-defs.el (c-self-bind-state-cache): New macro.

	* lisp/progmodes/cc-engine.el (c-ssb-lit-begin): Always call c-parse-state
	rather than just using the cache variable c-state-cache.
	(c-syntactic-skip-backward): Invoke c-self-bind-state-cache to isolate calls
	to c-parse-state from other uses of the parse state cache.

	* lisp/progmodes/cc-cmds.el (c-beginning-of-defun, c-end-of-defun): Invoke
	c-self-bind-state-cache around the processing, replacing flawed bindings of
	c-state-cache.

2016-03-14  Kaushal Modi  <kaushal.modi@gmail.com>

	Fix Isearch prompt when invoked with an argument

	* lisp/isearch.el (isearch--describe-regexp-mode): With
	`search-default-mode' set to nil, if user does C-u C-s, the minibuffer
	now displays "Regexp I-search: " again.  But if the user has set
	`search-default-mode' to t, and then does C-s, the minibuffer now
	displays "I-search: " because the default search mode is now regexp
	mode.  Comments have been added to explain the priority of conditions
	in the `cond' form.  (Bug#22991)

2016-03-14  Cesar Quiroz  <cesar.quiroz@gmail.com>  (tiny change)

	Fix a typo in the Emacs manual

	* doc/emacs/maintaining.texi (VC Directory Commands): Fix a typo
	in a command name.

2016-03-14  Paul Eggert  <eggert@cs.ucla.edu>

	Curved quotes in etc/NEWS etc.

	* etc/NEWS, nextstep/README: Prefer curved quotes in the
	recently-changed text documentation.  See:
	https://lists.gnu.org/r/emacs-devel/2016-03/msg00860.html

2016-03-14  Paul Eggert  <eggert@cs.ucla.edu>

	Fix some single quotes in documentation

	* doc/emacs/anti.texi (Antinews): Avoid confusion in info and PDF
	when documenting quoting styles.
	* etc/NEWS, nextstep/README: In these plain text files, quote
	'like this' consistently, rather than also (sometimes) ‘like this’
	or (more often) `like this'.

2016-03-13  Dmitry Gutov  <dgutov@yandex.ru>

	Make lisp-completion-at-point's argument optional

	* lisp/progmodes/elisp-mode.el (lisp-completion-at-point): Make
	the argument optional, like it was before the rename.

2016-03-13  Dmitry Gutov  <dgutov@yandex.ru>

	Tweak the left precedence of '=>'

	* lisp/progmodes/ruby-mode.el (ruby-smie-grammar): Tweak the left
	precedence of '=>', to improve indentation and sexp navigation.

2016-03-13  Dmitry Gutov  <dgutov@yandex.ru>

	Indent '.' relative to the first sibling expression

	* lisp/progmodes/ruby-mode.el (ruby-smie-rules):
	Indent '.' relative to the first sibling expression, instead of the
	parent token (bug#17213).

2016-03-13  Dmitry Gutov  <dgutov@yandex.ru>

	Make '.' associative, for easier sexp navigation

	* lisp/progmodes/ruby-mode.el (ruby-smie-grammar):
	Make '.' associative, for easier sexp navigation.

2016-03-13  Phillip Lord  <phillip.lord@russet.org.uk>

	Revert "Simplify "Visit New File" to "New File""

	This reverts commit d457fd9dc782465e1547f74021390c9d5951d6af.

2016-03-12  Phillip Lord  <phillip.lord@russet.org.uk>

	Simplify "Visit New File" to "New File"

	* doc/emacs/files.texi, lisp/menu-bar.el (menu-bar-file-menu),
	  lisp/startup.el(normal-mouse-start-screen,
	  normal-no-mouse-startup-screen): Change label "Visit New File" to "New
	  File".

2016-03-12  Eli Zaretskii  <eliz@gnu.org>

	Update Unicode notes for importing a new Unicode version

	* admin/notes/unicode: Mention the need to update otf-script-alist
	in fontset.el when importing data files from a new Unicode
	version.

2016-03-12  Eli Zaretskii  <eliz@gnu.org>

	Import new data files from Unicode 9.0.0beta

	* admin/unidata/UnicodeData.txt:
	* admin/unidata/Blocks.txt:
	* admin/unidata/BidiMirroring.txt:
	* admin/unidata/BidiBrackets.txt: Update from Unicode 9.0.0beta.
	* admin/unidata/unidata-gen.el (unidata-gen-files): Bind
	'coding-system-for-read' to 'utf-8, as various Unicode data files
	now actually use non-ASCII characters.
	(unidata-setup-list, unidata-get-name): Support the new Tangut
	Ideographs block.

	* lisp/international/characters.el (standard-case-table): Add new
	characters from Unicode 9.0.0.
	(standard-category-table): Add Arabic block u+08A0..u+08FF.  Add
	Cyrillic Extended-C block.
	(char-width-table): Update ranges per Unicode 9.0.0.
	* lisp/international/fontset.el (script-representative-chars): Add
	new scripts defined by Unicode 9.0.0.
	(otf-script-alist): Add new OTF script tags.
	* lisp/international/mule-cmds.el (ucs-names): Update ranges per
	Unicode 9.0.0 additions.

2016-03-12  Eli Zaretskii  <eliz@gnu.org>

	Avoid errors in forms-mode when default major mode is text

	* lisp/forms.el (forms-mode): Bind
	change-major-mode-with-file-name to nil when calling
	set-visited-file-name.  (Bug#22982)

2016-03-12  Eli Zaretskii  <eliz@gnu.org>

	Avoid crashes at startup on systems that CANNOT_DUMP

	* src/xdisp.c (syms_of_xdisp) <redisplay--inhibit-bidi>: New
	boolean variable.
	(init_iterator, reseat_to_string)
	(Fcurrent_bidi_paragraph_direction)
	(Fbidi_find_overridden_directionality): Use
	redisplay--inhibit-bidi instead of purify-flag, to determine when
	it's safe to reorder bidirectional text.

	* lisp/loadup.el (redisplay--inhibit-bidi): Set to t at the
	beginning of the file.  Reset to nil when charprop.el is
	successfully loaded, or when we are going to dump, whichever
	happens last.  (Bug#22975)

2016-03-12  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of seq.el functions

	* doc/lispref/sequences.texi (Sequence Functions): Fix typos.  Add
	cross-references.  Fix formatting.  (Bug#22992)

2016-03-11  Dmitry Gutov  <dgutov@yandex.ru>

	Support Ruby 2.3.0's safe navigation operator

	* lisp/progmodes/ruby-mode.el (ruby-smie--forward-token)
	(ruby-smie--backward-token): Tokenize '&.' as '.'.
	(ruby-smie--implicit-semi-p): Check for possible '&' before '.'.

	* test/indent/ruby.rb: Add an example using safe navigation
	operator.  Fix a syntax error in existing example.

2016-03-11  John Wiegley  <johnw@newartisans.com>

	Update Emacs manual section related to character folding

	* doc/emacs/search.texi: Character folding is not on by default.

2016-03-11  Eli Zaretskii  <eliz@gnu.org>

	Update admin/notes/unicode

	* admin/notes/unicode: Update the list of files from the UCD we
	are using.  Mention the possible need to change 'ucs-names' when
	importing a new version of the Unicode Standard.

2016-03-10  Dmitry Gutov  <dgutov@yandex.ru>

	Add symref-filepattern entries for c?perl-mode

	* lisp/cedet/semantic/symref/grep.el
	(semantic-symref-filepattern-alist): Add entries for perl-mode and
	cperl-mode.

2016-03-10  Ken Raeburn  <raeburn@raeburn.org>

	Don't use XRANDR 1.3 extensions if the server doesn't support them.

	* src/xterm.h (struct x_display_info): Add fields to save XRANDR
	version number.
	* src/xfns.c (x_get_monitor_attributes): Save the version numbers
	after querying the X server.
	(x_get_monitor_attributes_xrandr): Don't use XRRGetOutputPrimary or
	XRRGetScreenResourcesCurrent if the server doesn't support at least
	RANDR version 1.3.  Conditionalize the code blocks on compiling
	against library version 1.3 or better, rather than feature tests for
	each function.
	* configure.ac: Stop testing for those two functions.

2016-03-10  Paul Eggert  <eggert@cs.ucla.edu>

	Sync with gnulib

	This incorporates:
	2016-03-08 intprops: make .h file license match module
	2016-03-08 acl: fix missing return on Cygwin
	2016-03-05 extern-inline: port to PGI CC
	* doc/misc/texinfo.tex, lib/intprops.h, lib/set-permissions.c:
	* m4/extern-inline.m4:
	Copy from gnulib.

2016-03-10  Paul Eggert  <eggert@cs.ucla.edu>

	Rework C source files to avoid ^(

	Work around Bug#22884 by rewording comments and strings to avoid ‘(’
	at the start of a line unless it starts a function.  This change
	is a short-term hack; in the longer run we plan to fix cc-mode’s
	performance for C files that have ‘(’ at the start of a line in a
	comment or string.

2016-03-10  Eli Zaretskii  <eliz@gnu.org>

	By default, etags produces unqualified Perl tag names

	* lib-src/etags.c (Perl_functions): Produce unqualified names,
	unless -Q was specified.
	(print_help): Update the description of -Q.

	* doc/man/etags.1: Update the documentation of -Q.

	* test/etags/ETAGS.good_1:
	* test/etags/ETAGS.good_2:
	* test/etags/ETAGS.good_3:
	* test/etags/ETAGS.good_4:
	* test/etags/ETAGS.good_5:
	* test/etags/CTAGS.good: Adapt the expected test results to the
	changed Perl functionality.

2016-03-10  Dmitry Gutov  <dgutov@yandex.ru>

	Indent methods with keyword names correctly

	* lisp/progmodes/ruby-mode.el (ruby-smie--at-dot-call):
	Rename to ruby-smie--before-method-name.  Now also check if we're
	after a 'def' keyword.  Update both callers.

2016-03-10  Dmitry Gutov  <dgutov@yandex.ru>

	Propertize character literals and special global variables differently

	* lisp/progmodes/ruby-mode.el (ruby-syntax-propertize): Propertize
	character literals and global variables with special names with
	prefix and symbol syntax classes, for SMIE to tokenize them
	together automatically.
	(ruby-font-lock-keywords): Fix an old regression in highlighting
	character literals.

2016-03-09  John Wiegley  <johnw@newartisans.com>

	Change how /etc/NEWS presents character folding

	* NEWS: Note that character folding is no longer the default.

2016-03-09  John Wiegley  <johnw@newartisans.com>

	Revert "Revert "Backport: * lisp/isearch.el: Turn char-folding off by default""

	This reverts commit a91b4b51ddf2575d821adb8b84fdf32cff83886e.

2016-03-09  Andreas Schwab  <schwab@linux-m68k.org>

	Properly handle lambda as read function (bug 22961)

	* src/lread.c (readchar): Be more strict about checking for
	string in cons for read_vector.
	(unreadchar): Likewise.

2016-03-09  Dmitry Gutov  <dgutov@yandex.ru>

	Propertize operator symbol names with symbol syntax class

	* lisp/progmodes/ruby-mode.el (ruby-syntax-propertize):
	Do it here.
	(ruby-font-lock-keywords): Instead of handling them here.  Leave
	highlighting them to the "normal" matcher, because now we can.
	(ruby-smie--forward-token, ruby-smie--backward-token):
	Likewise, don't special-case operator symbols anymore.
	(ruby-smie--args-separator-p): Simplify the regexp, match operator
	names with \s_.
	(ruby-smie--implicit-semi-p): Handle the special cases of ? and =
	at EOL the same way: check if the character has been assigned the
	symbol syntax class by syntax-propertize.

2016-03-09  Dmitry Gutov  <dgutov@yandex.ru>

	Stop recognizing :#{} as symbol in ruby-mode

	* lisp/progmodes/ruby-mode.el (ruby-font-lock-keywords): Remove
	the weird part that recognized colon followed by interpolation
	construct without quotes (e.g. ':#{abc}') as symbol, which is just a
	syntax error in any modern version of Ruby.  Fix nearby bug reference.

2016-03-09  Dmitry Gutov  <dgutov@yandex.ru>

	Allow using the left shift operator without spaces on both sides

	* lisp/progmodes/ruby-mode.el (ruby-singleton-class-p): Rename to
	ruby-verify-heredoc, reverse the meaning of the return value, and
	short-circuit if preceded by a symbol not separated by whitespace.

	* test/automated/ruby-mode-tests.el (ruby-no-heredoc-left-shift)
	(ruby-no-heredoc-class-self): New tests.

2016-03-08  Andreas Schwab  <schwab@linux-m68k.org>

	Properly handle unquoting in wdired (bug 22938)

	The recorded old names are not quoted, don't unquote them.

	* lisp/wdired.el (wdired-normalize-filename): Add argument
	unquotep, only unquote if non-nil.
	(wdired-get-filename): Don't unquote the old file name.
	(wdired-get-previous-link): Always unquote.

2016-03-06  Dmitry Gutov  <dgutov@yandex.ru>

	Allow splat operator before percent literal

	* lisp/progmodes/ruby-mode.el (ruby-syntax-propertize):
	Allow splat operator before percent literal.

2016-03-06  Dmitry Gutov  <dgutov@yandex.ru>

	Don't apply the return value of goto-char as syntax class

	* lisp/progmodes/ruby-mode.el (ruby-syntax-propertize): Don't
	apply the return value of goto-char as syntax class.

2016-03-06  Dmitry Gutov  <dgutov@yandex.ru>

	Guard against nested percent literals

	* lisp/progmodes/ruby-mode.el
	(ruby-syntax-propertize-percent-literal):
	Don't check the syntax status.
	(ruby-syntax-propertize): Check it here.  And also guard against
	being in a larger percent literal.

	* test/automated/ruby-mode-tests.el
	(ruby-no-nested-percent-literals): New test.

2016-03-06  Dmitry Gutov  <dgutov@yandex.ru>

	Recognize iuwu-mod after an escaped newline

	* lisp/progmodes/ruby-mode.el (ruby-smie--bosp): Check if the
	newline is escaped.
	(ruby-smie-rules): Indent iuwu-mod after an escaped newline
	correctly.

2016-03-06  Andreas Schwab  <schwab@linux-m68k.org>

	Fix symbolic mode string conversion for s and t

	* lisp/files.el (file-modes-char-to-right): Fix values for ?s and
	?t.
	(file-modes-symbolic-to-number): Default to a for ts permissions.

2016-03-06  Eli Zaretskii  <eliz@gnu.org>

	Update 'ucs-names' database

	* lisp/international/mule-cmds.el (ucs-names): Update used and
	unused ranges from the latest UnicodeData.txt.

2016-03-06  Eli Zaretskii  <eliz@gnu.org>

	Improve doc string of 'shell-command'

	* lisp/simple.el (shell-command): Mention that COMMAND is prompted
	for.  (Bug#22926)

2016-03-06  Eli Zaretskii  <eliz@gnu.org>

	Make the code in movemail_strftime more general

	* lib-src/movemail.c (movemail_strftime): Transform the format
	string passed by the caller instead of using a separate format
	string.

2016-03-06  Eli Zaretskii  <eliz@gnu.org>

	Speed up redisplay of binary files with long series of nulls

	* src/bidi.c (bidi_resolve_weak): Avoid entering a loop searching
	for a character needed for resolving the type of a series of BN
	and ET characters, as required by rule W5 of UAX#9, if the results
	of the resolution are known in advance, because we are at level
	zero, and the previous strong character was L.
	(bidi_resolve_neutral): Partially resurrect the optimization for a
	long series of control characters in an otherwise strictly L2R
	text.
	(bidi_level_of_next_char): Don't enter the loop that searches for
	a paragraph separator if the current character is already at base
	embedding level.  (Bug#22739)

2016-03-05  Dmitry Gutov  <dgutov@yandex.ru>

	Remove the highlighting support for quoting 'like this' inside Lisp docstrings

	Remove the highlighting support for quoting 'like this' inside
	Lisp docstrings.  This part of
	c4151ebe15479de4c2e511b068cdf9af6a4576cf seems to have been
	unintentional, considering substitute-command-keys gives wrong
	output for such usage.
	* lisp/emacs-lisp/lisp-mode.el (lisp-el-font-lock-keywords-2)
	(lisp-cl-font-lock-keywords-2): Do not highlight text between two
	straight quotes as symbol.

2016-03-05  Paul Eggert  <eggert@cs.ucla.edu>

	Restore leading space in movemail pop output

	* lib-src/movemail.c (movemail_strftime) [WINDOWSNT]: New function.
	(strftime) [WINDOWSNT]: New macro.
	(mbx_delimit_begin): Go back to previous version of this code,
	now that there’s a special-purpose WINDOWSNT implementation
	that should do the right thing.  That way, the output continues
	to use leading space rather than leading zero for day of month.

2016-03-05  Eli Zaretskii  <eliz@gnu.org>

	Fix bidi-paragraph-direction in Rmail view buffer

	* lisp/mail/rmail.el (rmail-show-message-1): Reset
	bidi-paragraph-direction to nil before formatting the message for
	display.

2016-03-05  Dmitry Gutov  <dgutov@yandex.ru>

	Don't misindent computed property generator methods

	* lisp/progmodes/js.el (js--looking-at-operator-p):
	Don't misindent computed property generator methods
	(https://github.com/mooz/js2-mode/issues/317).

2016-03-05  Eli Zaretskii  <eliz@gnu.org>

	Fix mbox files produced by movemail on MS-Windows

	* lib-src/movemail.c (mbx_delimit_begin): Use portable strftime
	format specifiers, as at least the MS-Windows version of strftime
	doesn't support %e and %T.

2016-03-04  Paul Eggert  <eggert@cs.ucla.edu>

	doc string file descriptor exhaustion fix

	* src/doc.c (get_doc_string): Move newly-added check to a better
	location (Bug#22814).

2016-03-04  Michael Albinus  <michael.albinus@gmx.de>

	Fix Bug#22814

	* src/doc.c (get_doc_string): Raise an error in case too many
	files are open.  (Bug#22814)

2016-03-04  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix insertion of edited servers in the dribble file

	* lisp/gnus/gnus-srvr.el (gnus-server-update-server): Don't
	insert explicit newlines, because they're quoted (bug#22903).

	Backport:

	(cherry picked from commit ca4e30058eba0531f38fff75f14734acffab84ea)

2016-03-04  Martin Rudalics  <rudalics@gmx.at>

	Fix previous fix of enlarge-/shrink-window

	* lisp/window.el (enlarge-window, shrink-window): Consistently
	signal user-error instead of error.  Resize minibuffer window by
	delta lines instead of pixels.  When a window cannot be resized,
	signal an error only when this function was invoked by a command
	in the enlarge-/shrink-window group (this restores the behavior
	before the fix of bug#22723 for the non-interactive case).

2016-03-03  Artur Malabarba  <bruce.connor.am@gmail.com>

	* lisp/isearch.el (isearch-define-mode-toggle): Fix toggling logic

2016-03-03  Mark Oteiza  <mvoteiza@udel.edu>

	Complete temperature units in calc-convert-temperature

	* lisp/calc/calc-units.el (calc-convert-temperature): Complete with
	temperature units in math-standard-units.

2016-03-02  Dmitry Gutov  <dgutov@yandex.ru>

	Make sure to use case-sensitive search

	* lisp/progmodes/xref.el (xref-collect-references): Make sure to
	use case-sensitive search.

2016-03-02  Ulf Jasper  <ulf.jasper@web.de>

	Prevent infinite loop on not-well-formed xml. (Bug#16344)

	* lisp/xml.el (xml-parse-tag-1): Prevent inifinite loop. (Bug#16344)
	* test/automated/xml-parse-tests.el (xml-parse-tests--bad-data): Add
	  test cases for Bug#16344.

2016-03-02  Alan Third  <alan@idiocy.org>

	Add the missing test case for the previous patch

	lisp/dabbrev.el (dabbrev--substitute-expansion): Return EXPANSION after
	any processing.
	lisp/dabbrev.el (dabbrev-expand): Set EXPANSION to the return value of
	DABBREV--SUBSTITUTE-EXPANSION.
	test/automated/dabbrev-tests.el (dabbrev-expand-test): Test for bug#1948.

2016-03-02  Alan Third  <alan@idiocy.org>

	Use the correct dabbrev expansion

	lisp/dabbrev.el (dabbrev--substitute-expansion): Return EXPANSION after
	any processing.
	lisp/dabbrev.el (dabbrev-expand): Set EXPANSION to the return value of
	DABBREV--SUBSTITUTE-EXPANSION.
	test/automated/dabbrev-tests.el (dabbrev-expand-test): Test for bug#1948.

2016-03-02  Nicolas Petton  <nicolas@petton.fr>

	Bump version to 25.0.92

	* README:
	* configure.ac:
	* msdos/sed2v2.inp: Bump version to 25.0.92.

2016-03-02  Nicolas Petton  <nicolas@petton.fr>

	* etc/AUTHORS: Update the AUTHORS file

2016-03-02  Nicolas Petton  <nicolas@petton.fr>

	authors.el updates

	* admin/authors.el (authors-ignored-files): Addition.

2016-03-02  Michael Albinus  <michael.albinus@gmx.de>

	Fix Bug#22859

	* lisp/filenotify.el (file-notify-callback): Return a `deleted'
	event in case of kqueue and file1 is nil.  (Bug#22859)

2016-03-01  Eli Zaretskii  <eliz@gnu.org>

	Fix reordering of bidi text in an isolate inside an override

	* src/bidi.c (bidi_resolve_explicit): Override the orig_type value
	of FSI with either LRI or RLI, as determined by the first strong
	directional character in the isolate.  This prevents failure to
	isolate when the FSI...PDI text is inside a directional override.
	(Bug#22786)

2016-03-01  Alan Mackenzie  <acm@muc.de>

	Document c-guess-basic-syntax in the CC Mode manual.

	* doc/misc/cc-mode.texi (Syntactic Analysis): Document the function, adding
	pxrefs to Custom Line-Up and Other Indentation.
	(Custom Line-Up): Add a note on using c-guess-basic-syntax with a pxref to
	Syntactic Analysis.

2016-03-01  Michael Albinus  <michael.albinus@gmx.de>

	Fix targets in test/automated/Makefile.in

	* test/automated/Makefile.in: Use $(SELECTOR_DEFAULT) also for
	empty target and target all.

2016-03-01  Leo Liu  <sdl.web@gmail.com>

	Comment on last change to define-derived-mode

	* lisp/emacs-lisp/derived.el (define-derived-mode): Add comment.

2016-03-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Allow binding `url-mime-accept-string'

	* lisp/url/url-http.el (url-http): Allow binding
	`url-mime-accept-string' (bug#22855).

	Backport:

	(cherry picked from commit 144bb0cf322b9756d29def3e27a42303e2edce43)

2016-03-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Also allow setting the paragraph direction to nil

	* lisp/net/eww.el (eww-toggle-paragraph-direction): Also allow
	setting the paragraph direction to nil ("auto").

2016-02-29  Anders Lindgren  <andlind@gmail.com>

	Made the new OS X visible bell more visible.

	* src/nsterm.m: (EmacsBell:init:) Scaled up the visible bell
	  "caution" image five times, as the image in its original size
	  was hard to see.

2016-02-29  Lars Ingebrigtsen  <larsi@gnus.org>

	Use the correct background color when filling nested <divs>

	* lisp/net/shr.el (shr-face-background): Return the first
	background, because that's the one that's visible (bug#22680).

	Backport:

	(cherry picked from commit cad0bc70558f9c28c808711c5295dec9fc5ad6e5)

2016-02-29  Lars Ingebrigtsen  <larsi@gnus.org>

	Make <div> in <li> not insert extra newlines

	* lisp/net/shr.el (shr-tag-div): Make <div> in <li> not insert
	extra newlines (bug#19587).

	Backport:

	(cherry picked from commit 379a846b8548dc32a9019ef0a37c02f62cd9bad1)

2016-02-29  Dmitry Gutov  <dgutov@yandex.ru>

	Uncomment the next-error-function integration in xref

	* lisp/progmodes/xref.el (xref--xref-buffer-mode):
	Uncomment the next-error-function integration
	(https://debbugs.gnu.org/cgi/bugreport.cgi?bug=20489#110).

2016-02-29  Dmitry Gutov  <dgutov@yandex.ru>

	Remove the word "valid", to avoid ambiguity

	* doc/emacs/maintaining.texi (Identifier Search)
	(Looking Up Identifiers): Remove the word "valid" (bug#22692).

2016-02-28  Michael Albinus  <michael.albinus@gmx.de>

	Set auto-revert-use-notify to nil in global-auto-revert-mode.  (Bug#22814)

	* etc/NEWS:
	* etc/PROBLEMS: Mention this.

	* lisp/autorevert.el (global-auto-revert-mode): Set
	`auto-revert-use-notify' to nil.  (Bug#22814)

2016-02-28  Paul Eggert  <eggert@cs.ucla.edu>

	* etc/TODO: Minor quoting and grammar fixes.

2016-02-28  Friedrich Beckmann  <friedrich.beckmann@gmx.de>  (tiny change)

	Fix ModelSim error parsing

	* lisp/progmodes/vhdl-mode.el (vhdl-compiler-alist): Fix
	ModelSim error parsing (bug#5768).

2016-02-28  Lars Ingebrigtsen  <larsi@gnus.org>

	Make parse-time-string-chars faster

	* lisp/calendar/parse-time.el (parse-time-string-chars): Clean
	up the code (backport:).

2016-02-28  Lars Ingebrigtsen  <larsi@gnus.org>

	Add a eww command to toggle paragraph direction

	* lisp/net/eww.el (eww-toggle-paragraph-direction): New
	command and keystroke.

	* doc/misc/eww.texi (Advanced): Mention the `D' command.

2016-02-27  Glenn Morris  <rgm@gnu.org>

	* nextstep/WISHLIST: Merge into etc/TODO and remove.

	* etc/TODO: Merge in items from nextstep/WISHLIST.
	* nextstep/README: Update for this change.

2016-02-27  Andreas Schwab  <schwab@linux-m68k.org>

	Fix char signedness issue in bidi code

	* src/dispextern.h (struct bidi_t): Change type of resolved_level
	and isolate_level to signed char.  (Bug#22830)

2016-02-27  Andreas Schwab  <schwab@linux-m68k.org>

	* lib-src/pop.c (socket_connection): Fix format string.

2016-02-27  Eli Zaretskii  <eliz@gnu.org>

	Avoid inflooping in thing-at-point-looking-at

	* lisp/thingatpt.el (thing-at-point-looking-at): Avoid inflooping
	with regular expressions whose matching doesn't move point.
	(Bug#22756)
	Describe the argument DISTANCE in the doc string.

2016-02-27  Leo Liu  <sdl.web@gmail.com>

	* lisp/emacs-lisp/derived.el (define-derived-mode): Revert indent change.

2016-02-26  Michael Albinus  <michael.albinus@gmx.de>

	etc/PROBLEMS: Mention problems with using file descriptors

	* etc/PROBLEMS: Mention problems with using file descriptors
	of kqueue file notification library.

2016-02-26  Kaushal Modi  <kaushal.modi@gmail.com>

	* lisp/apropos.el (apropos-variable): Doc fix.  (Bug#22813).

2016-02-25  Eli Zaretskii  <eliz@gnu.org>

	Remove unneeded workaround in xftfont.c

	* src/xftfont.c (xftfont_open): Remove "dirty workaround" for
	XftTextExtents8 behavior, as it is no longer needed.  Suggested by
	Fangwen Yu <yynyygy@gmail.com>.  (Bug#22383)

2016-02-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/saveplace.el (save-place-local-mode): New minor mode

	(toggle-save-place): Define as obsolete alias.
	(save-place--setup-hooks): New function.
	(save-place-mode): Use it.

2016-02-25  Eli Zaretskii  <eliz@gnu.org>

	Fix redisplay on a TTY after 'make-frame'

	* src/xdisp.c (clear_garbaged_frames): Don't clear/redraw a
	garbaged TTY frame if it is not the selected frame.  (Bug#22794)

2016-02-25  Alan Mackenzie  <acm@muc.de>

	Make double-click-1 work with unbalanced parens in CC Mode.  Fixes bug#5560.

	* lisp/mouse.el (mouse-start-end): check the syntax of alleged parens with
	`syntax-after' to ensure syntax-table text properties are respected.

2016-02-25  Magnus Henoch  <magnus.henoch@gmail.com>

	Input method polish-slash should not use keyboard translation

	* lisp/leim/quail/latin-pre.el ("polish-slash"): Input method
	polish-slash should not use keyboard translation (bug#19081).

2016-02-25  Chris Feng  <chris.w.feng@gmail.com>

	Fix an assertion

	* src/dispnew.c (clear_glyph_matrix_rows): Test matrix->nrows == 0 (which
	implies start == 0) separately.

2016-02-24  Eli Zaretskii  <eliz@gnu.org>

	Fix 'toggle-save-place'

	* lisp/saveplace.el (toggle-save-place): Set up hooks necessary to
	support save-place in the buffer.  Autoload the command.

2016-02-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	* src/keyboard.c: Don't inadvertently set immediate_echo (bug#22581)

	* src/keyboard.c (read_key_sequence): Don't inadvertently set
	immediate_echo when we don't want any echo-keystrokes.
	(echo_keystrokes_p): Move earlier.

2016-02-24  Chris Zheng  <chriszheng99@gmail.com>  (tiny change)

	Minor fixes in calculator.el

	* lisp/calculator.el (calculator-mode-map): Bind `E' for
	`calculator-exp'.
	(calculator-last-input): Fix a bug with pressing F1.
	(Bug#20764)

2016-02-24  Anders Lindgren  <andlind@gmail.com>

	Update HISTORY section in readme for the NextStep interface.

	* nextstep/README: Update HISTORY after suggestion
	from former maintainer Adrian Robert.

2016-02-24  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'save-place-mode'

	* lisp/saveplace.el (toggle-save-place): Update the doc string wrt
	turning on 'save-place-mode' globally.

	* etc/NEWS: Mention the need to call 'save-place-mode' for turning
	on the mode in all buffers.

2016-02-24  Chris Feng  <chris.w.feng@gmail.com>  (tiny change)

	Allocate glyph matrices for the initial frame

	* src/frame.c (make_initial_frame): Allocate glyph matrices (Bug#22787).

	* src/dispnew.c (clear_glyph_matrix_rows): matrix->nrows can be 0.

2016-02-24  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix white space in last checkin

2016-02-24  Dima Kogan  <gnuplot@dima.secretsauce.net>

	Make `insert-pair' always leave the cursor where documented

	* lisp/emacs-lisp/lisp.el (insert-pair): The docstring of
	insert-pair states that after insertion, the point ends up
	after the opening character. This was not true if the pair was
	inserted to surround a region (bug#16949).

2016-02-24  Kaushal Modi  <kaushal.modi@gmail.com>

	etc/NEWS: Mention the new second parameter to `package-install'

	* etc/NEWS: Mention the new second parameter to
	`package-install' (bug#22784).

2016-02-24  John F. Trudeau  <JFTrudeau@aetna.com>  (tiny change)

	Highlight assignments in Makefiles more correctly

	* lisp/progmodes/make-mode.el (makefile-macroassign-regex):
	Highlight assignments preceded by a TAB character correctly
	(bug#20787).


	Backport:

	(cherry picked from commit bbd86c5642bd62c43d72391669f28eaa14459fd5)

2016-02-23  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of focus-related hooks

	* doc/lispref/commands.texi (Focus Events): Mention focus-related
	hooks.  (Bug#21728)

2016-02-23  Eli Zaretskii  <eliz@gnu.org>

	Further improve doc string of 'disable-point-adjustment'

	* src/keyboard.c (syms_of_keyboard): <disable-point-adjustment>
	<global-disable-point-adjustment>: Clarify doc strings.  (Bug#22771)

2016-02-23  Michael Albinus  <michael.albinus@gmx.de>

	Further adaptions in file-notify-tests.el for w32notify

	* test/automated/file-notify-tests.el
	(file-notify--test-read-event-timeout, file-notify--test-timeout):
	Decrease values.
	(file-notify-test03-autorevert)
	(file-notify-test04-file-validity)
	(file-notify-test05-dir-validity): Run tests also for w32notify.
	(file-notify-test08-watched-file-in-watched-dir):
	Adapt expected events for w32notify.

2016-02-23  Jan Tatarik  <jan.tatarik@gmail.com>

	Don't bug out on localized dates in gnus-icalendar

	* lisp/gnus/gnus-icalendar.el
	(gnus-icalendar-event:org-timestamp): Don't bug out on
	localized dates.

2016-02-23  Drew Adams  <drew.adams@oracle.com>

	(ls-lisp-insert-directory): Make -B work

	* lisp/ls-lisp.el (ls-lisp-insert-directory): Make -B work
	(bug#20776).

	Backport:

	(cherry picked from commit ef52e66efd78aac4c4e5bd5e11870e5ba3b37a1e)

2016-02-23  Vaidheeswaran C  <vaidheeswaran.chinnaraju@gmail.com>

	Make buttons in header lines work

	* lisp/help-mode.el (help-button-action): `help-xref-button' in
	header line doesn't work (bug#21024).

	Backport:

	(cherry picked from commit c11e565a6b6d09fa39d4c3ef65bef08190eaecc1)

2016-02-23  Christopher Wellons  <wellons@nullprogram.com>

	Make setf for frame-height/width work again

	* lisp/emacs-lisp/cl-lib.el (frame-height): Make setf for
	frame-height/width work again (bug#21979).

2016-02-23  Łukasz Stelmach  <stlman@poczta.fm>

	Encode header strings before printing

	* lisp/ps-print.el (ps-generate-header-line): Encode the
	header strings to avoid problems with non-ASCII headers
	(bug#22611).

	Backport:

	(cherry picked from commit 3cedbdcc71ebefc12bd20ec84f74251fe99ee7d0)

2016-02-23  Nicolas Richard  <youngfrog@members.fsf.org>

	(cl-union): Do not ignore :test argument when lists are equal.

	* lisp/emacs-lisp/cl-seq.el (cl-union): Do not ignore :test argument when lists are equal.

	* test/automated/cl-seq-tests.el: New file (bug#22729).

2016-02-23  Lars Ingebrigtsen  <larsi@gnus.org>

	Add `isearch' to `basic-faces'

	* doc/lispref/display.texi (Basic Faces): Mention the isearch
	and lazy-highlight faces.

	* lisp/replace.el (match): Add `isearch' to the `basic-faces'
	group, too (bug#22760).

2016-02-23  Dmitry Gutov  <dgutov@yandex.ru>

	Make $, : and @ "prefix characters" in ruby-mode

	* lisp/progmodes/ruby-mode.el (ruby-mode-syntax-table): Change the
	syntax classes of $, : and @ to "prefix character"
	(https://lists.gnu.org/r/emacs-devel/2016-01/msg00272.html).
	(ruby-syntax-propertize): Undo that specifically for colons
	followed by an opening paren or bracket.
	(ruby-font-lock-keyword-beg-re): Include colon character.
	(ruby-font-lock-keywords): Adjust the constants matcher for `:'
	not being a symbol constituent anymore.

2016-02-23  Dmitry Gutov  <dgutov@yandex.ru>

	Make find-tag-default-bounds more strict

	* lisp/subr.el (find-tag-default-bounds): Delegate to
	bounds-of-thing-at-point (bug#22692).

2016-02-22  Michael Albinus  <michael.albinus@gmx.de>

	Minor fixes in filenotify.el

	* lisp/filenotify.el (top): Require 'cl-lib.
	(file-notify--rm-descriptor)
	(file-notify--event-watched-file): Use cl-caadr.
	(file-notify-callback): Handle also `ignore' events from inotify.

2016-02-22  Michael Albinus  <michael.albinus@gmx.de>

	Additional fixes for file notification

	* lisp/filenotify.el (top): Require 'cl when compiling.
	(file-notify--event-watched-file): New defun.
	(file-notify--rm-descriptor, file-notify-callback):
	Handle case of several monitors running in parallel.

	* test/automated/file-notify-tests.el
	(file-notify--test-event-test): Simplify test.
	(file-notify--test-with-events): Get rid of outer definition.
	Check also results of tests performed in callbacks.
	(file-notify-test02-events): No wrapping when calling
	`file-notify-rm-watch'.  No special checking for callback tests.
	(file-notify-test07-backup): Adapt expected events for gfilenotify.
	(file-notify-test08-watched-file-in-watched-dir): Improve.

2016-02-22  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of 'global-disable-point-adjustment'

	* src/keyboard.c (syms_of_keyboard) <disable-point-adjustment>
	<global-disable-point-adjustment>: Doc fixes.  (Bug#22771)

2016-02-22  Daiki Ueno  <ueno@gnu.org>

	Set file modes of pinentry socket for extra safety

	* lisp/net/pinentry.el: Require 'cl-lib for `cl-letf'.
	(pinentry-start): Change the file modes of the socket file to 0700.
	This is just for extra safety since the parent directory is already
	protected with `server-ensure-safe-dir'.

2016-02-22  Daiki Ueno  <ueno@gnu.org>

	Clarify GnuPG version compatibility chapter

	* doc/misc/epa.texi (GnuPG version compatibility): Make the gpg-agent
	description a bit clearer.

2016-02-22  Daiki Ueno  <ueno@gnu.org>

	Revert "Change the default socket location for pinentry"

	This reverts commit e34fbdee8aca84b98393b06b2450837d175999ca.
	It turned out that the address is fixed in Pinentry itself.

2016-02-21  Dmitry Gutov  <dgutov@yandex.ru>

	Kill off xref--display-history

	Now that the core workflow keeps the xref window visible, there's
	less value in storing this history.  And it never was
	comprehensive enough to undo scrolling changes.
	* lisp/progmodes/xref.el (xref--display-history)
	(xref--save-to-history, xref-quit): Remove.
	(xref--show-pos-in-buf): Update accordingly.
	(xref--xref-buffer-mode-map): Remove xref-quit binding.

2016-02-21  Dmitry Gutov  <dgutov@yandex.ru>

	Keep the xref buffer visible until the user quits it explicitly

	* lisp/progmodes/xref.el (xref--pop-to-location):
	Rename WINDOW argument to ACTION.
	(xref--with-dedicated-window): New macro.
	(xref--show-pos-in-buf): Rename from `xref--display-position'.
	Add and handle new argument, SELECTED.  Use the above macro.
	(xref--show-location): Add SELECTED argument.
	(xref-show-location-at-point): Make an effort to avoid the
	original window when showing the location.
	(xref-goto-xref): Don't quit the xref window (bug#20487 and
	https://lists.gnu.org/r/emacs-devel/2016-01/msg01133.html).
	(xref--query-replace-1): Use xref--with-dedicated-window as well.
	(xref--next-error-function): Call xref--show-location instead of
	xref--pop-to-location.
	(xref--show-xrefs): Rename WINDOW argument to DISPLAY-ACTION.
	Only pass that value to xref--pop-to-location.  Pass the current
	selected window to xref-show-xrefs-function as the `window'
	property.
	(xref--find-xrefs, xref--find-definitions): Rename WINDOW argument
	to DISPLAY-ACTION as well.

2016-02-21  Daiki Ueno  <ueno@gnu.org>

	Change the default socket location for pinentry

	* lisp/net/pinentry.el: Require 'cl-lib for `cl-letf'.
	(pinentry--socket-dir): Change the default from /tmp/emacsXXX to
	~/.emacs.d/pinentry.
	(pinentry-start): Change the file modes of the socket file to 0700.
	This is just for extra safety since the parent directory is already
	protected with `server-ensure-safe-dir'.

2016-02-21  Daiki Ueno  <ueno@gnu.org>

	Mention how to enable pinentry feature

	* etc/NEWS: Mention "gpgconf --reload gpg-agent".
	* lisp/net/pinentry.el: Likewise.

2016-02-21  Paul Eggert  <eggert@cs.ucla.edu>

	Sync with gnulib

	This incorporates:
	2016-02-10 stdalign: port to older HP and IBM cc
	* doc/misc/texinfo.tex, lib/stdalign.in.h: Copy from gnulib.

2016-02-21  David Engster  <deng@randomsample.de>

	Remove `semanticdb-save-all-db-idle' from `auto-save-hook'

	* lisp/cedet/semantic/db-mode.el (semanticdb-hooks): Do not put
	  `semanticdb-save-all-db-idle' into `auto-save-hook'. The latter is
	  not an idle hook, so it's not appropriate to call it there. It will
	  already be called in the `semantic-idle-work-core-handler', which
	  runs when Emacs is actually idle.

2016-02-21  David Engster  <deng@randomsample.de>

	Restore point when writing semantic table to disk

	* lisp/cedet/semantic/db-file.el (object-write): Wrap call to
	  `semantic-fetch-tags' in `save-excursion', since it might move point
	  in current buffer. (Bug #22287)

2016-02-21  Daiki Ueno  <ueno@gnu.org>

	Mention pinentry.el in epa manual

	* doc/misc/epa.texi (GnuPG version compatibility): New chapter,
	describing the differences between three GnuPG branches, and how
	to enable pinentry.el.
	(Caching Passphrases): Add xref to the compatibility chapter.

2016-02-21  Michael Albinus  <michael.albinus@gmx.de>

	Fix Bug#22736

	* lisp/filenotify.el (file-notify-callback): Use the proper
	descriptor when calling the callback.  (Bug#22736)

	* test/automated/file-notify-tests.el
	(file-notify--test-event-handler): Deactivate trace.
	(file-notify-test08-watched-file-in-watched-dir): Bind
	`file-notify--test-tmpfile' temporarily in `dir-callback'.

2016-02-21  Wieland Hoffmann  <themineo@gmail.com>  (tiny change)

	Grammar fix in doc string

	* lisp/custom.el (defgroup): Grammar fix in doc string.

2016-02-20  Daiki Ueno  <ueno@gnu.org>

	Naming fix for consistency

	* lisp/epg-config.el (epg-find-configuration): Rename from
	`epg-configuration-find' to be consistent with other epg-* functions.
	Change all callers.

2016-02-20  Daiki Ueno  <ueno@gnu.org>

	Prefer customized value for GnuPG executable

	* lisp/epg-config.el (epg-configuration-find): Don't check GPG
	configuration if it is already set with custom.  (Bug#22747)

2016-02-20  Eli Zaretskii  <eliz@gnu.org>

	Fix memory reservation on MS-Windows

	* src/w32heap.c (mmap_alloc): Reserve memory in 64KB granular
	units.  This avoids leaving gaps in reserved memory regions that
	no one can use, since memory reservation must produce 64KB-aligned
	addresses.  (Bug#22526)

2016-02-20  Anders Lindgren  <andlind@gmail.com>

	Update NextStep readme and add wish list.

	* nextstep/README: Rewritten from scratch. New sections on
	"History", "Overview of Cocoa and Objective-C", "Guidelines",
	"Tracing Support", and "GNUStep". Expanded the "See Also" section.
	* nextstep/WISHLIST: New file containing list of issues and ideas
	associated with the NS port of Emacs.

2016-02-20  Michael Albinus  <michael.albinus@gmx.de>

	Report also result in `file-notify--test-event-handler'

2016-02-20  Michael Albinus  <michael.albinus@gmx.de>

	Improve file-notify-test08-watched-file-in-watched-dir

	* test/automated/file-notify-tests.el (file-notify--test-desc2):
	New variable.
	(file-notify--test-cleanup): Use it.
	(file-notify--test-event-handler): Enable trace.
	(file-notify-test08-watched-file-in-watched-dir): Tag it as
	:expensive-test.  Rewrite callbacks to use
	`file-notify--test-event-handler'.  Read events in loop.  Check
	`file-notify--test-results'.
	(file-notify-test08-watched-file-in-watched-dir): Fix docstring.

2016-02-20  Stephen Berman  <stephen.berman@gmx.net>

	Fix todo-mode item date editing bugs

	* lisp/calendar/todo-mode.el (todo-edit-item--header): Prevent out of
	range error by making sure the value of the numerical month date
	component cannot be nil.  Prevent wrong type error on trying to edit
	day number in February by making sure numerical instead of string
	value of the year component is passed to todo-read-date.
	(todo-read-date): When using the numerical month date component make
	sure to use `*' for an arbitrary month instead of its numerical value.

2016-02-20  Eli Zaretskii  <eliz@gnu.org>

	Fix "[:upper:]" for non-ASCII characters

	* src/regex.c (re_match_2_internal): Support [:upper:] and
	[:lower:] for non-ASCII characters.  (Bug#18150)

2016-02-20  Lars Ingebrigtsen  <larsi@gnus.org>

	Allow customizing the article mode cursor behavior

	* doc/misc/gnus.texi (HTML): Mention gnus-article-show-cursor.

	* lisp/gnus/gnus-art.el (gnus-article-show-cursor): New variable.
	(gnus-article-mode): Use it.

2016-02-20  Ari Roponen  <ari.roponen@gmail.com>

	Use pop-to-buffer-same-window in woman.el

	* lisp/woman.el (woman-really-find-file): Work around going to
	the wrong buffer by using `pop-to-buffer-same-window' (bug#22332).
	(WoMan-find-buffer): Ditto.

2016-02-20  Tassilo Horn  <tsdh@gnu.org>

	New filenotify test for bug#22736

	* test/automated/file-notify-tests.el
	(file-notify-test08-watched-file-in-watched-dir):
	(file-notify--test-desc1): New filenotify test for bug#22736

2016-02-20  Marcin Borkowski  <mbork@mbork.pl>

	Report critical battery errors

	* lisp/battery.el (battery-pmset): Report critical battery
	errors (bug#18157).

2016-02-19  Kaushal Modi  <kaushal.modi@gmail.com>  (tiny change)

	Make eww message toggling message clearer

	* lisp/net/eww.el (eww-toggle-fonts): Make the message
	clearer.

2016-02-19  Mark Oteiza  <mvoteiza@udel.edu>

	* lisp/calc/calc-units.el (math-standard-units): Update to 2014 CODATA adjustment.

2016-02-18  Martin Rudalics  <rudalics@gmx.at>

	Fix bugs in window resizing code

	* lisp/window.el (adjust-window-trailing-edge): Fix mismatched
	parenthesis.
	(shrink-window, enlarge-window): Fix bug#22723 where windows
	with preserved size would not get resized.  Also now signal an
	error when the window cannot be shrunk or enlarged as requested.

2016-02-17  Eli Zaretskii  <eliz@gnu.org>

	Fix decoding DOS EOL in a unibyte buffer

	* src/coding.c (decode_eol): Loop over bytes, not characters.
	(Bug#5251)

2016-02-17  Alan Mackenzie  <acm@muc.de>

	Correct c-parse-state cache manipulation error.

	* lisp/progmodes/cc-engine.el (c-invalidate-state-cache-1): Correct a
	comparison bound.  Amend comments.

2016-02-17  Daiki Ueno  <ueno@gnu.org>

	Take advantage of new GnuPG version check function

	* lisp/emacs-lisp/package.el (epg-configuration-find): Declare.
	(package-refresh-contents): Use `epg-configuration-find' to check if EPG
	is usable.

2016-02-17  Daiki Ueno  <ueno@gnu.org>

	Make GnuPG version check robuster

	We changed the default gpg program to "gpg2" from "gpg" in the commit
	f93d669a16bd3cb3f43f0c8cfd22fe18b627a6a1.  However, there are two
	maintained branches (2.0 and 2.1) and Emacs doesn't work well with 2.0
	series.  Check the actual version of "gpg2" at run time, and properly
	divert to "gpg" if necessary.
	* lisp/epg-config.el: Require 'cl-lib for `cl-destructuring-bind'.
	(epg-config--program-alist): New variable.
	(epg--configurations): New variable.
	(epg-configuration-find): New function.
	(epg-config--make-gpg-configuration): New function.
	(epg-config--make-gpgsm-configuration): New function.
	(epg-configuration): Mark as obsolete.
	* lisp/epg.el (epg-context): Use `epg-configuration-find'.

2016-02-17  Paul Eggert  <eggert@cs.ucla.edu>

	Fix x-load-color-file pointer signedness

	* src/xfaces.c (Fx_load_color_file) [!HAVE_X_WINDOWS]:
	For sscanf and int *, use %d, not %u.
	Problem found on Ubuntu 15.10 x32, which lacks X support.

2016-02-17  Paul Eggert  <eggert@cs.ucla.edu>

	* lisp/time-stamp.el (time-stamp-time-zone): Fix doc string punct.

2016-02-16  Mark Oteiza  <mvoteiza@udel.edu>

	Follow convention for greek letter constants.

	* lisp/calc/calc-units.el (math-standard-units):
	Add "sigma" and alias σ to it.

2016-02-16  Mark Oteiza  <mvoteiza@udel.edu>

	Add Stefan-Boltzmann constant to calc units table.

	* lisp/calc/calc-units.el (math-standard-units):
	Add Stefan-Boltzmann constant.

2016-02-16  Mark Oteiza  <mvoteiza@udel.edu>

	* lisp/calc/calc-units.el (math-build-units-table-buffer): Use special-mode.

2016-02-16  Glenn Morris  <rgm@gnu.org>

	Avoid loading cl-lib for term/xterm.elc, eg in -Q -nw.  (Bug#22669)

	* lisp/emacs-lisp/cl-generic.el (cl--generic-dispatchers):
	Prefill with relevant elements for term/xterm.

2016-02-16  Tassilo Horn  <tsdh@gnu.org>

	Fix soffice UserInstallation-URL for Windows

	* lisp/doc-view.el (doc-view-odf->pdf-converter-soffice): Fix
	UserInstallation-URL when calling soffice on Windows.

2016-02-16  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix display of <pre> elements

	* lisp/net/eww.el (eww-display-html): Remove CRLF before
	parsing so that <pre> elements don't render with ^M at the end
	of the lines.

2016-02-15  Eli Zaretskii  <eliz@gnu.org>

	Minor fixes in global-auto-composition-mode

	* lisp/emacs-lisp/easy-mmode.el (easy-mmode-pretty-mode-name):
	Produce prettier names of globalized minor modes.
	* lisp/composite.el (global-auto-composition-mode): Make it a
	globalized mode.  (Bug#22682)

2016-02-15  Alan Mackenzie  <acm@muc.de>

	Allow arithmetic operators inside C++ template constructs.

	Fixes debbugs #22486.  This corrects the previous patch with this message
	which was empty.

	* lisp/progmodes/cc-langs.el (c-multichar->-op-not->>-regexp): New language
	variable.
	(c-<>-notable-chars-re): New language variable.

	* lisp/progmodes/cc-engine.el (c-forward-<>-arglist-recur): User
	c-<>-notable-chars-re in place of the former fixed string in searching for
	places to stop and examine.
	Use c-multichar->-op-not->>-regexp to check that a found ">" is not part of a
	multichar operator in place of the former c->-op-without->-cont-regexp.
	Add code to skip forwards over a balanced parenthesized expression.

2016-02-15  Eli Zaretskii  <eliz@gnu.org>

	Avoid crashes in semi-malformed 'condition-case'

	* src/eval.c (internal_lisp_condition_case): Treat a handler
	'(nil)' as if it were '(nil nil)'.  (Bug#22675)

2016-02-15  Alan Mackenzie  <acm@muc.de>

	Allow arithmetic operators inside C++ template constructs.

	Fixes debbugs #22486.

	* lisp/progmodes/cc-langs.el (c-multichar->-op-not->>-regexp): New language
	variable.
	(c-<>-notable-chars-re): New language variable.

	* lisp/progmodes/cc-engine.el (c-forward-<>-arglist-recur): User
	c-<>-notable-chars-re in place of the former fixed string in searching for
	places to stop and examine.
	Use c-multichar->-op-not->>-regexp to check that a found ">" is not part of a
	multichar operator in place of the former c->-op-without->-cont-regexp.
	Add code to skip forwards over a balanced parenthesized expression.

2016-02-15  Eli Zaretskii  <eliz@gnu.org>

	Fix regression with 'recent-keys' and keyboard macros

	* src/keyboard.c (record_char): Don't record in 'recent_keys'
	events that come from executing keyboard macros.  (Bug#22674)

2016-02-15  Eli Zaretskii  <eliz@gnu.org>

	Fix wording in a doc-view.el comment

	* lisp/doc-view.el (doc-view--current-cache-dir): Don't use
	"illegal" for something that is not against the law.

2016-02-15  Paul Eggert  <eggert@cs.ucla.edu>

	CONTRIBUTE cleanups and updates

	* CONTRIBUTE: Mention URLs and info nodes more consistently,
	avoiding possibly-confusing punctuation adjacent to a URL, and
	giving full shell commands for 'info'.  Start with a brief but
	complete how-to, for people who want to get started right away.
	Then briefly discuss how to join the development process in the
	typical order.  Omit needless words.  Update some of the
	now-obsolete file names, info node names, and quoting styles.
	Better document emacs-NN branches and how they are merged.
	* admin/notes/git-workflow: Change emacs-24 to emacs-25,
	and trunk to master.  This file still needs work.

2016-02-14  Paul Eggert  <eggert@cs.ucla.edu>

	Port USE_STACK_LISP_OBJECTS fix to Clang

	* src/lisp.h (USE_STACK_LISP_OBJECTS): Default to false for Clang.
	Recent versions of Clang claim to be GCC 4.2.1 but do not have
	the GCC bug.

2016-02-14  Paul Eggert  <eggert@cs.ucla.edu>

	Port to x86 GCC 4.3.1 and earlier

	This tries to port to x86 FreeBSD 9, where Emacs dumps core (Bug#22065).
	* src/lisp.h (USE_STACK_LISP_OBJECTS): Default to false
	for GCC 4.3.1 and earlier.

2016-02-14  Eli Zaretskii  <eliz@gnu.org>

	Fix point movement under 'scroll-conservatively'

	* src/xdisp.c (redisplay_window): Correct a typo in computing the
	effective number of text lines in a window.  (Bug#22637)

2016-02-14  Thomas Plass  <thomas.plass@arcor.de>

	Replace colon in file name (not legal on Windows)

	* lisp/doc-view.el (doc-view--current-cache-dir): Replace colon in file
	name (not legal on Windows). [tiny change]

2016-02-14  Eli Zaretskii  <eliz@gnu.org>

	Fix a typo in edt.texi

	* doc/misc/edt.texi: Fix a typo in an email address.  Reported by
	"Herbert J. Skuhra" <herbert@mailbox.org>.

2016-02-14  Eli Zaretskii  <eliz@gnu.org>

	Make 'mmap_realloc' on MS-Windows more reliable

	* src/w32heap.c (mmap_alloc): If reserving memory succeeds, but
	committing fails, return NULL.  Don't call GetLastError twice for
	the same API error.
	(mmap_realloc): Zero out MEMORY_BASIC_INFORMATION structures
	before calling VirtualQuery, to avoid using garbled values if the
	call fails.  If committing more pages from the same block fails,
	fall back on mmap_alloc + CopyMemory.  Enhance debugging printouts
	if the call to VirtualAlloc to commit more pages fails.
	(Bug#22526)

2016-02-14  Oscar Fuentes  <ofv@wanadoo.es>

	Grep alias `all' shall not match parent directory

	* lisp/progmodes/grep.el (grep-files-aliases): Don't match parent
	  directory for `all'. Fixes bug#22577

2016-02-13  Nicolas Petton  <nicolas@petton.fr>

	Bump version to 25.0.91

	* README:
	* configure.ac:
	* msdos/sed2v2.inp: Bump version to 25.0.91.

2016-02-13  Nicolas Petton  <nicolas@petton.fr>

	* etc/AUTHORS: Update the AUTHORS file

2016-02-13  Glenn Morris  <rgm@gnu.org>

	* lisp/dired-aux.el: Require cl-lib.  (Bug#22613)

2016-02-13  Eli Zaretskii  <eliz@gnu.org>

	Index tilde characters in names of backup files

	* doc/emacs/files.texi (Backup Names): Improve indexing.
	(Bug#22625)

2016-02-13  Eli Zaretskii  <eliz@gnu.org>

	Document deprecation of hi-lock-mode's 'C-x w' bindings

	* doc/emacs/display.texi (Highlight Interactively): Deprecate the
	"C-x w" bindings of hi-lock-mode.

	* etc/NEWS: Mark the deprecation entry as documented.

2016-02-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	Announce that the `C-x w' bindings are deprecated

2016-02-13  Paul Eggert  <eggert@cs.ucla.edu>

	Suppress GNUstep hardening

	Fedora 23 normally hardens GNUstep applications, which causes
	‘./configure --with-ns’ to break Emacs’s funky way of undumping.
	Fix this by eliding the hardening options (Bug#22518).
	* src/Makefile.in (LIBS_GNUSTEP): Omit options like
	‘-specs=/usr/lib/rpm/redhat/redhat-hardened-ld’.
	(GNU_OBJC_CFLAGS): Omit options like
	‘-specs=/usr/lib/rpm/redhat/redhat-hardened-cc1’.

2016-02-12  Eli Zaretskii  <eliz@gnu.org>

	Fix redisplay after a large insertion

	* src/xdisp.c (redisplay_internal): Don't accept the results of
	"optimization 3" if the cursor ends up in a partially visible
	glyph row.  (Bug22637)

2016-02-12  Andreas Schwab  <schwab@linux-m68k.org>

	Revert "Fix gnus-group-get-new-news-this-group on group with closed server"

	This reverts commit 9dc77e37aa84c6df9b3ddb4609f3c09201b0580e.

		* lisp/gnus/nnimap.el (nnimap-change-group): Revert last
		change.  (Bug#22634)

2016-02-11  Paul Eggert  <eggert@cs.ucla.edu>

	* lib-src/make-docfile.c: Include stdarg.h.

2016-02-11  Alan Mackenzie  <acm@muc.de>

